/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Work Team
version 1.0

This is the class for showing the results of the simulations.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class About extends JFrame {

  JPanel contentPane;
  JScrollPane Scrl_Principal = new JScrollPane();
  JTextArea Txt_Datos = new JTextArea();
  JButton But_Cerrar = new JButton();

  /**Construct the frame*/
  public About() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(About.class.getResource("Open.gif")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    this.setResizable(false);
    this.setSize(new Dimension(387, 408));
    this.setTitle("About....");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Scrl_Principal.setBounds(new Rectangle(11, 10, 364, 327));
    Txt_Datos.setText("\n   ***************************************************************** \n");
    Txt_Datos.setText(Txt_Datos.getText() + "    This is Multi-Agent System to Simulate Human \n");
    Txt_Datos.setText(Txt_Datos.getText() + "    Behaviour within a Work Team. \n");
    Txt_Datos.setText(Txt_Datos.getText() + "    Version 1.0.0 \n\n");
    Txt_Datos.setText(Txt_Datos.getText() + "                             Using JADE \n");
    Txt_Datos.setText(Txt_Datos.getText() + "           The Java Agent DEvelopment Framework \n");
    Txt_Datos.setText(Txt_Datos.getText() + "                                 Ver. 3.6 \n\n");
    Txt_Datos.setText(Txt_Datos.getText() + "                             Using JESS \n");
    Txt_Datos.setText(Txt_Datos.getText() + "           The Rule Engine for the Java Platform \n");
    Txt_Datos.setText(Txt_Datos.getText() + "                                 Ver. 7.1 \n\n");
    Txt_Datos.setText(Txt_Datos.getText() + "                             Using FuzzyJ \n");
        Txt_Datos.setText(Txt_Datos.getText() + "                                 Ver. 1.10 \n\n");
    Txt_Datos.setText(Txt_Datos.getText() + "    @author: Juan C. Martinez Miranda. \n");
    Txt_Datos.setText(Txt_Datos.getText() + "                    juan.martinez.miranda@gmail.com \n");
    Txt_Datos.setText(Txt_Datos.getText() + "    Institution: Universidad Complutense de Madrid, \n");
    Txt_Datos.setText(Txt_Datos.getText() + "                     Facultad de Informtica. \n\n");
    Txt_Datos.setText(Txt_Datos.getText() + "                         WINTER 2003 \n");
    Txt_Datos.setText(Txt_Datos.getText() + "\n   ***************************************************************** \n");
    Txt_Datos.setForeground(SystemColor.activeCaption);
    Txt_Datos.setEditable(false);
    Txt_Datos.setFont(new java.awt.Font("Dialog", 1, 13));
    But_Cerrar.setText("Ok");
    But_Cerrar.setBounds(new Rectangle(149, 346, 80, 31));
    But_Cerrar.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
         But_Cerrar_mousePressed(e);
      }
    });
    contentPane.add(Scrl_Principal, null);
    contentPane.add(But_Cerrar, null);
    Scrl_Principal.getViewport().add(Txt_Datos, null);
  }

   protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }

  void But_Cerrar_mousePressed(MouseEvent e) {
      this.dispose();
  }

}