/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Work Team
version 1.0

This is the Agent Assigner that inform to all the agents when they have
to begin their tasks.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;


public class AgentAssigner extends Agent {

 Vector Terminadas = new Vector(1, 1);
 Vector ControlAsignados = new Vector(1,1);  // NUEVA *****
 int Simulations = 0;

  protected void setup() {

     DFAgentDescription dfd = new DFAgentDescription();
     ServiceDescription sd = new ServiceDescription();
     sd.setName(getName());
     sd.setType("ORGANIZER");
     dfd.setName(getAID());
     dfd.addServices(sd);
     try {
          DFService.register(this,dfd);
    	 } catch (FIPAException e) {
      	System.err.println(getLocalName()+" registration with DF unsucceeded. Reason: "+e.getMessage());
      	doDelete();
    	}

    addBehaviour(new CyclicBehaviour(this) {

    public void action() {

    Tarea T, T2;
    Vector Tasks, Assigned, Siguiente;
    int i, k, l;

   try { AID Counter = new AID("COUNTER", AID.ISLOCALNAME);
         ACLMessage MsgReq = receive(MessageTemplate.MatchPerformative(ACLMessage.REQUEST));
         if (MsgReq != null)
         { ControlAsignados.removeAllElements();
           Tasks = (Vector) Principal.getGlobalTasks(); //InTasks.readObject();
           for (int tam=0; tam<Tasks.size(); tam++)
             { T = (Tarea) Tasks.get(tam);
               T.restartParameters();
             }
           Principal.setGlobalTasks(Tasks);
           Simulations ++;
           T = (Tarea) Tasks.get(0);
           Assigned = (Vector) T.MuestraAgentesAsignados();

           Asignados TablaAsignaciones = new Asignados(T.getID());  //
           TablaAsignaciones.NumAsignados = Assigned.size();        //   NUEVA
           ControlAsignados.addElement(TablaAsignaciones);          //
           Integer AuxNumberSimulations = new Integer(Simulations);
           for(int j=0; j<Assigned.size(); j++)
             { ACLMessage msg2 = new ACLMessage(ACLMessage.REQUEST);  // ENVIA EL REQUEST A TODOS LOS AGENTES ASIGNADOS
               msg2.setSender(getAID());                             // A LA PRIMER TAREA
               msg2.addReceiver(new AID(Assigned.get(j).toString(), AID.ISLOCALNAME));
               msg2.setConversationId(AuxNumberSimulations.toString());
               msg2.setContent(T.getName());
               send(msg2);
             }
           System.out.println(" ");
           System.out.println("----> PROJECT START...");
           Progress.Lbl_Progreso.setText("----> PROJECT START...");
         }
         ACLMessage MsgInf = receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
         if (MsgInf != null)
            if (MsgInf.getContent().equals("FIN"))
                 Muere();
            else
            {	System.out.println("ASSIGNER RECIBE " + MsgInf.getContent() + " DE " + MsgInf.getSender().getLocalName());
            	Tasks = Principal.getGlobalTasks(); //(Vector)InTasks.readObject();
            	Integer IdTarea = new Integer(MsgInf.getContent());
           		for(int w=0; w<ControlAsignados.size(); w++)  // FOR PARA OBTENER LAS TAREAS ASIGNADAS DEL VECTOR DE ASIGNADAS
           		{  	Asignados TempAssigns = (Asignados) ControlAsignados.get(w);
           			if (TempAssigns.IDTarea == IdTarea.intValue())
            		{ 	TempAssigns.Realizados ++;
                     	ControlAsignados.set(w, TempAssigns);
            		}
            		if (TempAssigns.Realizados == TempAssigns.NumAsignados) // ENVIAR MENSAJE DE TAREA TERMINADA
            		{  ControlAsignados.removeElementAt(w);  // NUEVA
            		   Terminadas.addElement(IdTarea);
            		   Tarea Ts = (Tarea) Tasks.get(IdTarea - 1);
            		   System.out.println(" ");
            		   System.out.println("Terminada la tarea: " + Ts.getName() + " con duracin de: " + Ts.getFinishPercent() + " y calidad de: " + Ts.getQuality());
            		   System.out.println(" ");
                     
            		if (Ts.MuestraAgentesAsignados().size() > 1)
            			for (int j=0; j<Ts.MuestraAgentesAsignados().size(); j++){
            			   ACLMessage msgInformTskFinish = new ACLMessage(ACLMessage.INFORM);
            			   msgInformTskFinish.setSender(getAID());
            			   msgInformTskFinish.addReceiver(new AID(Ts.MuestraAgentesAsignados().get(j).toString(), AID.ISLOCALNAME));
            			   msgInformTskFinish.setContent(Ts.getName());
            			   msgInformTskFinish.setConversationId(Integer.valueOf(Simulations).toString());
            			   send(msgInformTskFinish);
            			}
            		if (Tasks.size() == Terminadas.size())  // INICIO CONDICION DE PROYECTO TERMINADO
            		{  System.out.println("***** COMPLETE SIMULATION NUMBER: " + Simulations + " *****");
                       System.out.println(" ");
                       Progress.Lbl_Numero.setText("Simulation Number: " + Simulations);
                       ACLMessage msg2 = new ACLMessage(ACLMessage.INFORM);
                       msg2.setSender(getAID());
                       msg2.addReceiver(new AID("COUNTER", AID.ISLOCALNAME));
                       msg2.setContent("TERMINADA");
                       send(msg2);
                       Terminadas.clear();
                       LlenaResults(Simulations);  // METODO PARA GUARDAR EL RESULTADO DE LAS TAREAS
                     } // FIN CONDICION DE PROYECTO TERMINADO
                     else
                     { i = IdTarea.intValue();
                       l = 0;
                       T = (Tarea) Tasks.get(l);
                       while (T.getID() != i)
                       {l++;
                        T = (Tarea) Tasks.get(l);
                       }
                       Siguiente = (Vector) T.MuestraPrecedencias();
                       for(int j=0; j<Siguiente.size(); j++) // FOR PARA BUSCAR TODAS LAS TAREAS SIGUIENTES
                       { Integer IdSiguiente = new Integer(Siguiente.get(j).toString());
                         k = IdSiguiente.intValue();
                         l = 0;
                         T2 = (Tarea) Tasks.get(l);
                         while (T2.getID() != k)
                         {l++;
                          T2 = (Tarea) Tasks.get(l);
                         }
                         if (Busca_Anteriores(T2))  // BUSQUEDA DE TAREAS ANTERIORES TERMINADAS
                         { Assigned = (Vector) T2.MuestraAgentesAsignados();
                           Asignados TablaAsignaciones = new Asignados(T2.getID());   //
                           TablaAsignaciones.NumAsignados = Assigned.size();          //
                           ControlAsignados.addElement(TablaAsignaciones);            //  NUEVA
                           Integer AuxNumberSimulations = new Integer(Simulations);

                           for(int m=0; m<Assigned.size(); m++)  // FOR PARA ENVIAR MENSAJE A TODOS LOS RESPONSABLES DE LA TAREA
                           { ACLMessage msg2 = new ACLMessage(ACLMessage.REQUEST);
                             msg2.setSender(getAID());
                             msg2.addReceiver(new AID(Assigned.get(m).toString(), AID.ISLOCALNAME));
                             msg2.setContent(T2.getName());
                             msg2.setConversationId(AuxNumberSimulations.toString());
                             send(msg2);
                             System.out.println(" ASSIGNER ENVIA " + msg2.getContent() + " A " +  Assigned.get(m).toString());
                           } // FIN FOR PARA ENVIAR MENSAJE A TODOS LOS RESPONSABLES DE LA TAREA
                         }  // FIN BUSQUEDA DE TAREAS ANTERIORES TERMINADAS
                       } // FIN FOR PARA BUSCAR TODAS LAS TAREAS SIGUIENTES
                     }  // FIN ELSE FIN DE PROYECTO
                  } // FIN DE ENVIAR MENSAJE DE TAREA TERMINADA             ********  NUEVA ******
              } // FIN FOR DE BUSCAR EN VECTOR DE CONTROL DE TERMINADAS     ********  NUEVA ******
            } // FIN DE RECIBIR MENSAJE          							********  NUEVA ******
         else // if no message is arrived, block the behaviour
           { block();
             System.out.println("ESTOY BLOQUEADO: ");
           }
    }
     catch (IOException ioe){ System.out.println("ERROR EN EL ASIGNADOR " + ioe); }
     catch (ClassNotFoundException cnfe){ System.out.println("ERROR POR LAS TAREAS" + cnfe); }
   }
  });
 }// **********FIN SETUP*******


 private void LlenaResults(int Sims) throws IOException, ClassNotFoundException{

    /* if (Principal.Bloqueo == 1)
        while (Principal.Bloqueo == 1)
         { }
     Principal.Bloqueo = 1;*/
     //ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(Principal.FileTasks));
     Vector Tsks = Principal.getGlobalTasks(); //(Vector)InTasks.readObject();
     //InTasks.close();
     Tarea T;
     AuxResults AR;
     for (int tam=0; tam<Tsks.size(); tam++)
     { T = (Tarea) Tsks.get(tam);
       AR = new AuxResults(Sims,T.getName(),T.getQuality(),T.getFinishPercent(), 0, 0, 0, 0);
       Results.ResTasks.addElement(AR);
     }
     //Principal.Bloqueo = 0;
 }

 private boolean Busca_Anteriores(Tarea T){

  Vector Anters;
  int cont, index;
  Integer Anterior, Hecha;

    Anters = (Vector) T.MuestraAnteriores();
    cont = 0;
    for(int i=0; i<Anters.size(); i++)
     {Anterior = new Integer(Anters.get(i).toString());
      index = 0;
      Hecha = new Integer(Terminadas.get(index).toString());
      while((Anterior.intValue() != Hecha.intValue()) && (index < Terminadas.size()))
        { index ++;
          if (index < Terminadas.size())
           Hecha = new Integer(Terminadas.get(index).toString());
        }
      if (index < Terminadas.size())
        cont ++;
     }
     if (cont == Anters.size())
       return true;
     else
       return false;
 }

  private void Muere(){

     try {
          DFService.deregister(this);
         }
     catch (FIPAException e) {
      	System.err.println(getLocalName()+" unregistration with DF unsucceeded. Reason: "+e.getMessage()); }
     doDelete();
 }
}
