/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the Agent Counter that inform to the Agent Assigner about the number
of simulations that it has to make.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/

import java.lang.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;
import jade.wrapper.AgentContainer;
import jade.wrapper.AgentController;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;


public class AgentCounter extends Agent {

  int Limite, Contador = 0;
  int value, Cuenta = 0;
  int ContValue = 0;
  Progress frame = new Progress();


  protected void setup() {


  addBehaviour(new SimpleBehaviour(this) {

     private boolean finished = false;

       public void action() {

      try{
          String Number = JOptionPane.showInputDialog(null, "Number of simulations: ", "ASSIGNER AGENT", JOptionPane.QUESTION_MESSAGE);
          if (Number != null)
          { Integer Times = new Integer(Number);
            Limite = Times.intValue();
            if (Limite > 100)
             { Cuenta = Math.round(Limite / 100);
               value = 1;
             }
            else
               value = Math.round(100 / Limite);
            if (Cuenta != 1)
              ContValue ++;
            ACLMessage msg = new ACLMessage(ACLMessage.REQUEST);
            msg.setSender(getAID());
            msg.addReceiver(new AID("ASSIGNER", AID.ISLOCALNAME));
            msg.setContent("SIMULA");
            send(msg);
            Contador ++;
            finished = true;

            boolean packFrame = false; // OPEN THE PROGRESS BAR WINDOW
            if (packFrame) {
               frame.pack();
            }
            else {
              frame.validate();
            }
            //Center the Progress Bar window
            Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
            Dimension frameSize = frame.getSize();
            if (frameSize.height > screenSize.height) {
              frameSize.height = screenSize.height;
            }
            if (frameSize.width > screenSize.width) {
               frameSize.width = screenSize.width;
            }
            frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
            frame.setResizable(false);
            frame.setVisible(true);  // END SHOW PROGRESS BAR WINDOW
          }
          else
          { finished = true;
            ACLMessage msg2 = new ACLMessage(ACLMessage.INFORM);
            msg2.setSender(getAID());
            msg2.addReceiver(new AID("ASSIGNER", AID.ISLOCALNAME));
            msg2.setContent("FIN");
            send(msg2);
            doDelete();
          }
        }catch (Exception e){ System.out.println("ERROR EN EL AGENT COUNTER" + e); }
     }

     public boolean done(){
        return finished;
      }
    });

    addBehaviour(new CyclicBehaviour(this) {

    public void action() {

     try { ACLMessage msg = receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
           if (msg != null)
           { if (msg.getContent().equals("TERMINADA"))
               if (Contador < Limite)
                {ContValue ++;
                 DFAgentDescription dad = new DFAgentDescription();
                 DFAgentDescription dad2[];
                 ServiceDescription sd = new ServiceDescription();
                 sd.setType("PROJECT MANAGER");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("COORDINATOR");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("SPECIALIST Sr.");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("SPECIALIST Jr.");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("TECHNICIAN");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("ASSISTANT");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setContent("INICIA");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT COUNTER AL RECIBIR EL MENSAJE: " + e);}

                 ACLMessage msg2 = new ACLMessage(ACLMessage.REQUEST);
                 msg2.setSender(getAID());
                 msg2.addReceiver(new AID("ASSIGNER", AID.ISLOCALNAME));
                 msg2.setContent("SIMULA");
                 send(msg2);

                 Contador++;
                 if (Cuenta != 0)
                   { if (ContValue == Cuenta)
                     { frame.Incrementa(value);
                       ContValue = 0;
                     }
                   }
                 else
                   frame.Incrementa(value);
                }
               else
               { ACLMessage msg2 = new ACLMessage(ACLMessage.INFORM);
                 msg2.setSender(getAID());
                 msg2.addReceiver(new AID("ASSIGNER", AID.ISLOCALNAME));
                 msg2.setContent("FIN");
                 send(msg2);
                 System.out.println(" ");
                 System.out.println("&&&&&&&&&&&& SIMULATIONS COMPLETES &&&&&&&&&&&&&&");
                 frame.Incrementa(100);
                 try {
                	 Object[] ResulterAgentArguments = new Object[1];
                	 ResulterAgentArguments[0] = Limite;
                	 AgentContainer ac = getContainerController();
                	 AgentController agc = ac.createNewAgent("RESULTER", "AgentResulter", ResulterAgentArguments);
                	 agc.start();
                 
                	 //AgentResulter Resulter = new AgentResulter(Limite); // CREA EL AGENTE DE RESULTADOS
                	 //Resulter.doStart("RESULTER");
                	 doDelete();
                 } catch (Exception ce) {ce.printStackTrace();}
               }
           }
           else // if no message is arrived, block the behaviour
              block();
    }
     catch (Exception e){ System.out.println("ERROR EN EL AGENT COUNTER " + e); }
   }
  });

  }// **********FIN SETUP*******

}
