/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the Agent Resoulter that request to all the workers agents to show
their simulations results.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.lang.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.*;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;



public class AgentResulter extends Agent {

  int Simulations = 0;
  int Contador = 1;
  int AgentesExistentes = 0;
  int Cuenta = 0;
  int value, ContValue = 0;
  Progress frame = new Progress();

  /*public AgentResulter (int Sim){

     this.Simulations = Sim;

  }*/

  protected void setup() {
	Object[] Arguments = this.getArguments();
	this.Simulations = Integer.parseInt(Arguments[0].toString());
	
    addBehaviour(new SimpleBehaviour(this) {

    private boolean finished = false;

    public void action() {

      try {  System.out.println("SOY EL AGENTRESULTER Y EL NUMERO DE SIMULACIONES ES: " + Simulations);
             Escribe(Contador);
             if (Simulations > 100)
             { Cuenta = Math.round(Simulations / 100);
               value = 1;
             }
             else
               value = Math.round(100 / Simulations);
             if (Cuenta != 1)
               ContValue ++;
             IniciaProgress();
             Integer AuxCont = new Integer(Contador);
             DFAgentDescription dad = new DFAgentDescription();
             DFAgentDescription dad2[];
             Agentwrk Ad;
             ServiceDescription sd = new ServiceDescription();
             sd.setType("PROJECT MANAGER");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

             sd.setType("COORDINATOR");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

             sd.setType("SPECIALIST Sr.");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

             sd.setType("SPECIALIST Jr.");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

             sd.setType("TECHNICIAN");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

             sd.setType("ASSISTANT");
             dad.addServices(sd);
             try {
                  dad2 = DFService.search(myAgent,dad);
                  AgentesExistentes = AgentesExistentes + dad2.length;
                  for (int z = 0; z<dad2.length; z++)
                  { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                    msg3.setSender(getAID());
                    msg3.addReceiver(dad2[z].getName());
                    msg3.setConversationId(AuxCont.toString());
                    msg3.setContent("ESCRIBE");
                    send(msg3);
                  }
                 }
             catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}
           finished = true;
     } // FIN TRY
     catch (Exception e){ System.out.println("ERROR EN EL AGENT RESULTER " + e); }
   }

   public boolean done(){
        return finished;
   } });

   addBehaviour(new CyclicBehaviour(this){

    public void action() {

     try { ACLMessage msg = receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
           if (msg != null)
           { if (msg.getContent().equals("ESCRITO"))
               AgentesExistentes --;
             if (Contador == Simulations)
               { frame.Incrementa(100);
                 JOptionPane.showMessageDialog(null, "Simulations Completes.", "Information", JOptionPane.INFORMATION_MESSAGE);
                 doDelete();
               }
             if (AgentesExistentes == 0 && Simulations != 1)
               { Contador ++;
                 ContValue ++;
                 Escribe(Contador);
                 if (Cuenta != 0)
                  { if (ContValue == Cuenta)
                     { frame.Incrementa(value);
                       ContValue = 0;
                     }
                  }
                 else
                    frame.Incrementa(value);
                 Integer AuxCont = new Integer(Contador);
                 DFAgentDescription dad = new DFAgentDescription();
                 DFAgentDescription dad2[];
                 Agentwrk Ad;
                 ServiceDescription sd = new ServiceDescription();

                 sd.setType("PROJECT MANAGER");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("COORDINATOR");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("SPECIALIST Sr.");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("SPECIALIST Jr.");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("TECHNICIAN");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN AGENT RESULTER AL RECIBIR EL MENSAJE: " + e);}

                 sd.setType("ASSISTANT");
                 dad.addServices(sd);
                 try {
                      dad2 = DFService.search(myAgent,dad);
                      AgentesExistentes = AgentesExistentes + dad2.length;
                      for (int z = 0; z<dad2.length; z++)
                      { ACLMessage msg3 = new ACLMessage(ACLMessage.REQUEST);
                        msg3.setSender(getAID());
                        msg3.addReceiver(dad2[z].getName());
                        msg3.setConversationId(AuxCont.toString());
                        msg3.setContent("ESCRIBE");
                        send(msg3);
                      }
                     }
                 catch (FIPAException e) {System.out.println("ERROR EN EL AGENT RESULTER: " + e);}
                 System.out.println("ESCRIBIENDO " + Contador + " VECES.");
                 frame.Lbl_Numero.setText("WRITING RESULTS OF SIMULATION: " + Contador);
               } // FIN TERMINARON TODOS LOS AGENTES DE ESCRIBIR SUS RESULTADOS
           }
           else // if no message is arrived, block the behaviour
              block();
    }
     catch (Exception e){ System.out.println("ERROR EN EL AGENT RESULTER" + e); }
   }
  });
 }// **********FIN SETUP*******


private void Escribe(int Sim) {

    /*if (Principal.Bloqueo == 1)
     while (Principal.Bloqueo == 1)
     { }

    Principal.Bloqueo = 1;*/
       Results.Txt_Results.append("\n  ********************  SIMULATION  " + Sim + " *********************\n");
    //Principal.Bloqueo = 0;
  }

private void IniciaProgress(){

   boolean packFrame = false; // OPEN THE PROGRESS BAR WINDOW

     if (packFrame)
         frame.pack();
     else
         frame.validate();
          //Center the Progress Bar window
     Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
     Dimension frameSize = frame.getSize();
     if (frameSize.height > screenSize.height)
        frameSize.height = screenSize.height;
     if (frameSize.width > screenSize.width)
        frameSize.width = screenSize.width;
     frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
     frame.setResizable(false);
     frame.Prg_Progreso.setValue(0);
     frame.Lbl_Numero.setText("WRITING RESULTS OF SIMULATION: " + Contador);
     frame.setVisible(true);  // END SHOW PROGRESS BAR WINDOW

  }

}
