/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the Agent base class for all the agents involved.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.lang.*;
import java.util.*;
import java.io.*;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;



  public class Agentwrk extends Agent implements Serializable {

	private static int AGENT_TYPE = 0;
	private static int AGENT_INTROVERTED = 1;
	private static int AGENT_WORKALONE = 2;
	private static int AGENT_CREATIVITY = 3;
	private static int AGENT_EXPERIENCE = 4;
	private static int AGENT_DESIRE = 5;
	private static int AGENT_INTEREST = 6;
	private static int AGENT_DISGUST = 7;
	private static int AGENT_ANXIETY = 8;
	private static int AGENT_STRESS = 9;
	private static int AGENT_DRIVER = 10;
	private static int AGENT_INFLUENCE = 11;
	private static int AGENT_STEADINESS = 12;
	private static int AGENT_COMPLIANCE = 13;
	private static int AGENT_PERSONALITY = 14;  
	  
    int Type;
    String Tp;
    int IntExt;
    int AloneTeam;
    int Creativity;
    int Experience;
    int Desire;
    int Interest;
    int Disgust;
    int Anxiety;
    int Stress;
    int Personality;
    int Drive;
    int Influence;
    int Stainess;
    int Compliance;
    HashMap<String, Double> trustValues = new HashMap<String, Double>();  // <LocalNameOfTeammate, LevelOfTrust>
    HashMap<String, Double> trustTendencyValues = new HashMap<String, Double>();  // <LocalNameOfTeammate, LevelOfTrust>

   /*public Agentwrk(String T){

         super();
         this.Tp = T;

    }*/

    public double getTrustLevel(String teammateName){
    	
    	return trustValues.get(teammateName).doubleValue();
    }
    
    public void insertNewInteraction(String teammateName, Double trustLevel){
    	
    	trustValues.put(teammateName, trustLevel);
    }
    
    public HashMap<String, Double> getInteractionHistory(){
    	
    	return trustValues;
    }
    
    public void clearTrustValues(){
    	
    	trustValues.clear();
    }
    
    public boolean hasCurrentTrustLevel(String teammateName){
    	
    	return trustValues.containsKey(teammateName);
    }
    
    public boolean hasPreviouslyInteracted(String teammateName){
    	
    	return trustTendencyValues.containsKey(teammateName);
    }
    
    public double getTrustTendencyLevel(String teammateName){
    	
    	try {
    		return trustTendencyValues.get(teammateName).doubleValue();
    	} catch(NullPointerException npe) {return 0.0;} 
    }
    
    public void insertNewTrustTendencyValue(String teammateName, Double trustLevel){
    	
    	trustTendencyValues.put(teammateName, trustLevel);
    }
    
    public HashMap<String, Double> getTrustTendencyValues(){
    	
    	return trustTendencyValues;
    }
    
    public void clearTrustTendencyValues(){
    	
    	trustTendencyValues.clear();
    }
    
    public void setType(String T){

        if (T == "PROJECT MANAGER")
          this.Type = 6;
        else
           if (T == "COORDINATOR")
             this.Type = 5;
           else
             if (T == "SPECIALIST Sr.")
               this.Type = 4;
             else
               if (T == "SPECIALIST Jr.")
                 this.Type = 3;
               else
                 if (T == "TECHNICIAN")
                   this.Type = 2;
                 else
                   this.Type = 1;
    }

    public void setIntroverted(int IE){

       this.IntExt = IE;

    }

    public void setAlone(int AT){

       this.AloneTeam = AT;

    }

    public void setCreativity(int C){

       this.Creativity = C;
    }

    public void setExperience(int E){

       this.Experience = E;
    }

    public void setDesire(int D){

       this.Desire = D;
    }

    public void setInterest(int I){

       this.Interest = I;
    }

    public void setDisgust(int Dis){

       this.Disgust = Dis;
    }

    public void setAnxiety(int A){

       this.Anxiety = A;
    }

    public void setStress(int S){

       this.Stress = S;
    }

    public void setDrive(int Dr){

           this.Drive = Dr;
    }

    public void setInfluence(int Infl){

       this.Influence = Infl;
    }

    public void setStainess(int Sts){

       this.Stainess = Sts;
    }

    public void setCompliance(int Cmpl){

       this.Compliance = Cmpl;
    }

    public void setPersonality(String Pty){

      if (Pty == "Analytical")
          this.Personality = 4;
        else
           if (Pty == "Driver")
             this.Personality = 3;
           else
             if (Pty == "Expressive")
               this.Personality = 2;
             else
               this.Personality = 1;
    }

    public int getIndexType(){

       return this.Type;
    }

    public String getType(){

      if (this.Type == 6)
          return "PROJECT MANAGER";
        else
           if (this.Type == 5)
             return "COORDINATOR";
           else
             if (this.Type == 4)
               return "SPECIALIST Sr.";
             else
               if (this.Type == 3)
                 return "SPECIALIST Jr.";
               else
                 if (this.Type == 2)
                   return "TECHNICIAN";
                 else
                   return "ASSISTANT";
    }

    public int getIntroverted(){

       return this.IntExt;
    }

    public int getAlone(){

       return this.AloneTeam;

    }

    public int getCreativity(){

       return this.Creativity;
    }

    public int getExperience(){

       return this.Experience;
    }

    public int getDesire(){

       return this.Desire;
    }

    public int getInterest(){

       return this.Interest;
    }

    public int getDisgust(){

       return this.Disgust;
    }

    public int getAnxiety(){

       return this.Anxiety;
    }

    public int getStress(){

       return this.Stress;
    }

    public int getDrive(){

       return this.Drive;
    }

    public int getInfluence(){

       return this.Influence;
    }

    public int getStainess(){

       return this.Stainess;
    }

    public int getCompliance(){

       return this.Compliance;
    }

    public int getIndexPersonality(){

       return this.Personality;
    }

    public String getPersonality(){

      if (this.Personality == 4)
          return "Analytical";
        else
           if (this.Personality == 3)
             return "Driver";
           else
             if (this.Personality == 2)
               return "Expressive";
             else
               return "Amiable";
    }

    protected void fillAgentProperties(Object[] Arguments){
    	
    	this.setType(Arguments[AGENT_TYPE].toString());
    	this.setAlone(Integer.parseInt(Arguments[AGENT_WORKALONE].toString()));
    	this.setAnxiety(Integer.parseInt(Arguments[AGENT_ANXIETY].toString()));
    	this.setCompliance(Integer.parseInt(Arguments[AGENT_COMPLIANCE].toString()));
    	this.setCreativity(Integer.parseInt(Arguments[AGENT_CREATIVITY].toString()));
    	this.setDesire(Integer.parseInt(Arguments[AGENT_DESIRE].toString()));
    	this.setDisgust(Integer.parseInt(Arguments[AGENT_DISGUST].toString()));
    	this.setDrive(Integer.parseInt(Arguments[AGENT_DRIVER].toString()));
    	this.setExperience(Integer.parseInt(Arguments[AGENT_EXPERIENCE].toString()));
    	this.setInfluence(Integer.parseInt(Arguments[AGENT_INFLUENCE].toString()));
    	this.setInterest(Integer.parseInt(Arguments[AGENT_INTEREST].toString()));
    	this.setIntroverted(Integer.parseInt(Arguments[AGENT_INTROVERTED].toString()));
    	this.setPersonality(Arguments[AGENT_PERSONALITY].toString());
    	this.setStainess(Integer.parseInt(Arguments[AGENT_STEADINESS].toString()));
    	this.setStress(Integer.parseInt(Arguments[AGENT_STRESS].toString()));
    }
    
   protected void setup() {

    	/** Registration with the DF */
	    Principal.Agentes2.addElement(this);
        Object[] Ar = this.getArguments();
        fillAgentProperties(Ar);
        DFAgentDescription dfd = new DFAgentDescription();
    	ServiceDescription sd = new ServiceDescription();
    	sd.setName(getName());
        sd.setType(getType());
    	dfd.setName(getAID());
    	dfd.addServices(sd);
    	try {
      	   DFService.register(this,dfd);
    	    }
      catch (FIPAException e)
      {
        System.err.println(getLocalName()+" registration with DF unsucceeded. Reason: "+e.getMessage());
        doDelete();
      }
      addBehaviour(new AgentwrkBehaviour(this));

   } // ********FIN SETUP********

 protected void takeDown() {

   try {
         DFService.deregister(this);
       }
   catch (FIPAException e1)
      {System.err.println(getLocalName()+" unregistration with DF unsucceeded. Reason: "+e1.getMessage()); }

  }  // ********FIN TAKE DOWN ********

}