/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the Behaviour of the the Agentwrk class.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.util.*;
import java.io.*;

import jade.core.*;
import jade.core.behaviours.*;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.DFService;
import jade.domain.FIPAException;

import jess.*;

import nrc.fuzzy.*;
import nrc.fuzzy.jess.*;


public class AgentwrkBehaviour extends CyclicBehaviour{

  Agentwrk Yo;
  Tarea T;
  Vector Assigned; //, Tasks;
  int i;
  long AGBEHGACH, AGBEHDURT, AGBEHICNT, AGBEHTKQTY;
  boolean Paso = false;  // Variable auxiliar para ejecutar simulaciones con agentes ya creados.
  double initialTrustLevel, initialTrustTendencyValue = 0.0;
  Vector Resultados = new Vector(1, 1);
  Vector ResComp = new Vector(1,1);
  Vector traceTrustValues = new Vector(1,1);
  int MemDesire = -100, MemInterest = -100, MemDisgust = -100, MemAnxiety = -100, MemStrs = -100;

  public AgentwrkBehaviour(Agentwrk agent){ Yo=agent;}

  public void action() {
    if (MemDesire == -100)
      { MemDesire = Yo.getDesire();
        MemInterest = Yo.getInterest();
        MemDisgust = Yo.getDisgust();
        MemAnxiety = Yo.getAnxiety();
        MemStrs = Yo.getStress();
      }
    
    ACLMessage msgTskFinished = Yo.receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
    if (msgTskFinished != null){
    	System.out.println(Yo.getLocalName() + " Recibe INFORM de Tarea " + msgTskFinished.getContent() + " terminada.");
    	if (Configure.includeTrustModel)
    		setTrustLevel(msgTskFinished.getContent(), msgTskFinished.getConversationId());
    }
    
    ACLMessage msg = Yo.receive(MessageTemplate.MatchPerformative(ACLMessage.REQUEST));
    if (msg != null)
     if (msg.getContent().equals("INICIA"))  // INICIA EL INTERNAL STATE ORIGINAL EN
       { System.out.println(Yo.getLocalName() + " RECIBE INICIA");
    	 Yo.setDesire(MemDesire);            // CADA SIMULACION
         Yo.setInterest(MemInterest);
         Yo.setDisgust(MemDisgust);
         Yo.setAnxiety(MemAnxiety);
         Yo.setStress(MemStrs);
         Yo.clearTrustTendencyValues();
         Yo.clearTrustValues();
         initialTrustLevel = Configure.initialTrustLevel;
       }
     else
       if (msg.getContent().equals("ESCRIBE"))
        { System.out.println(Yo.getLocalName() + " WRITING RESULTS... " + Resultados.size());
          Progress.Lbl_Progreso.setText(Yo.getLocalName() + " WRITING RESULTS... ");
          Escribe(msg.getConversationId());
          ACLMessage ReplyEscribe = msg.createReply();
          ReplyEscribe.setPerformative(ACLMessage.INFORM);
          ReplyEscribe.setContent("ESCRITO");
          myAgent.send(ReplyEscribe);
          Paso = false;
          System.out.println("TT de " + Yo.getLocalName() + " --> " + Yo.getTrustTendencyValues());
          System.out.println("TRUST LEVEL de " + Yo.getLocalName() + " --> " + Yo.getInteractionHistory());
        }
       else
        { System.out.println(Yo.getLocalName() + " Recibe " + msg.getContent());
         i = 0;
         T = (Tarea) Principal.getGlobalTasks().get(i);  //Tasks.get(i);
         while (!T.getName().equals(msg.getContent()))
         { i++;
           T = (Tarea) Principal.getGlobalTasks().get(i); //Tasks.get(i);
         }
         Integer Sims = new Integer(msg.getConversationId());  // ESTO ES PARA LIMPIAR
         if (Sims.intValue() == 1 && !Paso)                    // LAS VARIABLES DEL AGENTE
           { Resultados.removeAllElements();                   // QUE ESTAN YA CREADOS
             ResComp.removeAllElements();                      // Y SE PIDE OTRA SIMULACION
             Paso = true;
             Yo.setDesire(MemDesire);
             Yo.setInterest(MemInterest);
             Yo.setDisgust(MemDisgust);
             Yo.setAnxiety(MemAnxiety);
             Yo.setStress(MemStrs);
             Yo.clearTrustTendencyValues();
             Yo.clearTrustValues();
             initialTrustLevel = Configure.initialTrustLevel;
           }
         ObtieneInternalState(T, msg.getConversationId());
         if (Configure.includeTrustModel)
        	 SetTrustTendencyValues(T, msg.getConversationId());
         GeneraComportamiento(T, msg.getConversationId());
         Integer IdTarea = new Integer(T.getID());
         ACLMessage reply = msg.createReply();
         reply.setPerformative(ACLMessage.INFORM);
         reply.setContent(IdTarea.toString());
         myAgent.send(reply);
         ActualizaInternalState(AGBEHGACH, AGBEHDURT, AGBEHICNT, AGBEHTKQTY, msg.getConversationId());
         System.out.println(Yo.getLocalName() + " ENVIA REPLY AL ASSIGNER");
         System.out.println("VECTOR CON RESULTADOS:  " + Resultados.size() + " Simulacion Numero: " + msg.getConversationId());
       }  // FIN ELSE SI EL MENSAJE RECIBIDO NO ES ESCRIBE Y NO ES INICIA --> EL MENSAJE ES EL ID DE LA TAREA A REALIZAR
   } // FIN ACTION

  
  private void setTrustLevel(String TaskName, String SimulationNumber){
	  
	  int index = 0;
	  double trustLevel = 0.0;
	  String localNameTeammate;
	  Tarea Task;
	  Vector taskTeammates;
	  
      Task = (Tarea) Principal.getGlobalTasks().get(index);  // GET THE TASK RESULTS TO UPDATE THE TRUST LEVEL
      while (!Task.getName().equalsIgnoreCase(TaskName))     // OF THE AGENT'S TEAMMATES
      { index ++;
        Task = (Tarea) Principal.getGlobalTasks().get(index);
      }
      taskTeammates = Task.MuestraAgentesAsignados();
	  for (int i=0; i<taskTeammates.size(); i++){
		  localNameTeammate = taskTeammates.get(i).toString();
		  if (! localNameTeammate.equalsIgnoreCase(Yo.getLocalName())){
			  trustLevel = getTrustLevelOfTeammate(localNameTeammate, Task);
			  if (Yo.hasCurrentTrustLevel(localNameTeammate)){
				  Yo.insertNewInteraction(localNameTeammate, Double.valueOf(Yo.getTrustLevel(localNameTeammate) + trustLevel));
				  fillTrustValuesTracing(SimulationNumber, Yo.getLocalName(), Task.getName(), localNameTeammate, Yo.getTrustLevel(localNameTeammate) + trustLevel);
			  }
			  else{
				  Yo.insertNewInteraction(localNameTeammate, Double.valueOf(initialTrustLevel + trustLevel));
				  fillTrustValuesTracing(SimulationNumber, Yo.getLocalName(), Task.getName(), localNameTeammate, initialTrustLevel + trustLevel);
			  }
		  }
	  }
  }
  
  private double getTrustLevelOfTeammate(String teammateName, Tarea Task){
	  
	  double ObtainedTrustLevel;
	  String RuleFired;
	  FuzzyRete jess;
	  FuzzyVariable FVTaskQuality, FVTaskDuration, FVTrustTendency, FVDesire, FVInterest, FVDisgust, FVAnxiety, FVStress;
	  FuzzyValue INTaskQuality, INTaskDuration, INTrustTendency, INDesire, INInterest, INDisgust, INAnxiety, INStress;
	  
	  
	  jess = new FuzzyRete();
	   try {  jess.executeCommand("(clear)");
		      jess.executeCommand("(reset)");
		      jess.executeCommand("(assert (inicio))");
		      FileReader fr = new FileReader("rules/TrustLevelRules.clp");
		      Jesp j = new Jesp(fr, jess);
			// parse and execute one construct, without printing a prompt
		      j.parse(false);
		      jess.run(1);
		      FuzzyValue.setConfineFuzzySetsToUOD(true);
		      FVDesire = (FuzzyVariable)(jess.fetch("DESIREFUZZYVARIABLE")).externalAddressValue(null);
		      FVInterest = (FuzzyVariable)(jess.fetch("INTERESTFUZZYVARIABLE")).externalAddressValue(null);
		      FVDisgust = (FuzzyVariable)(jess.fetch("DISGUSTFUZZYVARIABLE")).externalAddressValue(null);
		      FVAnxiety = (FuzzyVariable)(jess.fetch("ANXIETYFUZZYVARIABLE")).externalAddressValue(null);
		      FVStress = (FuzzyVariable)(jess.fetch("STRESSFUZZYVARIABLE")).externalAddressValue(null);
		      FVTaskQuality = (FuzzyVariable) (jess.fetch("TASKQUALITYFUZZYVARIABLE")).externalAddressValue(null);
		      FVTaskDuration = (FuzzyVariable) (jess.fetch("TASKDURATIONFUZZYVARIABLE")).externalAddressValue(null);
		      FVTrustTendency = (FuzzyVariable) (jess.fetch("TRUSTTENDENCYFUZZYVARIABLE")).externalAddressValue(null);
		      INDesire = new FuzzyValue(FVDesire, new PIFuzzySet(Integer.valueOf(Yo.getDesire()).doubleValue(), 1.0));
		      INInterest = new FuzzyValue(FVInterest, new PIFuzzySet(Integer.valueOf(Yo.getInterest()).doubleValue(), 1.0));
		      INDisgust = new FuzzyValue(FVDisgust, new PIFuzzySet(Integer.valueOf(Yo.getDisgust()).doubleValue(), 1.0));
		      INAnxiety = new FuzzyValue(FVAnxiety, new PIFuzzySet(Integer.valueOf(Yo.getAnxiety()).doubleValue(), 1.0));
		      INStress = new FuzzyValue(FVStress, new PIFuzzySet(Integer.valueOf(Yo.getStress()).doubleValue(), 1.0));
		      INTaskQuality = new FuzzyValue(FVTaskQuality, new PIFuzzySet(Integer.valueOf(Task.getQuality()).doubleValue(), 1.0));
		      INTaskDuration = new FuzzyValue(FVTaskDuration, new PIFuzzySet(Integer.valueOf(Task.getFinishPercent()).doubleValue(), 1.0));
		      INTrustTendency = new FuzzyValue(FVTrustTendency, new PIFuzzySet(Yo.getTrustTendencyLevel(teammateName), 1.0));
		      jess.store("INDES", INDesire);
		      jess.store("ININT", INInterest);
		      jess.store("INDISG", INDisgust);
		      jess.store("INANX", INAnxiety);
	          jess.store("INSTRSS", INStress);
	          jess.store("INTSKQTY", INTaskQuality);
	          jess.store("INTSKDURATION", INTaskDuration);
	          jess.store("INTT", INTrustTendency);
	          jess.executeCommand(AssertTrustConditions("INDES", "ININT", "INDISG", "INANX", "INSTRSS", "INTSKQTY", "INTSKDURATION", "INTT"));
	          jess.run();
	          ObtainedTrustLevel = jess.fetch("TRSTLEVEL").numericValue(null);
	          RuleFired = jess.fetch("RULESTHATFIRED").stringValue(null);
	          System.out.println("El agente " + Yo.getLocalName() + " dispar las reglas de Trust -- > " + RuleFired);
	          System.out.println("El agente " + Yo.getLocalName() + " obtiene un NIVEL DE CONFIANZA de -- > " + ObtainedTrustLevel + " sobre el teammate: " + teammateName);
	          return ObtainedTrustLevel;
	  
	   } catch (FuzzyException  fe){ fe.printStackTrace(); return 0.0; }
       	 catch (JessException re) { re.printStackTrace(); return 0.0; }
       	 catch (IOException io) { io.printStackTrace(); return 0.0; }
  }
	   
  public String AssertTrustConditions(String des, String intst, String disgst, String anx, String strs, String tskqty, String tskdur, String trstcy)

  {
     String     fact;
     fact = "(assert (desire (fetch " + des;
     fact = fact + ")) (interest (fetch " + intst;
     fact = fact + ")) (disgust (fetch " + disgst;
     fact = fact + ")) (anxiety (fetch " + anx;
     fact = fact + ")) (stress (fetch " + strs;
     fact = fact + ")) (taskquality (fetch " + tskqty;
     fact = fact + ")) (taskduration (fetch " + tskdur;
     fact = fact + ")) (trusttendency (fetch " + trstcy;
     fact = fact + ")))";
     return fact;
 }
  
  private void fillTrustValuesTracing(String SimulationNumber, String AgentName, String TaskName, String TeamMateName, double TrustValue){
	  
	  AuxResults trustResults = new AuxResults(Integer.valueOf(SimulationNumber).intValue(), AgentName, TaskName, TeamMateName, TrustValue);
	  traceTrustValues.addElement(trustResults);
  }

  private void SetTrustTendencyValues(Tarea Task, String Sim){
	  
	  double trustTendencyValue = 0.0;
	  Vector taskTeammates;
	  Agentwrk teamMate;
	  String localNameTeammate;
	  
	  
	  if (! TareaSolo(Task))
	  {   taskTeammates = Task.MuestraAgentesAsignados();
		  for (int i=0; i<taskTeammates.size(); i++){
			  localNameTeammate = taskTeammates.get(i).toString();
			  if (! localNameTeammate.equalsIgnoreCase(Yo.getLocalName()))
			  { if (Yo.hasCurrentTrustLevel(localNameTeammate)) //.hasPreviouslyInteracted(localNameTeammate))
				  trustTendencyValue = setTrustTendencyFirstInteraction(0, localNameTeammate);
			  	else{
			  		Yo.insertNewInteraction(localNameTeammate, Double.valueOf(initialTrustLevel));
			  		trustTendencyValue = setTrustTendencyFirstInteraction(1, "");
			  	}
			    Yo.insertNewTrustTendencyValue(localNameTeammate, trustTendencyValue);
			  }
				  //System.out.println("TEAMMATES DE " + Yo.getLocalName() + " --> " + taskTeammates.get(i));
		  }
	  }
  }
	   
   private double setTrustTendencyFirstInteraction(int firstInteraction, String teamMate){
	   
	   String RuleFired = " ";
	   double ObtainedTT = 0.0;
	   FuzzyRete jess;
	   FuzzyVariable FVDrive, FVInfluence, FVSteadiness, FVCompliance, FVDesire, FVInterest, FVDisgust, FVAnxiety, FVStress, FVTrustLevel;
	   FuzzyValue INDrive, INInfluence, INSteadiness, INCompliance, INDesire, INInterest, INDisgust, INAnxiety, INStress, INTrustLevel;
	   
	   jess = new FuzzyRete();
	   try {  jess.executeCommand("(clear)");
		      jess.executeCommand("(reset)");
		      jess.executeCommand("(assert (inicio))");
		      FileReader fr = new FileReader("rules/TrustTendencyRules.clp");
		      Jesp j = new Jesp(fr, jess);
			// parse and execute one construct, without printing a prompt
		      j.parse(false);
		      jess.run(1);
		      FuzzyValue.setConfineFuzzySetsToUOD(true);
		      FVDrive = (FuzzyVariable)(jess.fetch("DRIVEFUZZYVARIABLE")).externalAddressValue(null);
		      FVInfluence = (FuzzyVariable)(jess.fetch("INFLUENCEFUZZYVARIABLE")).externalAddressValue(null);
		      FVSteadiness = (FuzzyVariable)(jess.fetch("STEADINESSFUZZYVARIABLE")).externalAddressValue(null);
		      FVCompliance = (FuzzyVariable)(jess.fetch("COMPLIANCEFUZZYVARIABLE")).externalAddressValue(null);
		      FVDesire = (FuzzyVariable)(jess.fetch("DESIREFUZZYVARIABLE")).externalAddressValue(null);
		      FVInterest = (FuzzyVariable)(jess.fetch("INTERESTFUZZYVARIABLE")).externalAddressValue(null);
		      FVDisgust = (FuzzyVariable)(jess.fetch("DISGUSTFUZZYVARIABLE")).externalAddressValue(null);
		      FVAnxiety = (FuzzyVariable)(jess.fetch("ANXIETYFUZZYVARIABLE")).externalAddressValue(null);
		      FVStress = (FuzzyVariable)(jess.fetch("STRESSFUZZYVARIABLE")).externalAddressValue(null);
		      FVTrustLevel = (FuzzyVariable)(jess.fetch("TRUSTLEVELVARIABLE")).externalAddressValue(null); 
		      INDrive = new FuzzyValue(FVDrive, new PIFuzzySet(Integer.valueOf(Yo.getDrive()).doubleValue(), 1.0));
		      INInfluence = new FuzzyValue(FVInfluence, new PIFuzzySet(Integer.valueOf(Yo.getInfluence()).doubleValue(), 1.0));
		      INSteadiness = new FuzzyValue(FVSteadiness, new PIFuzzySet(Integer.valueOf(Yo.getStainess()).doubleValue(), 1.0));
		      INCompliance = new FuzzyValue(FVCompliance, new PIFuzzySet(Integer.valueOf(Yo.getCompliance()).doubleValue(), 1.0));
		      INDesire = new FuzzyValue(FVDesire, new PIFuzzySet(Integer.valueOf(Yo.getDesire()).doubleValue(), 1.0));
		      INInterest = new FuzzyValue(FVInterest, new PIFuzzySet(Integer.valueOf(Yo.getInterest()).doubleValue(), 1.0));
		      INDisgust = new FuzzyValue(FVDisgust, new PIFuzzySet(Integer.valueOf(Yo.getDisgust()).doubleValue(), 1.0));
		      INAnxiety = new FuzzyValue(FVAnxiety, new PIFuzzySet(Integer.valueOf(Yo.getAnxiety()).doubleValue(), 1.0));
		      INStress = new FuzzyValue(FVStress, new PIFuzzySet(Integer.valueOf(Yo.getStress()).doubleValue(), 1.0));
		      if(firstInteraction == 1)
		    	  INTrustLevel = new FuzzyValue(FVTrustLevel, new PIFuzzySet(initialTrustLevel, 1.0));
		      else
		    	  INTrustLevel = new FuzzyValue(FVTrustLevel, new PIFuzzySet(Yo.getTrustLevel(teamMate), 1.0));
		      jess.store("INDRV", INDrive);
		      jess.store("ININFL",INInfluence);
		      jess.store("INSTNSS",INSteadiness);
		      jess.store("INCOMPL",INCompliance);
		      jess.store("INDES", INDesire);
		      jess.store("ININT", INInterest);
		      jess.store("INDISG", INDisgust);
		      jess.store("INANX", INAnxiety);
	          jess.store("INSTRSS", INStress);
	          jess.store("INTRUST", INTrustLevel);
	          jess.store("FIRSTINTERACTION", new Value(firstInteraction, RU.INTEGER));
	          jess.executeCommand(AssertPersonalityEmotions("INDRV", "ININFL", "INSTNSS", "INCOMPL", "INDES", "ININT", "INDISG", "INANX", "INSTRSS", "INTRUST", "FIRSTINTERACTION"));
	          jess.run();
	          ObtainedTT = jess.fetch("TT").numericValue(null);
	          RuleFired = jess.fetch("RULESTHATFIRED").stringValue(null);
	          System.out.println("El agente " + Yo.getLocalName() + " dispar las reglas de TT -- > " + RuleFired);
	          return ObtainedTT;
	     } catch (FuzzyException  fe){ fe.printStackTrace(); return 0.0; }
	       catch (JessException re) { re.printStackTrace(); return 0.0; }
	       catch (IOException io) { io.printStackTrace(); return 0.0; }
   }
   
   public String AssertPersonalityEmotions(String drv, String infl, String stnss, String cmpl, String des, String in, String dis, String anx, String strs, String trst, String frstint)

   {
      String     fact;
      fact = "(assert (drive (fetch " + drv;
      fact = fact + ")) (influence (fetch " + infl;
      fact = fact + ")) (steadiness (fetch " + stnss;
      fact = fact + ")) (compliance (fetch " + cmpl;
      fact = fact + ")) (desire (fetch " + des;
      fact = fact + ")) (interest (fetch " + in;
      fact = fact + ")) (disgust (fetch " + dis;
      fact = fact + ")) (anxiety (fetch " + anx;
      fact = fact + ")) (stress (fetch " + strs;
      fact = fact + ")) (trustlevel (fetch " + trst;
      fact = fact + ")) (firstinteraction (fetch " + frstint;
      fact = fact + ")))";
      return fact;
  }
  
   private void ObtieneInternalState(Tarea Task, String Sim) {

      // AQUI SE OBTIENE EL ESTADO INTERNO DEL AGENTE DE ACUERDO A LOS
      // PARAMETROS DE LA TAREA ASIGNADA.

   double AddDes = 0.0, AddInter = 0.0, AddDisg = 0.0, AddAnx = 0.0, AddStrss = 0.0;
   String RuleFired = " ", TpAgent = " ", Prsty = " ";
   FuzzyRete jess;
   FuzzyVariable FVExperience, FVDuration, FVDrive, FVInfluence, FVStainess, FVCompliance, FVAloneTeam, FVIntExt, FVTaskType, FVTaskDifficult;
   FuzzyValue INExperience, INDuration, INDrive, INInfluence, INStainess, INCompliance, INAloneTeam, INIntExt, INTaskType, INTaskDifficult;

   Integer Ex = new Integer(Yo.getExperience());
   Integer Drv = new Integer(Yo.getDrive());
   Integer Infl = new Integer(Yo.getInfluence());
   Integer Stnss = new Integer(Yo.getStainess());
   Integer Compln = new Integer(Yo.getCompliance());
   Integer AloneTeam = new Integer(Yo.getAlone());
   Integer IntExt = new Integer(Yo.getIntroverted());
   Integer Dur = new Integer(Task.getAdelantoRetraso());
   Integer TskTp = new Integer(Task.getType());
   Integer TskDiff = new Integer(Task.getDifficult());
   jess = new FuzzyRete();
   try {  jess.executeCommand("(clear)");
          jess.executeCommand("(reset)");
          jess.executeCommand("(assert (inicio))");
          FileReader fr = new FileReader("rules/BehaviourRules.clp");
          Jesp j = new Jesp(fr, jess);
	// parse and execute one construct, without printing a prompt
	  j.parse(false);
          jess.run(1);
          FuzzyValue.setConfineFuzzySetsToUOD(true);
          FVExperience = (FuzzyVariable)(jess.fetch("EXPERIENCEFUZZYVARIABLE")).externalAddressValue(null);
          FVDrive = (FuzzyVariable)(jess.fetch("DRIVEFUZZYVARIABLE")).externalAddressValue(null);
          FVInfluence = (FuzzyVariable)(jess.fetch("INFLUENCEFUZZYVARIABLE")).externalAddressValue(null);
          FVStainess = (FuzzyVariable)(jess.fetch("STAINESSFUZZYVARIABLE")).externalAddressValue(null);
          FVCompliance = (FuzzyVariable)(jess.fetch("COMPLIANCEFUZZYVARIABLE")).externalAddressValue(null);
          FVAloneTeam = (FuzzyVariable)(jess.fetch("ALONETEAMFUZZYVARIABLE")).externalAddressValue(null);
          FVIntExt = (FuzzyVariable)(jess.fetch("INTEXTFUZZYVARIABLE")).externalAddressValue(null);
          FVDuration = (FuzzyVariable)(jess.fetch("DURATIONFUZZYVARIABLE")).externalAddressValue(null);
          FVTaskType = (FuzzyVariable)(jess.fetch("TASKTYPEFUZZYVARIABLE")).externalAddressValue(null);
          FVTaskDifficult = (FuzzyVariable)(jess.fetch("TASKDIFFICULTFUZZYVARIABLE")).externalAddressValue(null);
          INExperience = new FuzzyValue(FVExperience, new PIFuzzySet(Ex.doubleValue(), 1.0));
          jess.store("INEXP", INExperience);
          INDrive = new FuzzyValue(FVDrive, new PIFuzzySet(Drv.doubleValue(), 1.0));
          jess.store("INDRV", INDrive);
          INInfluence = new FuzzyValue(FVInfluence, new PIFuzzySet(Infl.doubleValue(), 1.0));
          jess.store("ININFL",INInfluence);
          INStainess = new FuzzyValue(FVStainess, new PIFuzzySet(Stnss.doubleValue(), 1.0));
          jess.store("INSTNSS",INStainess);
          INCompliance = new FuzzyValue(FVCompliance, new PIFuzzySet(Compln.doubleValue(), 1.0));
          jess.store("INCOMPL",INCompliance);
          INAloneTeam = new FuzzyValue(FVAloneTeam, new PIFuzzySet(AloneTeam.doubleValue(), 1.0));
          jess.store("INALONETEAM",INAloneTeam);
          INIntExt = new FuzzyValue(FVIntExt, new PIFuzzySet(IntExt.doubleValue(), 1.0));
          jess.store("ININTEXT",INIntExt);
          INDuration = new FuzzyValue(FVDuration, new PIFuzzySet(Dur.doubleValue(), 1.0));
          jess.store("INDUR", INDuration);
          INTaskType = new FuzzyValue(FVTaskType, new PIFuzzySet(TskTp.doubleValue(), 1.0));
          jess.store("INTASKTYPE", INTaskType);
          INTaskDifficult = new FuzzyValue(FVTaskDifficult, new PIFuzzySet(TskDiff.doubleValue(), 1.0));
          jess.store("INDIFFTASK", INTaskDifficult);
          TpAgent = Yo.getType();
          jess.store("INTYPEAGENT", new Value(TpAgent, RU.STRING));
          Prsty = Yo.getPersonality();
          jess.store("INTPRSTYAGENT", new Value(Prsty, RU.STRING));
	  /*if (Yo.getAlone())
             jess.store("INAGALONE", new Value(1, RU.INTEGER));   // 1 AGENTE PREFIERE TRABAJAR SOLO
          else
             jess.store("INAGALONE", new Value(0, RU.INTEGER));   // 0 AGENTE PREFIERE TRABAJAR EN EQUIPO */
          if (TareaSolo(Task))
            jess.store("INTASKALONE", new Value(1, RU.INTEGER));   // 1 TAREA SOLO
          else
            jess.store("INTASKALONE", new Value(0, RU.INTEGER));   // 0 TAREA EN EQUIPO
          jess.executeCommand(AssertTaskParameters("INEXP", "INDRV", "ININFL", "INSTNSS", "INCOMPL", "INDUR", "INTYPEAGENT", "INTPRSTYAGENT", "INALONETEAM", "ININTEXT", "INTASKTYPE", "INDIFFTASK", "INTASKALONE"));
          jess.run();
          AddDes = jess.fetch("SUMDESIRE").numericValue(null);
          AddInter = jess.fetch("SUMINTEREST").numericValue(null);
          AddDisg = jess.fetch("SUMDISGUST").numericValue(null);
          AddAnx = jess.fetch("SUMANXIETY").numericValue(null);
          AddStrss = jess.fetch("SUMSTRESS").numericValue(null);
          RuleFired = jess.fetch("RULESTHATFIRED").stringValue(null);
          ModificaInternalState(AddDes, AddInter, AddDisg, AddAnx, AddStrss);
          LlenaResults1(RuleFired, Yo.getLocalName(), Task, Sim);
        } catch (FuzzyException  fe)
            { System.out.println(fe);
              LlenaResults1(RuleFired, Yo.getLocalName(), Task, Sim); //, 0, 0, 0, 0, 0, 0, 0);
            }
         catch (JessException re)
            { System.out.println(re);
              LlenaResults1(RuleFired, Yo.getLocalName(), Task, Sim); //, 0, 0, 0, 0, 0, 0, 0);
            }
         catch (FileNotFoundException e) { System.out.println(e); }
  } // FIN OBTIENEINTERNALSTATE

  public String AssertTaskParameters(String exp, String drv, String infl, String stnss, String cmpl, String dur, String typag, String ptyag, String alteag, String intextag, String tpts, String difts, String alts){
    String     fact;
    fact = "(assert (experience (fetch " + exp;
    fact = fact + ")) (drive (fetch " + drv;
    fact = fact + ")) (influence (fetch " + infl;
    fact = fact + ")) (stainess (fetch " + stnss;
    fact = fact + ")) (compliance (fetch " + cmpl;
    fact = fact + ")) (advance (fetch " + dur;
    fact = fact + ")) (typeagent (fetch " + typag;
    fact = fact + ")) (personality (fetch " + ptyag;
    fact = fact + ")) (prefersalone (fetch " + alteag;
    fact = fact + ")) (introextro (fetch " + intextag;
    fact = fact + ")) (typetask (fetch " + tpts;
    fact = fact + ")) (kindoftask (fetch " + difts;
    fact = fact + ")) (aloneteam (fetch " + alts;
    fact = fact + ")))";
    return fact;
  }

   private void LlenaResults1(String Reglas, String NomA, Tarea Ts, String NSim ){ //, long ADes, long AInt, long ADis, long AAnx, long AStrs, long AQty, long ADur){

      AuxResults Res1 = new AuxResults(NomA + " Recives task " + Ts.getName() + " with delay/advance of: " +
                                       Ts.getAdelantoRetraso() + " and quality: " + Ts.getQuality() + "\n",
                                       "FIRED RULES: " + Reglas + "\n", NSim);
      Resultados.addElement(Res1);

   }

   private boolean TareaSolo(Tarea Ts) {  // Metodo para saber si una tarea se realiza en equipo o individual

   Vector AgAssig;

     AgAssig = (Vector) Ts.MuestraAgentesAsignados();
     if (AgAssig.size() > 1)
        return false;
     else
        return true;

   }

   private void GeneraComportamiento(Tarea Task, String Sim) {

      // AQUI SE GENERA EL COMPORTAMIENTO DEL AGENTE.

   double Exito, Fracaso, Final, Aleatorio;
   long DiasForTask, TaskQuality, GoalAch, ColLevel, IndivCont, Supervision;
   double Des, Inter, Disg, Anx, Strss;
   double Dv, TrustLevel = 25.0;
   int AleatEnt, includeTrustModel = 0;
   long Fin;
   String TotalResults, Results = " ";
   String RuleFired = " ";
   FuzzyRete jess;
   FuzzyVariable FVCreativity, FVExperience, FVDrive, FVInfluence, FVStainess, FVCompliance, FVDesire, FVInterest, FVDisgust, FVAnxiety, FVStress, FVTaskType, FVTaskDifficult, FVTrustLevel;
   FuzzyValue INCreativity, INExperience, INDrive, INInfluence, INStainess, INCompliance, INDesire, INInterest, INDisgust, INAnxiety, INStress, INTaskType, INTaskDifficult, INTrustLevel;
   Long TempEmts;

   Double DesV = new Double(Configure.Sv);
   Dv = DesV.doubleValue();  // Desviacion estandar para el calculo de numeros aleatorios con distribucion normal.

   Integer Creat = new Integer(Yo.getCreativity());     //   PARAMETROS DE ENTRADA:
   Integer Ex = new Integer(Yo.getExperience());        //   EXPERIENCIA, CREATIVIDAD,
   Integer Drv = new Integer(Yo.getDrive());            //   TIPO DE TAREA, LOS PARAMETROS
   Integer Infl = new Integer(Yo.getInfluence());       //   DE PERSONALIDAD CLEAVER Y EL
   Integer Stnss = new Integer(Yo.getStainess());       //   NIVEL DE CONFIANZA.
   Integer Compln = new Integer(Yo.getCompliance());    //
   Integer TskTp = new Integer(Task.getType());
   Integer TskDiff = new Integer(Task.getDifficult());
   if (Task.MuestraAgentesAsignados().size() > 1 && Configure.includeTrustModel){
	   TrustLevel = getTrustLevelAverage(Task);
	   includeTrustModel = 1;
	   System.out.println("El agente " + Yo.getLocalName() + " obtiene un NIVEL DE CONFIANZA GLOBAL DE " + TrustLevel + " en la tarea " + Task.getName());
   }
   Des = AleatorioNormal(Yo.getDesire(), Dv);         //
   TempEmts = new Long(StrictMath.round(Des));        //
   Yo.setDesire(TempEmts.intValue());                 //
   Inter = AleatorioNormal(Yo.getInterest(), Dv);     //
   TempEmts = new Long(StrictMath.round(Inter));      //   AQUI SE INTRODUCE LA ALEATORIEDAD
   Yo.setInterest(TempEmts.intValue());               //   Y LAS EMOCIONES SE MODIFICAN DE ACUERDO
   Disg = AleatorioNormal(Yo.getDisgust(), Dv);       //   A ESTOS VALORES ALEATORIOS
   TempEmts = new Long(StrictMath.round(Disg));       //
   Yo.setDisgust(TempEmts.intValue());                //
   Anx = AleatorioNormal(Yo.getAnxiety(), Dv);        //
   TempEmts = new Long(StrictMath.round(Anx));        //
   Yo.setAnxiety(TempEmts.intValue());                //
   Strss = AleatorioNormal(Yo.getStress(), Dv);       //
   TempEmts = new Long(StrictMath.round(Strss));      //
   Yo.setStress(TempEmts.intValue());                 //

   jess = new FuzzyRete();
   try {  jess.executeCommand("(clear)");
          jess.executeCommand("(reset)");
          jess.executeCommand("(assert (inicio))");
          FileReader fr = new FileReader("rules/TasksRules.clp");
          Jesp j = new Jesp(fr, jess);
          // parse and execute one construct, without printing a prompt
          j.parse(false);
          jess.run(1);
          FuzzyValue.setConfineFuzzySetsToUOD(true);
          FVCreativity = (FuzzyVariable)(jess.fetch("CREATIVITYFUZZYVARIABLE")).externalAddressValue(null);
          FVExperience = (FuzzyVariable)(jess.fetch("EXPERIENCEFUZZYVARIABLE")).externalAddressValue(null);
          FVDrive = (FuzzyVariable)(jess.fetch("DRIVEFUZZYVARIABLE")).externalAddressValue(null);
          FVInfluence = (FuzzyVariable)(jess.fetch("INFLUENCEFUZZYVARIABLE")).externalAddressValue(null);
          FVStainess = (FuzzyVariable)(jess.fetch("STAINESSFUZZYVARIABLE")).externalAddressValue(null);
          FVCompliance = (FuzzyVariable)(jess.fetch("COMPLIANCEFUZZYVARIABLE")).externalAddressValue(null);
          FVDesire = (FuzzyVariable)(jess.fetch("DESIREFUZZYVARIABLE")).externalAddressValue(null);
          FVInterest = (FuzzyVariable)(jess.fetch("INTERESTFUZZYVARIABLE")).externalAddressValue(null);
          FVDisgust = (FuzzyVariable)(jess.fetch("DISGUSTFUZZYVARIABLE")).externalAddressValue(null);
          FVAnxiety = (FuzzyVariable)(jess.fetch("ANXIETYFUZZYVARIABLE")).externalAddressValue(null);
          FVStress = (FuzzyVariable)(jess.fetch("STRESSFUZZYVARIABLE")).externalAddressValue(null);
          FVTaskType = (FuzzyVariable)(jess.fetch("TASKTYPEFUZZYVARIABLE")).externalAddressValue(null);
          FVTaskDifficult = (FuzzyVariable)(jess.fetch("TASKDIFFICULTFUZZYVARIABLE")).externalAddressValue(null);
          FVTrustLevel = (FuzzyVariable)(jess.fetch("TRUSTLEVELFUZZYVARIABLE")).externalAddressValue(null);
          INCreativity = new FuzzyValue(FVCreativity, new PIFuzzySet(Creat.doubleValue(), 1.0));
          INExperience = new FuzzyValue(FVExperience, new PIFuzzySet(Ex.doubleValue(), 1.0));
          INDrive = new FuzzyValue(FVDrive, new PIFuzzySet(Drv.doubleValue(), 1.0));
          INInfluence = new FuzzyValue(FVInfluence, new PIFuzzySet(Infl.doubleValue(), 1.0));
          INStainess = new FuzzyValue(FVStainess, new PIFuzzySet(Stnss.doubleValue(), 1.0));
          INCompliance = new FuzzyValue(FVCompliance, new PIFuzzySet(Compln.doubleValue(), 1.0));
          INDesire = new FuzzyValue(FVDesire, new PIFuzzySet(Des, 1.0));
          INInterest = new FuzzyValue(FVInterest, new PIFuzzySet(Inter, 1.0));
          INDisgust = new FuzzyValue(FVDisgust, new PIFuzzySet(Disg, 1.0));
          INAnxiety = new FuzzyValue(FVAnxiety, new PIFuzzySet(Anx, 1.0));
          INStress = new FuzzyValue(FVStress, new PIFuzzySet(Strss, 1.0));
          INTaskType = new FuzzyValue(FVTaskType, new PIFuzzySet(TskTp.doubleValue(), 1.0));
          INTaskDifficult = new FuzzyValue(FVTaskDifficult, new PIFuzzySet(TskDiff.doubleValue(), 1.0));
          INTrustLevel = new FuzzyValue(FVTrustLevel, new PIFuzzySet(TrustLevel, 1.0));
          jess.store("INCREAT", INCreativity);
          jess.store("INEXP", INExperience);
          jess.store("INDRV", INDrive);
          jess.store("ININFL",INInfluence);
          jess.store("INSTNSS",INStainess);
          jess.store("INCOMPL",INCompliance);
          jess.store("INDES", INDesire);
          jess.store("ININT", INInterest);
          jess.store("INDISG", INDisgust);
          jess.store("INANX", INAnxiety);
          jess.store("INSTRSS", INStress);
          jess.store("TASKTYPE", INTaskType);
          jess.store("TASKDIFFICULT", INTaskDifficult);
          jess.store("TRUSTLEVEL", INTrustLevel);
          jess.store("INCLUDETRUSTMODEL", new Value(includeTrustModel, RU.INTEGER));
          jess.executeCommand(AssertInternalState("INCREAT", "INEXP", "INDRV", "ININFL", "INSTNSS", "INCOMPL", "INDES", "ININT", "INDISG", "INANX", "INSTRSS", "TASKTYPE", "TASKDIFFICULT", "TRUSTLEVEL", "INCLUDETRUSTMODEL"));
          jess.run();
          DiasForTask = StrictMath.round(jess.fetch("DIASPARALATAREA").numericValue(null));
          System.out.print("******DURACION******** DE: " + Yo.getLocalName() + " en la tarea " + Task.getName());
          System.out.println(DiasForTask);

          TaskQuality = StrictMath.round(jess.fetch("CALIDADTOTAL").numericValue(null));
          /*System.out.print("******CALIDAD******** DE: " + Yo.getLocalName() + " ");
          System.out.println(TaskQuality);*/

          GoalAch = StrictMath.round(jess.fetch("METASALCANZADAS").numericValue(null));
          /*System.out.print("******CUMPLIMIENTO DE METAS******** DE: " + Yo.getLocalName() + " ");
          System.out.println(GoalAch);*/

          ColLevel = StrictMath.round(jess.fetch("COLABORACIONEQUIPO").numericValue(null));
          /*System.out.print("******COLABORACION EN EQUIPO******** DE: " + Yo.getLocalName() + " ");
          System.out.println(ColLevel);*/

          IndivCont = StrictMath.round(jess.fetch("CONTRIBUCIONINDIVIDUAL").numericValue(null));
          /*System.out.print("******CONTRIBUCION INDIVIDUAL******** DE: " + Yo.getLocalName() + " ");
          System.out.println(IndivCont);*/

          Supervision = StrictMath.round(jess.fetch("SUPERVISIONREQUERIDA").numericValue(null));
          /*System.out.print("******SUPERVISION REQUERIDA******** DE: " + Yo.getLocalName() + " ");
          System.out.println(Supervision);*/

          RuleFired = jess.fetch("RULESTHATFIRED").stringValue(null);
          //System.out.println("El agente " + Yo.getLocalName() + " disparo las REGLAS DE PERFORMANCE: " + RuleFired);
          ModificaTask(Task, DiasForTask, TaskQuality);
          LlenaResults2(RuleFired, Yo.getLocalName(), Task, Sim, DiasForTask, TaskQuality, GoalAch, ColLevel, IndivCont, Supervision);
          AGBEHGACH = GoalAch;
          AGBEHDURT = DiasForTask;
          AGBEHICNT = IndivCont;
          AGBEHTKQTY = TaskQuality;
       } catch (FuzzyException  fe)
            { System.out.println(fe);
              LlenaResults2(RuleFired, Yo.getLocalName(), Task, Sim, 0, 0, 0, 0, 0, 0);
            }
         catch (JessException re)
            { System.out.println(re);
              LlenaResults2(RuleFired, Yo.getLocalName(), Task, Sim, 0, 0, 0, 0, 0, 0);
            }
         catch (FileNotFoundException e) { System.out.println(e); }
         catch (ClassNotFoundException cnf) { System.out.println(cnf); }
         catch (IOException ioe) { System.out.println("ERROR AL MODIFICAR LA TAREA" + ioe); }
  } // FIN GENERACOMPORTAMIENTO


 public String AssertInternalState(String crt, String ex, String drv, String infl, String stnss, String cmpl, String des, String in, String dis, String anx, String strs, String tsktp, String tskdiff, String trstlvl, String incldtrst)

 {
    String     fact;
    fact = "(assert (creativity (fetch " + crt;
    fact = fact + ")) (experience (fetch " + ex;
    fact = fact + ")) (drive (fetch " + drv;
    fact = fact + ")) (influence (fetch " + infl;
    fact = fact + ")) (stainess (fetch " + stnss;
    fact = fact + ")) (compliance (fetch " + cmpl;
    fact = fact + ")) (desire (fetch " + des;
    fact = fact + ")) (interest (fetch " + in;
    fact = fact + ")) (disgust (fetch " + dis;
    fact = fact + ")) (anxiety (fetch " + anx;
    fact = fact + ")) (stress (fetch " + strs;
    fact = fact + ")) (tasktype (fetch " + tsktp;
    fact = fact + ")) (taskdifficult (fetch " + tskdiff;
    fact = fact + ")) (trustlevel (fetch " + trstlvl;
    fact = fact + ")) (includetrust (fetch " + incldtrst;
    fact = fact + ")))";
    return fact;
}

  private void LlenaResults2(String Reglas, String NomA, Tarea Ts, String NSim, long Dias, long Calidad, long Metas, long CollTeam, long IndvCont, long Supervsn)
 {

      AuxResults Res = new AuxResults(NomA + " Add to task: " + Ts.getName() + " " + Dias + " % and " + Calidad +
                                      " of quality\n Task with Delay/Advance of " + Ts.getFinishPercent() + " %, Quality " +
                                      Ts.getQuality() + " , Goals Achievement of: " + Metas + ", Team Collaboration of: " +
                                      CollTeam + ", Individual Contribution of: " + IndvCont + " and Required Supervision of: "
                                      + Supervsn + "\n", "FIRED RULES: " + Reglas + "\n\n", NSim);
      Resultados.addElement(Res);
      AuxResults CompRes = new AuxResults(NSim, NomA, Ts.getName(), Calidad, Dias, Metas, CollTeam, IndvCont, Supervsn);
      ResComp.addElement(CompRes);
 }

   private void ModificaTask(Tarea Tsk, long Dias, long Calidad) throws IOException, ClassNotFoundException {

     Vector Prec;
     Tarea ThsTsk, TskPrec;
     Integer IDTskPrec;
     Long Temp;

      Temp = new Long(Calidad);
      int inxTs = Tsk.getID();
      /*if (Principal.Bloqueo == 1)
         while (Principal.Bloqueo == 1)
         { for(int delay=0; delay<500; delay++) {}}
      Principal.Bloqueo = 1;
      ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(Principal.FileTasks));
      Tasks = (Vector)InTasks.readObject();
      InTasks.close(); */
      ThsTsk = (Tarea) Principal.getGlobalTasks().get(inxTs - 1);  //Tasks.get(inxTs - 1);
      ThsTsk.ModifyQuality(Temp.intValue());    // MODIFICA LA CALIDAD DE LA TAREA ACTUAL
      Prec = Tsk.MuestraPrecedencias();
      Temp = new Long(Dias);
      for (int k=0; k < Prec.size(); k++)
        {  IDTskPrec = (Integer) Prec.get(k);
           TskPrec = (Tarea) Principal.getGlobalTasks().get(IDTskPrec.intValue() - 1);  //Tasks.get(IDTskPrec.intValue() - 1);
           TskPrec.ModifyDuration(Temp.intValue() + Tsk.getAdelantoRetraso(), false);  // MODIFICA LA DURACION
           Principal.getGlobalTasks().setElementAt(TskPrec, IDTskPrec.intValue() - 1); // Tasks.setElementAt(TskPrec, IDTskPrec.intValue() - 1);                      // DE TODAS LAS TAREA PRECEDENTES
         }
      ThsTsk.ModifyDuration(Temp.intValue(), true);    // MODIFICA LA DURACION DE LA TAREA ACTUAL
      Principal.getGlobalTasks().setElementAt(ThsTsk, inxTs - 1);   //Tasks.setElementAt(ThsTsk, inxTs - 1);
      /*ObjectOutputStream OutTasks = new ObjectOutputStream(new FileOutputStream(Principal.FileTasks));
      OutTasks.writeObject(Tasks);
      OutTasks.close();
      //Principal.Bloqueo = 0;*/
   }

   private void ActualizaInternalState(long GoalAc, long TsDur, long AgIndCont, long TsQty, String Sim) {

      // AQUI SE ACTUALIZA EL ESTADO INTERNO DEL AGENTE DE ACUERDO
      // A LOS RESULTADOS OBTENIDOS EN LA TAREA REALIZADA.

   double AddDes = 0.0, AddInter = 0.0, AddDisg = 0.0, AddAnx = 0.0, AddStrss = 0.0;
   String RuleFired = " ", Prsty = " ";
   FuzzyRete jess;
   FuzzyVariable FVQuality, FVGoalAchievement, FVTaskDuration, FVAgentContribution, FVDrive, FVInfluence, FVStainess, FVCompliance;
   FuzzyValue INQuality, INGoalAchievement, INTaskDuration, INAgentContribution, INDrive, INInfluence, INStainess, INCompliance;

   Long GLA = new Long(GoalAc + 80);
   Long TSD = new Long(TsDur);
   Long AIC = new Long(AgIndCont + 50);
   Long TSQ = new Long(TsQty + 50);
   Integer Drv = new Integer(Yo.getDrive());
   Integer Infl = new Integer(Yo.getInfluence());
   Integer Stnss = new Integer(Yo.getStainess());
   Integer Compln = new Integer(Yo.getCompliance());
   jess = new FuzzyRete();
   try {  jess.executeCommand("(clear)");
          jess.executeCommand("(reset)");
          jess.executeCommand("(assert (inicio))");
          FileReader fr = new FileReader("rules/UpdtEmRules.clp");
          Jesp j = new Jesp(fr, jess);
	// parse and execute one construct, without printing a prompt
	  j.parse(false);
          jess.run(1);
          FuzzyValue.setConfineFuzzySetsToUOD(true);
          FVQuality = (FuzzyVariable)(jess.fetch("QUALITYFUZZYVARIABLE")).externalAddressValue(null);
          FVGoalAchievement = (FuzzyVariable)(jess.fetch("GOALACHIEVEMENTFUZZYVARIABLE")).externalAddressValue(null);
          FVTaskDuration = (FuzzyVariable)(jess.fetch("TASKDURATIONFUZZYVARIABLE")).externalAddressValue(null);
          FVAgentContribution = (FuzzyVariable)(jess.fetch("AGENTCONTRIBUTIONFUZZYVARIABLE")).externalAddressValue(null);
          FVDrive = (FuzzyVariable)(jess.fetch("DRIVEFUZZYVARIABLE")).externalAddressValue(null);
          FVInfluence = (FuzzyVariable)(jess.fetch("INFLUENCEFUZZYVARIABLE")).externalAddressValue(null);
          FVStainess = (FuzzyVariable)(jess.fetch("STAINESSFUZZYVARIABLE")).externalAddressValue(null);
          FVCompliance = (FuzzyVariable)(jess.fetch("COMPLIANCEFUZZYVARIABLE")).externalAddressValue(null);
          INQuality = new FuzzyValue(FVQuality, new PIFuzzySet(TSQ.doubleValue(), 1.0));
          INGoalAchievement = new FuzzyValue(FVGoalAchievement, new PIFuzzySet(GLA.doubleValue(), 1.0));
          INTaskDuration = new FuzzyValue(FVTaskDuration, new PIFuzzySet(TSD.doubleValue(), 1.0));
          INAgentContribution = new FuzzyValue(FVAgentContribution, new PIFuzzySet(AIC.doubleValue(), 1.0));
          INDrive = new FuzzyValue(FVDrive, new PIFuzzySet(Drv.doubleValue(), 1.0));
          INInfluence = new FuzzyValue(FVInfluence, new PIFuzzySet(Infl.doubleValue(), 1.0));
          INStainess = new FuzzyValue(FVStainess, new PIFuzzySet(Stnss.doubleValue(), 1.0));
          INCompliance = new FuzzyValue(FVCompliance, new PIFuzzySet(Compln.doubleValue(), 1.0));
 	  jess.store("INQTY", INQuality);
          jess.store("INGLACH", INGoalAchievement);
          jess.store("INTSKDUR", INTaskDuration);
          jess.store("INAGCONT", INAgentContribution);
          jess.store("INDRV", INDrive);
          jess.store("ININFL",INInfluence);
          jess.store("INSTNSS",INStainess);
          jess.store("INCOMPL",INCompliance);
          jess.executeCommand(AssertQuality("INQTY", "INGLACH", "INTSKDUR", "INAGCONT", "INDRV", "ININFL", "INSTNSS", "INCOMPL"));
          jess.run();
          AddDes = jess.fetch("SUMDESIRE").numericValue(null);
          AddInter = jess.fetch("SUMINTEREST").numericValue(null);
          AddDisg = jess.fetch("SUMDISGUST").numericValue(null);
          AddAnx = jess.fetch("SUMANXIETY").numericValue(null);
          AddStrss = jess.fetch("SUMSTRESS").numericValue(null);
          RuleFired = jess.fetch("RULESTHATFIRED").stringValue(null);
          ModificaInternalState(AddDes, AddInter, AddDisg, AddAnx, AddStrss);
        } catch (FuzzyException  fe)
            { System.out.println(fe);
            }
         catch (JessException re)
            { System.out.println(re);
            }
         catch (FileNotFoundException e) { System.out.println(e); }
  } // FIN ACTUALIZAINTERNALSTATE

   public String AssertQuality(String qty, String glach, String tskdurn, String agcnt, String drv, String infl, String stss, String cmpln){
    String     fact;
    fact = "(assert (quality (fetch " + qty;
    fact = fact + ")) (goalsachievement (fetch " + glach;
    fact = fact + ")) (taskduration (fetch " + tskdurn;
    fact = fact + ")) (agentcontribution (fetch " + agcnt;
    fact = fact + ")) (drive (fetch " + drv;
    fact = fact + ")) (influence (fetch " + infl;
    fact = fact + ")) (stainess (fetch " + stss;
    fact = fact + ")) (compliance (fetch " + cmpln;
    fact = fact + ")))";
    return fact;
  }

  private void ModificaInternalState(double Des, double Inter, double Disg, double Anx, double Strs) {


     Long Temp;

      Temp = new Long(StrictMath.round(Des));
      if (Yo.getDesire() + Temp.intValue() > 100)
        Yo.setDesire(100);
      else
        if (Yo.getDesire() + Temp.intValue() < 0)
          Yo.setDesire(0);
        else
          Yo.setDesire(Yo.getDesire() + Temp.intValue());
      Temp = new Long(StrictMath.round(Inter));
      if (Yo.getInterest() + Temp.intValue() > 100)
        Yo.setInterest(100);
      else
        if (Yo.getInterest() + Temp.intValue() < 0)
          Yo.setInterest(0);
        else
          Yo.setInterest(Yo.getInterest() + Temp.intValue());
      Temp = new Long(StrictMath.round(Disg));
      if (Yo.getDisgust() + Temp.intValue() > 100)
        Yo.setDisgust(100);
      else
        if (Yo.getDisgust() + Temp.intValue() < 0)
          Yo.setDisgust(0);
        else
          Yo.setDisgust(Yo.getDisgust() + Temp.intValue());
      Temp = new Long(StrictMath.round(Anx));
      if (Yo.getAnxiety() + Temp.intValue() > 100)
        Yo.setAnxiety(100);
      else
        if (Yo.getAnxiety() + Temp.intValue() < 0)
          Yo.setAnxiety(0);
        else
          Yo.setAnxiety(Yo.getAnxiety() + Temp.intValue());
      Temp = new Long(StrictMath.round(Strs));
      if (Yo.getStress() + Temp.intValue() > 100)
        Yo.setStress(100);
      else
        if (Yo.getStress() + Temp.intValue() < 0)
          Yo.setStress(0);
        else
          Yo.setStress(Yo.getStress() + Temp.intValue());

   }


   private void Escribe(String S) {

   boolean Encontrado = false;
   String trustResults;

     Integer SSim = new Integer(S);
     int Sim = SSim.intValue();

     for (int k=0; k<Resultados.size(); k++)
      { AuxResults Mostrar = (AuxResults) Resultados.get(k);
        if (Mostrar.NumSimulacion == Sim)
          Results.Txt_Results.append(Mostrar.Descripcion + Mostrar.DescripcionTotales);
      }
     Results.Txt_Results.append("\n");

     for (int k=0; k<ResComp.size(); k++)
      { AuxResults Mostrar = (AuxResults)ResComp.get(k);
        if (Mostrar.NumSimulacion == Sim)
          Results.ResAgent.addElement(Mostrar);
      }
     
     for (int k=0; k<traceTrustValues.size(); k++)
     {
    	 AuxResults trustTrace = (AuxResults)traceTrustValues.get(k);
    	 if (trustTrace.NumSimulacion == Sim){
    		 trustResults = "SIMULATION = " + trustTrace.NumSimulacion + " AGENT = " + trustTrace.Owner + " TRUST RELATIONSHIP = " + trustTrace.trustValues + " IN TASK = " + trustTrace.TSName + "\n"; 
    		 Results.ResTrust.addElement(trustResults);
    		 Results.AveragesTrust.add(trustTrace);
    	 }
     }
    	 
 }

 private double getTrustLevelAverage(Tarea Task){
	 
	 String teamMate;
	 double sumTrustLevel = 0.0;
	 
	  for (int i=0; i<Task.MuestraAgentesAsignados().size(); i++){
		  teamMate = Task.MuestraAgentesAsignados().get(i).toString();
		  if (! teamMate.equalsIgnoreCase(Yo.getLocalName())){
			  sumTrustLevel = sumTrustLevel + Yo.getTrustLevel(teamMate);
		  }
	  }
	  return sumTrustLevel / (Task.MuestraAgentesAsignados().size() - 1);
 }
   
 public static double AleatorioNormal(double m, double s) {

  double res, x1, x2, w;
  do {
      x1 = 2. * StrictMath.random() - 1.;
      x2 = 2. * StrictMath.random() - 1.;
      w = x1*x1 + x2*x2;
     }
  while (w >= 1. || w < 1E-30);
  w = StrictMath.sqrt((-2.* StrictMath.log(w))/w);
  x1 *= w;
  res = x1 * s + m;
  if ((res > m + s) || (res < m - s))
    res = m;
  if (res > 100.0)
    res = 100.0;
  if (res < 0.0)
    res = 0.0;
  return res;
 }

} // end AgentwrkBehaviour






