/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class for assign the tasks to all the agents.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class Assign extends JFrame {

  boolean Pasa = false;
  Vector Agentes = new Vector(1, 1);
  Vector NomAgentes = new Vector(1, 1);
  Vector Tasks = Principal.getGlobalTasks();
  Vector NomAsignados = new Vector(1, 1);
  Vector TempNomAgentes = new Vector(1, 1);
  Vector TempAgentes = new Vector(1, 1);
  JPanel contentPane;
  JScrollPane Scl_Agents = new JScrollPane();
  JLabel jLabel1 = new JLabel();
  JList Lst_Agents = new JList();
  JLabel jLabel2 = new JLabel();
  JComboBox Cmb_Tasks = new JComboBox();
  JScrollPane Scl_Assign = new JScrollPane();
  JList Lst_Assign = new JList();
  JButton But_Assign = new JButton();
  JButton But_Clear = new JButton();
  JButton But_Agregar = new JButton();
  JButton But_Quitar = new JButton();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();


  /**Construct the frame*/
  public Assign(Vector Ag, Vector NomAg) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    for (int i = 0; i<Ag.size(); i++)
      {Agentes.addElement(Ag.get(i));
       TempAgentes.addElement(Ag.get(i));
       NomAgentes.addElement(NomAg.get(i));
       TempNomAgentes.addElement(NomAg.get(i));
      }
     Lst_Agents.setListData(NomAgentes);
    try {
      jbInit();
      CargaTareas();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(600, 315));
    this.setTitle("Assign Tasks");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Scl_Agents.setBounds(new Rectangle(22, 59, 190, 216));
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setText("Agents:");
    jLabel1.setBounds(new Rectangle(24, 35, 62, 20));
    jLabel2.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel2.setText("Task:");
    jLabel2.setBounds(new Rectangle(305, 35, 48, 20));
    Cmb_Tasks.setBounds(new Rectangle(343, 33, 150, 20));
    Cmb_Tasks.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
         try {
              Cmb_Tasks_itemStateChanged(e);
             }
         catch (Exception e1) { System.out.println("ERROR EN ASSIGN 87" + e1);}
      }
    });
    Scl_Assign.setBounds(new Rectangle(304, 58, 190, 216));
    But_Assign.setText("Ok");
    But_Assign.setBounds(new Rectangle(506, 242, 80, 31));
    But_Assign.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        try {
              But_Assign_mousePressed(e);
            }
        catch ( IOException e1 ) { System.out.println("ERROR EN ASSIGN 98" + e1);}
      }
    });
    But_Clear.setToolTipText("Quit all the assigned agents to all tasks");
    But_Clear.setText("Clear all");
    But_Clear.setBounds(new Rectangle(216, 217, 84, 27));
    But_Clear.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_Clear_mousePressed(e);
      }
    });
    But_Agregar.setFont(new java.awt.Font("DialogInput", 0, 12));
    But_Agregar.setToolTipText("Add");
    But_Agregar.setText("--->");
    But_Agregar.setBounds(new Rectangle(223, 137, 64, 21));
    But_Agregar.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_Agregar_mousePressed(e);
      }
    });
    But_Quitar.setBounds(new Rectangle(223, 160, 64, 21));
    But_Quitar.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        But_Quitar_mousePressed(e);
      }
    });
    But_Quitar.setText("<---");
    But_Quitar.setFont(new java.awt.Font("DialogInput", 0, 12));
    But_Quitar.setToolTipText("Quit");
    jLabel3.setText("Select the agent(s) for assign to a task.");
    jLabel3.setBounds(new Rectangle(6, 4, 229, 21));
    jLabel4.setBounds(new Rectangle(306, 5, 117, 21));
    jLabel4.setText("Select the task.");
    contentPane.add(But_Clear, null);
    contentPane.add(But_Assign, null);
    contentPane.add(jLabel1, null);
    contentPane.add(jLabel3, null);
    contentPane.add(jLabel4, null);
    contentPane.add(jLabel2, null);
    contentPane.add(Cmb_Tasks, null);
    contentPane.add(Scl_Assign, null);
    contentPane.add(Scl_Agents, null);
    contentPane.add(But_Agregar, null);
    contentPane.add(But_Quitar, null);
    Scl_Agents.getViewport().add(Lst_Agents, null);
    Scl_Assign.getViewport().add(Lst_Assign, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }

  void CargaTareas() throws IOException, FileNotFoundException, ClassNotFoundException{

    Tarea T;

    //ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(Principal.FileTasks));

    //Tasks = (Vector)InTasks.readObject();
    //InTasks.close();
    for (int i=0; i < Tasks.size(); i++)
      { T = (Tarea) Tasks.get(i);
        Cmb_Tasks.addItem(T.getName());
      }
 }

  void Cmb_Tasks_itemStateChanged(ItemEvent e) {

  Tarea T;
  Vector Asignados;
  int i;
  Agentwrk A;

   if  (!Pasa)
     { NomAsignados.clear();
       TempNomAgentes.clear();
       TempAgentes.clear();
      for (int j = 0; j<Agentes.size(); j++)
       { TempAgentes.addElement(Agentes.get(j));
         TempNomAgentes.addElement(NomAgentes.get(j));
       }
       T = (Tarea) Tasks.get(Cmb_Tasks.getSelectedIndex());
       Asignados = T.MuestraAgentesAsignados();
       for (int k=0; k < Asignados.size(); k++)
         { i = 0;
           A = (Agentwrk) Agentes.get(i);
           try {
                 while (!Asignados.get(k).equals(A.getLocalName()))
                  { i++;
                    A = (Agentwrk) Agentes.get(i);
                  }
                 NomAsignados.addElement(NomAgentes.get(i));
                 i = TempAgentes.indexOf(A);
                 TempNomAgentes.removeElementAt(i);
                 TempAgentes.removeElementAt(i);
               }
           catch (ArrayIndexOutOfBoundsException e2) { T.removeAgent(Asignados.get(k).toString()); }
         }
       Lst_Agents.setListData(TempNomAgentes);
       Lst_Assign.setListData(NomAsignados);
       Pasa = true;
     }
   else
       Pasa = false;
  }

  void But_Agregar_mousePressed(MouseEvent e) {

   Tarea T;
   Agentwrk A;

   if (Lst_Agents.getSelectedIndex() != -1)
     {T = (Tarea) Tasks.get(Cmb_Tasks.getSelectedIndex());
      A = (Agentwrk) TempAgentes.get(Lst_Agents.getSelectedIndex());
      T.setAgent(A.getLocalName());
      TempNomAgentes.removeElementAt(Lst_Agents.getSelectedIndex());
      TempAgentes.removeElementAt(Lst_Agents.getSelectedIndex());
      NomAsignados.addElement(A.getType() + " --> " + A.getLocalName());
      Lst_Agents.setListData(TempNomAgentes);
      Lst_Assign.setListData(NomAsignados);
     }
  }

  void But_Quitar_mousePressed(MouseEvent e) {

   Tarea T;
   Agentwrk A;
   int i;

   if (Lst_Assign.getSelectedIndex() != -1)
     {T = (Tarea) Tasks.get(Cmb_Tasks.getSelectedIndex());
      i = NomAgentes.indexOf(NomAsignados.get(Lst_Assign.getSelectedIndex()));
      A = (Agentwrk) Agentes.get(i);
      T.removeAgent(A.getLocalName());
      if (i <= TempAgentes.size())
        {TempNomAgentes.insertElementAt(A.getType() + " --> " + A.getLocalName(), i);
         TempAgentes.insertElementAt(A, i);
        }
      else
        {TempNomAgentes.addElement(A.getType() + " --> " + A.getLocalName());
         TempAgentes.addElement(A);
        }
      NomAsignados.removeElementAt(Lst_Assign.getSelectedIndex());
      Lst_Agents.setListData(TempNomAgentes);
      Lst_Assign.setListData(NomAsignados);
     }
  }

  void But_Clear_mousePressed(MouseEvent e) {

  Vector As;
  Tarea T;

    for (int i=0; i < Tasks.size(); i++)
      { T = (Tarea) Tasks.get(i);
        T.removeAllAgents();
      }
       T = (Tarea) Tasks.get(0);
       Cmb_Tasks.setSelectedItem(T.getName());
       NomAsignados.clear();
       Lst_Assign.setListData(NomAsignados);
       Lst_Agents.setListData(NomAgentes);
  }

  void But_Assign_mousePressed(MouseEvent e) throws IOException {

    Tarea T;
    boolean lleno = true;

    for (int i=0; i < Tasks.size(); i++)
      { T = (Tarea) Tasks.get(i);
        if(T.MuestraAgentesAsignados().isEmpty())
          lleno = false;
      }

    if (lleno)
     { ObjectOutputStream OutTasks = new ObjectOutputStream(new FileOutputStream(Principal.FileTasks));

       OutTasks.writeObject(Tasks);
       OutTasks.close();
       for (int i=0; i < Tasks.size(); i++)
        { T = (Tarea) Tasks.get(i);
          System.out.println(T.getName() + " --> " + T.MuestraAgentesAsignados().toString());
        }
       this.dispose();
     }
    else
      JOptionPane.showMessageDialog(null, "You must assign all the tasks.", "Error", JOptionPane.ERROR_MESSAGE);
  }

}