/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is an auxiliar class for write the simulations results in a text file
or show them graphically.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.lang.*;
import java.io.*;
import java.util.*;

public class AuxResults implements Serializable {

   public String Descripcion;
   public String DescripcionTotales;
   public String TSName;
   public String Owner;
   public int NumSimulacion;
   public int QualityTask, DurationTask, AgentGoals, AgentTeamCollaboration, AgentIndividualContribution, AgentRequiredSupervision;
   public HashMap<String, Double> trustValues;


  public AuxResults(int Sims, String TsNm, int QtyTs, int Dur, int Goals, int ColTeam, int IndivCont, int SupervReq){

         this.NumSimulacion = Sims;
         this.TSName = TsNm;
         this.QualityTask = QtyTs;
         this.DurationTask = Dur;
         this.AgentGoals = Goals;
         this.AgentTeamCollaboration = ColTeam;
         this.AgentIndividualContribution = IndivCont;
         this.AgentRequiredSupervision = SupervReq;
  }

  public AuxResults(String Sims, String NomAg, String TsNm, long QtyTs, long Dur, long Goals, long ColTeam, long IndivCont, long SupervReq){

         Integer SimAux = new Integer(Sims);
         Long Qty = new Long(QtyTs);
         Long Durts = new Long(Dur);
         Long Gls = new Long(Goals);
         Long TeamCll = new Long(ColTeam);
         Long IndvContr = new Long(IndivCont);
         Long SupReq = new Long(SupervReq);

         this.NumSimulacion = SimAux.intValue();
         this.Owner = NomAg;
         this.TSName = TsNm;
         this.QualityTask = Qty.intValue();
         this.DurationTask = Durts.intValue();
         this.AgentGoals = Gls.intValue();
         this.AgentTeamCollaboration = TeamCll.intValue();
         this.AgentIndividualContribution = IndvContr.intValue();
         this.AgentRequiredSupervision = SupReq.intValue();

  }

  public AuxResults(String Desc, String Reg, String Sims){

         Integer SimAux = new Integer(Sims);

         this.NumSimulacion = SimAux.intValue();
         this.Descripcion = Desc;
         this.DescripcionTotales = Reg;

  }
  
  public AuxResults(int simulationNumber, String agentName, String taskName, String teamMate, double trustValue){
	  
	  this.trustValues = new HashMap<String, Double>();
	  
	  this.NumSimulacion = simulationNumber;
	  this.Owner = agentName;
	  this.TSName = taskName;
	  this.trustValues.put(teamMate, trustValue);
	  
  }

  public void SumaDurQty(int SumDur, int SumQty, int SumGls, int SumTeamColl, int SumIndivCont, int SumReqSup){

      this.DurationTask = this.DurationTask + SumDur;
      this.QualityTask = this.QualityTask + SumQty;
      this.AgentGoals = this.AgentGoals + SumGls;
      this.AgentTeamCollaboration = this.AgentTeamCollaboration + SumTeamColl;
      this.AgentIndividualContribution = this.AgentIndividualContribution + SumIndivCont;
      this.AgentRequiredSupervision = this.AgentRequiredSupervision + SumReqSup;
  }

}