/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the Principal class for the construction of the agents with its
internal representation (emotions, personalities, cognition and social
characteristics.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.domain.FIPAAgentManagement.AMSAgentDescription;
import jade.domain.AMSService;
import jade.domain.FIPAException;

import jade.core.Runtime;
import jade.core.Profile;
import jade.core.ProfileImpl;
import jade.wrapper.*;
import jade.core.Agent;
import jade.core.AID;
import javax.swing.event.*;



public class Principal extends JFrame{

  public static Vector Agentes2 = new Vector(1,1);	
  public static Vector GlobalTasks;
	
  public static int Bloqueo = 0;
  private static int AGENT_TYPE = 0;
  private static int AGENT_INTROVERTED = 1;
  private static int AGENT_WORKALONE = 2;
  private static int AGENT_CREATIVITY = 3;
  private static int AGENT_EXPERIENCE = 4;
  private static int AGENT_DESIRE = 5;
  private static int AGENT_INTEREST = 6;
  private static int AGENT_DISGUST = 7;
  private static int AGENT_ANXIETY = 8;
  private static int AGENT_STRESS = 9;
  private static int AGENT_DRIVER = 10;
  private static int AGENT_INFLUENCE = 11;
  private static int AGENT_STEADINESS = 12;
  private static int AGENT_COMPLIANCE = 13;
  private static int AGENT_PERSONALITY = 14;
  
  public static String FileTasks;
  protected AgentContainer ac = null;

  Vector AgentesCreados = new Vector(1,1); // Vector en el cual estan las etiquetas de los agentes (para la interfaz)
  //protected Vector Agentes = new Vector(1,1);  //Vector en el cual estan los agentes
  Cursor Normal = new Cursor(0);
  Cursor Reloj = new Cursor(3);
  public static JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem Mnu_Open = new JMenuItem();
  JMenuItem Mnu_Close = new JMenuItem();
  JMenuItem Mnu_Save = new JMenuItem();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuOptions = new JMenu();
  JMenuItem Mnu_Tareas = new JMenuItem();
  JMenuItem Mnu_Assign = new JMenuItem();
  JMenu jMenuSimulations = new JMenu();
  JMenuItem Mnu_Configure = new JMenuItem();
  JMenuItem Mnu_Start = new JMenuItem();
  JMenu jMenuResults = new JMenu();
  JMenuItem Mnu_All = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JLabel jLabel1 = new JLabel();
  //String[] data = {"PROJECT MANAGER", "ENGINEER", "TECHNICIAN", "ASSISTANT"};
  String[] data = {"PROJECT MANAGER", "COORDINATOR", "SPECIALIST Sr.", "SPECIALIST Jr.", "TECHNICIAN", "ASSISTANT"};
  JComboBox cmb_TipoAgentes = new JComboBox(data);
  JLabel jLabel2 = new JLabel();
  JTabbedPane tab_Parametros = new JTabbedPane();
  JPanel Pnl_Status = new JPanel();
  JPanel Pnl_Cognition = new JPanel();
  JPanel Pnl_Emotion = new JPanel();
  JPanel Pnl_Personality = new JPanel();
  ButtonGroup Gpo_IntExt = new ButtonGroup();
  ButtonGroup Gpo_EquipoSolo = new ButtonGroup();
  JSlider Sld_Creatividad = new JSlider();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JSlider Sld_Experiencia = new JSlider();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JSlider Sld_Deseo = new JSlider();
  JLabel jLabel14 = new JLabel();
  JLabel jLabel15 = new JLabel();
  JLabel jLabel16 = new JLabel();
  JLabel jLabel17 = new JLabel();
  JSlider Sld_Interes = new JSlider();
  JLabel jLabel18 = new JLabel();
  JLabel jLabel19 = new JLabel();
  JSlider Sld_Ansiedad = new JSlider();
  JSlider Sld_Disgusto = new JSlider();
  JLabel jLabel110 = new JLabel();
  JSlider Sld_Stress = new JSlider();
  JLabel jLabel111 = new JLabel();
  ButtonGroup Gpo_Personality = new ButtonGroup();
  JTextPane Txt_Caracteristicas = new JTextPane();
  Border border1;
  Border border2;
  JButton But_Crear = new JButton();
  JButton But_Limpiar = new JButton();
  JLabel jLabel11 = new JLabel();
  JList Lst_TipoAgentes = new JList();
  JPanel Pnl_Organization = new JPanel();
  JLabel jLabel12 = new JLabel();
  ButtonGroup Gpo_Organization = new ButtonGroup();
  JRadioButton Opt_Centralizada = new JRadioButton();
  JRadioButton Opt_JerarquiaArbol = new JRadioButton();
  JRadioButton Opt_SinJerarquias = new JRadioButton();
  JButton But_Agregar = new JButton();
  JScrollPane Scl_TipoAgentes = new JScrollPane();
  JPopupMenu Pop_OptsAgentes = new JPopupMenu();
  JMenuItem Mnu_AgentEdit = new JMenuItem();
  JMenuItem Mnu_AgentRemove = new JMenuItem();
  JLabel jLabel13 = new JLabel();
  JTextField Txt_Name = new JTextField();
  JScrollPane Scl_Caracteristicas = new JScrollPane();
  JRadioButton Opt_Simpatico = new JRadioButton();
  JRadioButton Opt_Autoritario = new JRadioButton();
  JRadioButton Opt_Expresivo = new JRadioButton();
  JRadioButton Opt_Analitico = new JRadioButton();
  JPanel Pnl_Cleaver = new JPanel();
  JSlider Sld_Compliance = new JSlider();
  JSlider Sld_Influence = new JSlider();
  JLabel jLabel113 = new JLabel();
  JLabel jLabel116 = new JLabel();
  JSlider Sld_Drive = new JSlider();
  JSlider Sld_Stainess = new JSlider();
  JLabel jLabel115 = new JLabel();
  JLabel jLabel112 = new JLabel();
  JLabel jLabel114 = new JLabel();
  JLabel jLabel117 = new JLabel();
  JLabel jLabel118 = new JLabel();
  JLabel jLabel119 = new JLabel();
  JLabel jLabel20 = new JLabel();
  JSlider Sld_IntExt = new JSlider();
  JLabel jLabel21 = new JLabel();
  JSlider Sld_AlTem = new JSlider();
  JLabel jLabel22 = new JLabel();
  JLabel jLabel23 = new JLabel();



  /**Construct the frame*/
  
  public Principal() {
	    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	    try {
	    	jbInit();
	    }
	    catch(Exception e) {
	    	e.printStackTrace();
	    }
	  }
  
  public Principal(AgentContainer cc) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
    	this.ac = cc;
    	jbInit();
    }
    catch(Exception e) {
    	e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    border1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.black,Color.white),"");
    border2 = BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.black,Color.white,Color.white,Color.black);
    contentPane.setLayout(null);
    this.setSize(new Dimension(686, 559));
    this.setTitle("TEAKS: Simulating Human Behaviour in Work Teams");

    jMenuFile.setText("File");
    Mnu_Open.setText("Open team");
    Mnu_Open.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        try {
             Mnu_Open_actionPerformed(e);
            }
        catch ( IOException e1 ) { 
        	System.out.println("ERROR AL ABRIR EL ARCHIVO DE EQUIPO (TEAMS)");
        	e1.printStackTrace();
        }
        catch ( ClassNotFoundException e2 ) { System.out.println("ERROR POR LAS TAREAS PRINCIPAL 172 " + e2); }
        catch ( Exception e3 ) { System.out.println("ERROR PRINCIPAL 174" + e3); }
      }
    });

    Mnu_Close.setText("Close team");
    Mnu_Close.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        try {
             Mnu_Close_actionPerformed(e);
            }
        catch ( Exception e3 ) { System.out.println("ERROR AL CERRAR EL EQUIPO" + e3); }
      }
    });

    Mnu_Save.setText("Save team");
    Mnu_Save.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
       try {
            Mnu_Save_actionPerformed(e);
           }
       catch ( IOException e1 ) { System.out.println("ERROR AL GUARDAR EL EQUIPO" + e1);}
      }
    });

    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });

    jMenuSimulations.setText("Simulations");
    Mnu_Configure.setText("Settings");
    Mnu_Configure.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
         Mnu_Configure_actionPerformed(e);
      }
    });

    Mnu_Start.setText("Start simulation");
    Mnu_Start.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
         Mnu_Start_actionPerformed(e);
      }
    });

    jMenuOptions.setText("Tasks");
    Mnu_Tareas.setText("Create tasks");
    Mnu_Tareas.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_Tareas_actionPerformed(e);
      }
    });

    Mnu_Assign.setText("Assign tasks");
    Mnu_Assign.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_Assign_actionPerformed(e);
      }
    });

    jMenuResults.setText("Results");
    Mnu_All.setText("All Simulations");
    Mnu_All.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_All_actionPerformed(e);
      }
    });

    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About...");
    jMenuHelpAbout.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });

    Mnu_AgentRemove.setText("Remove Agent");
    Mnu_AgentRemove.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        try{
            Mnu_AgentRemove_actionPerformed(e);
           }
        catch ( Exception e1 ) { System.out.println(e1.toString());}
      }
    });

    Mnu_AgentEdit.setText("Edit Agent");
    Mnu_AgentEdit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_AgentEdit_actionPerformed(e);
      }
    });

    contentPane.setPreferredSize(new Dimension(1, 1));
    contentPane.setToolTipText("");
    Txt_Caracteristicas.setBorder(null);
    Txt_Caracteristicas.setEditable(false);
    Txt_Caracteristicas.setForeground(new Color(0, 0, 184));
    Txt_Caracteristicas.setFont(new java.awt.Font("Serif", 1, 12));
    Txt_Caracteristicas.setLayout(null);
    jLabel1.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel1.setText("Select type of person:");
    jLabel1.setBounds(new Rectangle(16, 35, 134, 24));
    cmb_TipoAgentes.setBounds(new Rectangle(156, 37, 224, 24));
    jLabel2.setFont(new java.awt.Font("SansSerif", 1, 18));
    jLabel2.setForeground(new Color(112, 0, 0));
    jLabel2.setText("TEAM CONFIGURATION");
    jLabel2.setBounds(new Rectangle(246, 5, 244, 24));
    tab_Parametros.setFont(new java.awt.Font("Dialog", 1, 12));
    tab_Parametros.setBounds(new Rectangle(13, 97, 419, 247));
    Pnl_Status.setLayout(null);
    Sld_IntExt.setValue(0);
    Sld_IntExt.setToolTipText("Haga click para cambiar este parametro");
    Sld_IntExt.setBounds(new Rectangle(10, 50, 398, 22));
    Sld_AlTem.setValue(0);
    Sld_AlTem.setToolTipText("Haga click para cambiar este parametro");
    Sld_AlTem.setBounds(new Rectangle(10, 154, 398, 22));
    Pnl_Cognition.setLayout(null);
    Sld_Creatividad.setValue(0);
    Sld_Creatividad.setToolTipText("Haga click para cambiar este parametro");
    Sld_Creatividad.setBounds(new Rectangle(104, 25, 290, 22));
    jLabel3.setText("Creativity:");
    jLabel3.setBounds(new Rectangle(13, 25, 81, 20));
    jLabel4.setText("Experience:");
    jLabel4.setBounds(new Rectangle(17, 104, 79, 21));
    Sld_Experiencia.setValue(0);
    Sld_Experiencia.setToolTipText("Change this value.");
    Sld_Experiencia.setBounds(new Rectangle(106, 107, 288, 24));
    jLabel5.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel5.setText("LOW");
    jLabel5.setBounds(new Rectangle(96, 51, 31, 19));
    jLabel6.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel6.setToolTipText("");
    jLabel6.setText("MEDIUM");
    jLabel6.setBounds(new Rectangle(226, 53, 55, 19));
    jLabel7.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel7.setText("HIGH");
    jLabel7.setBounds(new Rectangle(366, 53, 41, 19));
    jLabel8.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel8.setText("LOW");
    jLabel8.setBounds(new Rectangle(96, 135, 31, 19));
    jLabel9.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel9.setText("HIGH");
    jLabel9.setBounds(new Rectangle(370, 133, 41, 19));
    jLabel10.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel10.setText("MEDIUM");
    jLabel10.setBounds(new Rectangle(228, 135, 56, 17));
    Pnl_Emotion.setLayout(null);
    Sld_Deseo.setBounds(new Rectangle(102, 36, 297, 22));
    Sld_Deseo.setExtent(0);
    Sld_Deseo.setEnabled(true);
    Sld_Deseo.setToolTipText("Change this value.");
    Sld_Deseo.setValue(50);
    jLabel14.setBounds(new Rectangle(366, 16, 41, 19));
    jLabel14.setText("HIGH");
    jLabel14.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel15.setBounds(new Rectangle(227, 15, 58, 19));
    jLabel15.setText("MEDIUM");
    jLabel15.setToolTipText("");
    jLabel15.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel16.setBounds(new Rectangle(88, 13, 31, 19));
    jLabel16.setText("LOW");
    jLabel16.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel17.setBounds(new Rectangle(13, 65, 79, 21));
    jLabel17.setText("Interest:");
    Sld_Interes.setBounds(new Rectangle(102, 68, 297, 24));
    Sld_Interes.setExtent(0);
    Sld_Interes.setEnabled(true);
    Sld_Interes.setToolTipText("Change this value.");
    Sld_Interes.setValue(50);
    jLabel18.setBounds(new Rectangle(11, 36, 81, 20));
    jLabel18.setText("Desire:");
    jLabel19.setText("Anxiety:");
    jLabel19.setBounds(new Rectangle(13, 129, 79, 21));
    Sld_Ansiedad.setExtent(0);
    Sld_Ansiedad.setEnabled(true);
    Sld_Ansiedad.setToolTipText("Change this value.");
    Sld_Ansiedad.setValue(50);
    Sld_Ansiedad.setBounds(new Rectangle(102, 132, 297, 24));
    Sld_Disgusto.setExtent(0);
    Sld_Disgusto.setEnabled(true);
    Sld_Disgusto.setToolTipText("Change this value.");
    Sld_Disgusto.setValue(50);
    Sld_Disgusto.setBounds(new Rectangle(102, 100, 297, 22));
    jLabel110.setText("Disgust:");
    jLabel110.setBounds(new Rectangle(11, 100, 62, 20));
    Sld_Stress.setBounds(new Rectangle(102, 181, 297, 24));
    Sld_Stress.setExtent(0);
    Sld_Stress.setEnabled(true);
    Sld_Stress.setToolTipText("Change this value.");
    Sld_Stress.setValue(50);
    jLabel111.setBounds(new Rectangle(13, 178, 79, 21));
    jLabel111.setFont(new java.awt.Font("Dialog", 2, 12));
    jLabel111.setText("Stress:");
    Pnl_Personality.setLayout(null);
    But_Crear.setToolTipText("Show the characteristics of the agent.");
    But_Crear.setText("Show");
    But_Crear.setBounds(new Rectangle(16, 348, 101, 33));
    But_Crear.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mousePressed(MouseEvent e) {
        Mostrar_Agente(e);
      }
    });
    But_Crear.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mouseReleased(MouseEvent e) {
        Mostrar_Agente(e);
      }
    });
    But_Limpiar.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mousePressed(MouseEvent e) {
        Limpia_Agente(e);
      }
    });
    But_Limpiar.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mouseReleased(MouseEvent e) {
        Limpia_Agente(e);
      }
    });
    But_Limpiar.setBounds(new Rectangle(123, 348, 101, 33));
    But_Limpiar.setText("Clear");
    But_Limpiar.setToolTipText("Clear all the characteristics of the agent.");
    jLabel11.setBounds(new Rectangle(440, 93, 176, 24));
    jLabel11.setText("Created Agents:");
    jLabel11.setFont(new java.awt.Font("Dialog", 1, 12));
    Lst_TipoAgentes.setBackground(Color.white);
    MouseListener popupListener = new PopupListener();
    Lst_TipoAgentes.addMouseListener(popupListener);
    Pnl_Organization.setBorder(border2);
    Pnl_Organization.setBounds(new Rectangle(440, 355, 230, 141));
    Pnl_Organization.setLayout(null);
    jLabel12.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel12.setText("Organisation type:");
    jLabel12.setBounds(new Rectangle(6, 4, 136, 24));
    Opt_Centralizada.setSelected(true);
    Opt_Centralizada.setText("Centralised hierarchy");
    Opt_Centralizada.setBounds(new Rectangle(9, 41, 201, 19));
    Opt_JerarquiaArbol.setText("Tree hierarchy");
    Opt_JerarquiaArbol.setBounds(new Rectangle(9, 71, 194, 19));
    Opt_SinJerarquias.setBounds(new Rectangle(10, 100, 196, 26));
    Opt_SinJerarquias.setText("Without hierarchies");
    But_Agregar.setToolTipText("Create/Modify the agent with the selected characteristics.");
    But_Agregar.setText("Create Agent");
    But_Agregar.setBounds(new Rectangle(314, 348, 119, 33));
    But_Agregar.addMouseListener(new java.awt.event.MouseAdapter() {
    public void mousePressed(MouseEvent e) {
           Crear_Agente(e);
      }
    });
    Scl_TipoAgentes.setBounds(new Rectangle(437, 117, 233, 380));
    jLabel13.setBounds(new Rectangle(103, 66, 48, 24));
    jLabel13.setText("Name:");
    jLabel13.setFont(new java.awt.Font("Dialog", 1, 12));
    Txt_Name.setBounds(new Rectangle(156, 69, 224, 21));
    Scl_Caracteristicas.setBounds(new Rectangle(13, 386, 419, 111));
    Opt_Simpatico.setText("Amiable");
    Opt_Simpatico.setBounds(new Rectangle(320, 193, 76, 26));
    Opt_Autoritario.setBounds(new Rectangle(116, 197, 74, 19));
    Opt_Autoritario.setText("Driver");
    Opt_Expresivo.setBounds(new Rectangle(208, 197, 114, 19));
    Opt_Expresivo.setText("Expressive");
    Opt_Analitico.setAlignmentX((float) 0.0);
    Opt_Analitico.setSelected(true);
    Opt_Analitico.setText("Analytical");
    Opt_Analitico.setBounds(new Rectangle(10, 193, 91, 25));
    Pnl_Cleaver.setBorder(BorderFactory.createEtchedBorder());
    Pnl_Cleaver.setBounds(new Rectangle(8, 4, 399, 186));
    Pnl_Cleaver.setLayout(null);
    Sld_Compliance.setBounds(new Rectangle(92, 133, 297, 24));
    Sld_Compliance.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        Sld_Compliance_stateChanged(e);
      }
    });
    Sld_Compliance.setToolTipText("Change this value.");
    Sld_Compliance.setEnabled(true);
    Sld_Compliance.setExtent(0);
    Sld_Compliance.setValue(0);
    Sld_Influence.setValue(0);
    Sld_Influence.setToolTipText("Change this value.");
    Sld_Influence.setEnabled(true);
    Sld_Influence.setExtent(0);
    Sld_Influence.setBounds(new Rectangle(92, 72, 297, 24));
    Sld_Influence.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        Sld_Influence_stateChanged(e);
      }
    });
    jLabel113.setFont(new java.awt.Font("Dialog", 0, 10));
    jLabel113.setText("HIGH");
    jLabel113.setBounds(new Rectangle(361, 165, 41, 19));
    jLabel116.setText("Driver:");
    jLabel116.setBounds(new Rectangle(9, 40, 81, 20));
    Sld_Drive.setToolTipText("Change this value.");
    Sld_Drive.setEnabled(true);
    Sld_Drive.setExtent(0);
    Sld_Drive.setValue(0);
    Sld_Drive.setBounds(new Rectangle(92, 40, 297, 22));
    Sld_Drive.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        Sld_Drive_stateChanged(e);
      }
    });
    Sld_Stainess.setToolTipText("Change this value.");
    Sld_Stainess.setEnabled(true);
    Sld_Stainess.setExtent(0);
    Sld_Stainess.setValue(0);
    Sld_Stainess.setBounds(new Rectangle(91, 103, 297, 22));
    Sld_Stainess.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        Sld_Stainess_stateChanged(e);
      }
    });
    jLabel115.setBounds(new Rectangle(8, 104, 62, 20));
    jLabel115.setText("Amiable:");
    jLabel112.setBounds(new Rectangle(9, 133, 79, 21));
    jLabel112.setText("Analytical:");
    jLabel114.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel114.setText("LOW");
    jLabel114.setBounds(new Rectangle(88, 164, 31, 19));
    jLabel117.setText("Expressive:");
    jLabel117.setBounds(new Rectangle(9, 74, 79, 21));
    jLabel118.setFont(new java.awt.Font("Dialog", 1, 12));
    jLabel118.setText("CLEAVER Style Behaviour Parameters");
    jLabel118.setVerticalAlignment(SwingConstants.CENTER);
    jLabel118.setVerticalTextPosition(SwingConstants.CENTER);
    jLabel118.setBounds(new Rectangle(98, 5, 252, 24));
    jLabel119.setBounds(new Rectangle(218, 165, 64, 19));
    jLabel119.setText("MEDIUM");
    jLabel119.setFont(new java.awt.Font("Dialog", 1, 10));
    jLabel20.setBounds(new Rectangle(7, 122, 145, 21));
    jLabel20.setText("Prefers to work alone.");
    jLabel21.setBounds(new Rectangle(3, 23, 81, 20));
    jLabel21.setText("Introverted.");
    jLabel22.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel22.setText("Extroverted.");
    jLabel22.setBounds(new Rectangle(311, 26, 94, 20));
    jLabel23.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel23.setText("Prefers to work in team.");
    jLabel23.setBounds(new Rectangle(255, 125, 145, 21));
    jMenuFile.add(Mnu_Open);
    jMenuFile.add(Mnu_Close);
    jMenuFile.add(Mnu_Save);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuFileExit);
    jMenuOptions.add(Mnu_Tareas);
    jMenuOptions.add(Mnu_Assign);
    jMenuSimulations.add(Mnu_Configure);
    jMenuSimulations.add(Mnu_Start);
    jMenuResults.add(Mnu_All);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuOptions);
    jMenuBar1.add(jMenuSimulations);
    jMenuBar1.add(jMenuResults);
    jMenuBar1.add(jMenuHelp);
    Pop_OptsAgentes.add(Mnu_AgentEdit);
    Pop_OptsAgentes.add(Mnu_AgentRemove);
    contentPane.add(tab_Parametros, null);
    tab_Parametros.add(Pnl_Status, "Social Skills");
    Pnl_Status.add(jLabel21, null);
    Pnl_Status.add(jLabel22, null);
    Pnl_Status.add(Sld_IntExt, null);
    Pnl_Status.add(Sld_AlTem, null);
    Pnl_Status.add(jLabel20, null);
    Pnl_Status.add(jLabel23, null);
    tab_Parametros.add(Pnl_Cognition, "Cognition");
    Pnl_Cognition.add(jLabel4, null);
    Pnl_Cognition.add(Sld_Experiencia, null);
    Pnl_Cognition.add(jLabel8, null);
    Pnl_Cognition.add(jLabel3, null);
    Pnl_Cognition.add(jLabel5, null);
    Pnl_Cognition.add(Sld_Creatividad, null);
    Pnl_Cognition.add(jLabel9, null);
    Pnl_Cognition.add(jLabel7, null);
    Pnl_Cognition.add(jLabel6, null);
    Pnl_Cognition.add(jLabel10, null);
    tab_Parametros.add(Pnl_Emotion, "Emotions");
    Pnl_Emotion.add(jLabel16, null);
    Pnl_Emotion.add(Sld_Deseo, null);
    Pnl_Emotion.add(jLabel18, null);
    Pnl_Emotion.add(jLabel17, null);
    Pnl_Emotion.add(jLabel110, null);
    Pnl_Emotion.add(jLabel19, null);
    Pnl_Emotion.add(Sld_Ansiedad, null);
    Pnl_Emotion.add(Sld_Disgusto, null);
    Pnl_Emotion.add(Sld_Interes, null);
    Pnl_Emotion.add(Sld_Stress, null);
    Pnl_Emotion.add(jLabel111, null);
    Pnl_Emotion.add(jLabel14, null);
    Pnl_Emotion.add(jLabel15, null);
    tab_Parametros.add(Pnl_Personality, "Personality");
    contentPane.add(jLabel2, null);
    contentPane.add(Scl_Caracteristicas, null);
    contentPane.add(Scl_TipoAgentes, null);
    Scl_TipoAgentes.getViewport().add(Lst_TipoAgentes, null);
    contentPane.add(Pnl_Organization, null);
    Pnl_Organization.add(jLabel12, null);
    Pnl_Organization.add(Opt_JerarquiaArbol, null);
    Pnl_Organization.add(Opt_Centralizada, null);
    Pnl_Organization.add(Opt_SinJerarquias, null);
    contentPane.add(jLabel11, null);
    contentPane.add(Txt_Name, null);
    contentPane.add(jLabel13, null);
    contentPane.add(jLabel1, null);
    contentPane.add(cmb_TipoAgentes, null);
    Scl_Caracteristicas.getViewport().add(Txt_Caracteristicas, null);
    this.setJMenuBar(jMenuBar1);
    Gpo_Organization.add(Opt_Centralizada);
    Gpo_Organization.add(Opt_JerarquiaArbol);
    Gpo_Organization.add(Opt_SinJerarquias);
    tab_Parametros.setSelectedComponent(Pnl_Status);
    contentPane.add(But_Agregar, null);
    contentPane.add(But_Crear, null);
    contentPane.add(But_Limpiar, null);
    Gpo_Personality.add(Opt_Simpatico);
    Gpo_Personality.add(Opt_Expresivo);
    Gpo_Personality.add(Opt_Autoritario);
    Gpo_Personality.add(Opt_Analitico);
    Pnl_Cleaver.add(Sld_Stainess, null);
    Pnl_Cleaver.add(jLabel116, null);
    Pnl_Cleaver.add(jLabel117, null);
    Pnl_Cleaver.add(jLabel115, null);
    Pnl_Cleaver.add(jLabel112, null);
    Pnl_Cleaver.add(Sld_Compliance, null);
    Pnl_Cleaver.add(Sld_Influence, null);
    Pnl_Cleaver.add(Sld_Drive, null);
    Pnl_Cleaver.add(jLabel114, null);
    Pnl_Cleaver.add(jLabel113, null);
    //Pnl_Cleaver.add(jLabel118, null);
    Pnl_Cleaver.add(jLabel119, null);
    /*Pnl_Personality.add(Opt_Simpatico, null);
    Pnl_Personality.add(Opt_Analitico, null);
    Pnl_Personality.add(Opt_Autoritario, null);
    Pnl_Personality.add(Opt_Expresivo, null);*/
    Pnl_Personality.add(Pnl_Cleaver, null);

  }

  public void Mnu_Open_actionPerformed(ActionEvent e) throws IOException, FileNotFoundException, ClassNotFoundException{

    Agentwrk AgentRead;
    Vector TempAgentes;
    File ruta = new File("\\");
    contentPane.setCursor(Reloj);
    if (Agentes2.size() > 0)
       JOptionPane.showMessageDialog(null, "You must close the actual team before.", "Alert", JOptionPane.WARNING_MESSAGE);
    else
    { JFileChooser chooser = new JFileChooser();
      ExampleFileFilter filter = new ExampleFileFilter();
      filter.addExtension("tem");
      filter.setDescription("Team files");
      chooser.setFileFilter(filter);
      chooser.setCurrentDirectory(ruta);
      int returnVal = chooser.showOpenDialog(null);
      if(returnVal == JFileChooser.APPROVE_OPTION) {
       ObjectInputStream InAgentes = new ObjectInputStream(new FileInputStream(chooser.getSelectedFile().getAbsoluteFile()));  //.getName()));
       TempAgentes = (Vector)InAgentes.readObject();
       InAgentes.close();
       for (int i = 0; i<TempAgentes.size(); i++)
        {
          AgentRead = (Agentwrk) TempAgentes.get(i);
          Txt_Name.setText(AgentRead.getLocalName());
          cmb_TipoAgentes.setSelectedItem(AgentRead.getType());
          /*if (AgentRead.getIntroverted())
            Opt_Introvertido.setSelected(true);
          else
            Opt_Extrovertido.setSelected(true);
          if (AgentRead.getAlone())
            Opt_Solo.setSelected(true);
          else
            Opt_Equipo.setSelected(true);*/
         Sld_IntExt.setValue(AgentRead.getIntroverted());
         Sld_AlTem.setValue(AgentRead.getAlone());
         Sld_Creatividad.setValue(AgentRead.getCreativity());
         Sld_Experiencia.setValue(AgentRead.getExperience());
         Sld_Deseo.setValue(AgentRead.getDesire());
         Sld_Interes.setValue(AgentRead.getInterest());
         Sld_Disgusto.setValue(AgentRead.getDisgust());
         Sld_Ansiedad.setValue(AgentRead.getAnxiety());
         Sld_Stress.setValue(AgentRead.getStress());
         Sld_Drive.setValue(AgentRead.getDrive());
         Sld_Influence.setValue(AgentRead.getInfluence());
         Sld_Stainess.setValue(AgentRead.getStainess());
         Sld_Compliance.setValue(AgentRead.getCompliance());
         if (AgentRead.getIndexPersonality() == 4)
             Opt_Analitico.setSelected(true);
         else
           if (AgentRead.getIndexPersonality() == 3)
              Opt_Autoritario.setSelected(true);
           else
             if (AgentRead.getIndexPersonality() == 2)
                Opt_Expresivo.setSelected(true);
             else
                  Opt_Simpatico.setSelected(true);
         NaceAgente(false);
        }
        LimpiaCaracteristicas();
        fillTypeNameAgents();
        Lst_TipoAgentes.setListData(AgentesCreados);
      } // FIN DEL FILE CHOOSER
    }
    contentPane.setCursor(Normal);
  }

  private void fillTypeNameAgents(){
	  
	  Agentwrk AgentRead;
	  int index = 0;
	  
	  contentPane.setCursor(Reloj);
	  try {
	       Thread.sleep (600); // Do nothing!!! Only waste time to get all the agents registered!!
	    } catch (InterruptedException e) {e.printStackTrace();}
	    
	  AgentesCreados.removeAllElements();
	  for (int i = 0; i<Agentes2.size(); i++)
      {
        AgentRead = (Agentwrk) Agentes2.get(i);
        AgentesCreados.addElement(AgentRead.getType() + " --> " + AgentRead.getLocalName());
      }
	  contentPane.setCursor(Normal);
  }
  
  public void Mnu_Close_actionPerformed(ActionEvent e) throws IOException {

     Agentwrk Agent;

      for (int i = 0; i < Agentes2.size(); i++)
       { Agent = (Agentwrk) Agentes2.get(i);
         Agent.doDelete();
       }
      Agentes2.removeAllElements();
      AgentesCreados.removeAllElements();
      Txt_Name.setEnabled(true);
      cmb_TipoAgentes.setEnabled(true);
      Lst_TipoAgentes.setEnabled(true);
      LimpiaCaracteristicas();
      Lst_TipoAgentes.setListData(AgentesCreados);
 }

  public void Mnu_Save_actionPerformed(ActionEvent e) throws IOException {

    JFileChooser chooser = new JFileChooser();
    ExampleFileFilter filter = new ExampleFileFilter();
    filter.addExtension("tem");
    filter.setDescription("Team files");
    chooser.setFileFilter(filter);
    chooser.setCurrentDirectory(new File("\\"));
    int returnVal = chooser.showSaveDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      ObjectOutputStream OutAgentes = new ObjectOutputStream(new FileOutputStream(chooser.getSelectedFile().getName()));
      OutAgentes.writeObject(Agentes2);
      OutAgentes.close();
    }
 }

  public void Mnu_Configure_actionPerformed(ActionEvent e) {

  boolean packFrame = false;

    Configure frame = new Configure();
    if (packFrame) {
       frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setResizable(false);
    frame.setVisible(true);
}


 public void Mnu_Start_actionPerformed(ActionEvent e) {

  Agentwrk Agent;

  contentPane.setCursor(Reloj);

   if (! Agentes2.isEmpty())
     //if (FileTasks != nul)
	 if (GlobalTasks!= null)  
      {
       for (int i = 0; i < Agentes2.size(); i++)  // FOR para estabilizar las emociones de
        { Agent = (Agentwrk) Agentes2.get(i);     // los agentes en cada nueva simulacin
          Agent.setDesire(50);
          Agent.setInterest(50);
          Agent.setDisgust(50);
          Agent.setAnxiety(50);
          Agent.setStress(50);
        }
       Results.ResTasks.removeAllElements();
       Results.ResAgent.removeAllElements();
       Results.Txt_Results.setText("          ---------------------------  RESULTS   FILE ----------------------------------\n\n" +
                                   "CONFIGURATION PARAMETERS: \n" +
                                   "  Standard Deviation: " + Configure.Sv + "\n" + 
                                   "  Initial Trust Level: " + Configure.initialTrustLevel + "\n\n");
       try {
    	   AgentController agc = ac.createNewAgent("COUNTER", "AgentCounter", null);
    	   agc.start();
    	   agc = ac.createNewAgent("ASSIGNER", "AgentAssigner", null);
    	   agc.start();
       } catch (Exception ce) {ce.printStackTrace();} 
       //AgentCounter Contador = new AgentCounter();
       //Contador.doStart("COUNTER");

       //AgentAssigner Asignador = new AgentAssigner();
       //Asignador.doStart("ASSIGNER");
      }
     else
      { JOptionPane.showMessageDialog(null, "You must select the tasks to simulate.", "Information", JOptionPane.WARNING_MESSAGE);
        JFileChooser chooser = new JFileChooser();
        ExampleFileFilter filter = new ExampleFileFilter();
        filter.addExtension("tsk");
        filter.setDescription("Tasks files");
        chooser.setFileFilter(filter);
        chooser.setCurrentDirectory(new File("\\"));
        int returnVal = chooser.showOpenDialog(null);
        if(returnVal == JFileChooser.APPROVE_OPTION)
        { FileTasks = chooser.getSelectedFile().getAbsolutePath(); //getName();
        	try {ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(FileTasks));
				setGlobalTasks((Vector)InTasks.readObject());	
				InTasks.close();
				JOptionPane.showMessageDialog(null, "The tasks have been loaded. Please select the 'Start simulation' option again.", "Information", JOptionPane.INFORMATION_MESSAGE);
        	} catch (IOException ioe){ System.out.println("ERROR AL CARGAR EL ARCHIVO DE TAREAS " + ioe); }
        	  catch (ClassNotFoundException cnfe){ System.out.println("ERROR POR LAS TAREAS" + cnfe); }
          Results.ResTasks.removeAllElements();
          Results.ResAgent.removeAllElements();
          Results.Txt_Results.setText("          ---------------------------  RESULTS   FILE ----------------------------------\n\n" +
                                      "CONFIGURATION PARAMETERS: \n" +
                                      "  Standard Deviation: " + Configure.Sv + "\n" + 
                                      "  Initial Trust Level: " + Configure.initialTrustLevel + "\n\n");
          AgentCounter Contador = new AgentCounter();
          //Contador.doStart("COUNTER");

          AgentAssigner Asignador = new AgentAssigner();
          //Asignador.doStart("ASSIGNER");
        }
      }
   else
     JOptionPane.showMessageDialog(null, "You must open a team before.", "Error", JOptionPane.ERROR_MESSAGE);
  contentPane.setCursor(Normal);

}


  public void Mnu_Assign_actionPerformed(ActionEvent e) {

    contentPane.setCursor(Reloj);
    JOptionPane.showMessageDialog(null, "You must select the file tasks to assign.", "Information", JOptionPane.INFORMATION_MESSAGE);
    JFileChooser chooser = new JFileChooser();
    ExampleFileFilter filter = new ExampleFileFilter();
    filter.addExtension("tsk");
    filter.setDescription("Tasks files");
    chooser.setFileFilter(filter);
    chooser.setCurrentDirectory(new File("\\"));
    int returnVal = chooser.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    { FileTasks = chooser.getSelectedFile().getAbsolutePath(); //.getName();  EN LUGAR DE OBTENER EL NOMBRE DEL ARCHIVO MEJOR TENER LAS TAREAS EN MEMORIA!!!!!!!
    	try {ObjectInputStream InTasks = new ObjectInputStream(new FileInputStream(FileTasks));
    		setGlobalTasks((Vector)InTasks.readObject());	
    		//Tasks = (Vector)InTasks.readObject();
    		InTasks.close();
    //Principal.Bloqueo = 0;
    } catch (IOException ioe){ System.out.println("ERROR AL CARGAR EL ARCHIVO DE TAREAS " + ioe); }
      catch (ClassNotFoundException cnfe){ System.out.println("ERROR POR LAS TAREAS" + cnfe); }
      boolean packFrame = false;

      Assign frame = new Assign(Agentes2, AgentesCreados);
      if (packFrame) {
         frame.pack();
      }
      else {
        frame.validate();
      }
      //Center the window
      Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
      frame.setResizable(false);
      frame.setVisible(true);
    }
    contentPane.setCursor(Normal);
}

  public void Mnu_Tareas_actionPerformed(ActionEvent e) {

  boolean packFrame = false;

  contentPane.setCursor(Reloj);
    Tareas frame = new Tareas();
    if (packFrame) {
       frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setResizable(false);
    frame.setVisible(true);
    contentPane.setCursor(Normal);
 }

 public void Mnu_All_actionPerformed(ActionEvent e) {

  boolean packFrame = false;

    Results frame = new Results(Agentes2);
    if (packFrame) {
       frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setResizable(false);
    frame.setVisible(true);
 }

  /**File | Exit action performed*/
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  /**Help | About action performed*/
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {

    boolean packFrame = false;

    About frame = new About();
    if (packFrame) {
       frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setResizable(false);
    frame.setVisible(true);
 }

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  public void Mnu_AgentEdit_actionPerformed(ActionEvent e) {

    Agentwrk Agent;

   if (Lst_TipoAgentes.getSelectedIndex() != -1)
    {Agent = (Agentwrk) Agentes2.get(Lst_TipoAgentes.getSelectedIndex());
     But_Agregar.setText("Modify Agent");
     Txt_Name.setText(Agent.getLocalName());
     Txt_Name.setEnabled(false);
     cmb_TipoAgentes.setEnabled(false);
     Lst_TipoAgentes.setEnabled(false);
     cmb_TipoAgentes.setSelectedItem(Agent.getType());
     /*if (Agent.getIntroverted())
       Opt_Introvertido.setSelected(true);
     else
       Opt_Extrovertido.setSelected(true);
     if (Agent.getAlone())
       Opt_Solo.setSelected(true);
     else
       Opt_Equipo.setSelected(true);*/
      Sld_IntExt.setValue(Agent.getIntroverted());
      Sld_AlTem.setValue(Agent.getAlone());
      Sld_Creatividad.setValue(Agent.getCreativity());
      Sld_Experiencia.setValue(Agent.getExperience());
      Sld_Deseo.setValue(Agent.getDesire());
      Sld_Interes.setValue(Agent.getInterest());
      Sld_Disgusto.setValue(Agent.getDisgust());
      Sld_Ansiedad.setValue(Agent.getAnxiety());
      Sld_Stress.setValue(Agent.getStress());
      Sld_Drive.setValue(Agent.getDrive());
      Sld_Influence.setValue(Agent.getInfluence());
      Sld_Stainess.setValue(Agent.getStainess());
      Sld_Compliance.setValue(Agent.getCompliance());
      if (Agent.getIndexPersonality() == 4)
          Opt_Analitico.setSelected(true);
        else
           if (Agent.getIndexPersonality() == 3)
             Opt_Autoritario.setSelected(true);
           else
             if (Agent.getIndexPersonality() == 2)
               Opt_Expresivo.setSelected(true);
             else
               Opt_Simpatico.setSelected(true);
     }
  }

 public void Mnu_AgentRemove_actionPerformed(ActionEvent e) {

   Agentwrk Agent;

   if (Lst_TipoAgentes.getSelectedIndex() != -1)
    {
     if(JOptionPane.showConfirmDialog(null, "Are you sure you want to delete this agent?", "Delete agent", JOptionPane.YES_NO_OPTION) == 0)
      { Agent = (Agentwrk) Agentes2.get(Lst_TipoAgentes.getSelectedIndex());
        Agent.doDelete();
        Agentes2.removeElementAt(Lst_TipoAgentes.getSelectedIndex());
        AgentesCreados.removeElementAt(Lst_TipoAgentes.getSelectedIndex());
        Lst_TipoAgentes.setListData(AgentesCreados);
     }
    }
  }

  void Mostrar_Agente(MouseEvent e) {

  String IntExt;
  String SolEq;
  String Personality;
  String FCreat, FExp, FDes, FInt, FDis, FAnx, FStr;
  String FDrive, FInfluence, FStainess, FCompliance;

    /* if(Opt_Introvertido.isSelected())
       IntExt = "Introverted";
     else
       IntExt = "Extroverted";

     if(Opt_Solo.isSelected())
       SolEq = "Prefers work alone.";
     else
       SolEq = "Prefers work in team.";*/

     if(Sld_IntExt.getValue() >= 75)
       IntExt = "High Extroverted";
     else
       if (Sld_IntExt.getValue() <= 25)
         IntExt = "High Introverted";
       else
         IntExt = "Medium Introverted/Extroverted";

     if(Sld_AlTem.getValue() >= 75)
        SolEq = "Prefers to work in team";
     else
        if (Sld_IntExt.getValue() <= 25)
          SolEq = "Prefers to work alone";
        else
          SolEq = "Prefers to work alone and in team";

     if(Opt_Analitico.isSelected())
       Personality = "Analytical.";
     else
       if(Opt_Autoritario.isSelected())
        Personality = "Driver.";
       else
         if(Opt_Expresivo.isSelected())
           Personality = "Expressive.";
         else
           Personality = "Amiable.";

     if (Sld_Experiencia.getValue() >= 66)
        FExp = "High";
     else
        if (Sld_Experiencia.getValue() <= 33)
          FExp = "Low";
        else
          FExp = "Medium";

      if (Sld_Creatividad.getValue() >= 66)
        FCreat = "High";
      else
        if (Sld_Creatividad.getValue() <= 33)
          FCreat = "Low";
        else
          FCreat = "Medium";

       if (Sld_Deseo.getValue() >= 66)
        FDes = "High";
       else
        if (Sld_Deseo.getValue() <= 33)
          FDes = "Low";
        else
          FDes = "Medium";

       if (Sld_Interes.getValue() >= 66)
        FInt = "High";
       else
        if (Sld_Interes.getValue() <= 33)
          FInt = "Low";
        else
          FInt = "Medium";

       if (Sld_Disgusto.getValue() >= 66)
        FDis = "High";
       else
        if (Sld_Disgusto.getValue() <= 33)
          FDis = "Low";
        else
          FDis = "Medium";

       if (Sld_Ansiedad.getValue() >= 66)
        FAnx = "High";
       else
        if (Sld_Ansiedad.getValue() <= 33)
          FAnx = "Low";
        else
          FAnx = "Medium";

       if (Sld_Stress.getValue() >= 66)
        FStr = "High";
       else
        if (Sld_Stress.getValue() <= 33)
          FStr = "Low";
        else
          FStr = "Medium";

        if (Sld_Drive.getValue() >= 66)
           FDrive = "High";
        else
           if (Sld_Drive.getValue() <= 33)
             FDrive = "Low";
           else
             FDrive = "Medium";

        if (Sld_Influence.getValue() >= 66)
           FInfluence = "High";
        else
           if (Sld_Influence.getValue() <= 33)
             FInfluence = "Low";
           else
             FInfluence = "Medium";

        if (Sld_Stainess.getValue() >= 66)
           FStainess = "High";
        else
           if (Sld_Stainess.getValue() <= 33)
             FStainess = "Low";
           else
             FStainess = "Medium";

        if (Sld_Compliance.getValue() >= 66)
           FCompliance = "High";
        else
           if (Sld_Compliance.getValue() <= 33)
             FCompliance = "Low";
           else
             FCompliance = "Medium";


     Txt_Caracteristicas.setText( cmb_TipoAgentes.getSelectedItem().toString() +
                                  " AGENT:   " + Txt_Name.getText() +
                                  "\nSOCIAL SKILLS:   " + IntExt + ", " + SolEq +
                                  "\nCOGNITION:   Creativity: " + FCreat +
                                  ",  Experience: " + FExp +
                                  "\nEMOTIONS:   Desire: " + FDes +
                                  ",  Interest: " + FInt +
                                  ",\n                           Disgust: " + FDis +
                                  ",  Anxiety: " + FAnx +
                                  "\nStress:   " + FStr +
                                 // "\nPERSONALITY:   " + Personality +
                                  "\nPERSONALITY:" +
                                  "\n   Driver: " + FDrive + 
                                  "\n   Expressive: " + FInfluence +
                                  "\n   Amiable: " + FStainess + 
                                  "\n   Analytical: " + FCompliance);
  }
  void Limpia_Agente(MouseEvent e) {

    LimpiaCaracteristicas();
  }

  void Crear_Agente(MouseEvent e) {

   Verifica_Personalidad();

   if (But_Agregar.getText() == "Create Agent")
      NaceAgente(true);
   else
      ModificaAgente();
   //Lst_TipoAgentes.setListData(AgentesCreados);
   LimpiaCaracteristicas();
   Lst_TipoAgentes.setListData(AgentesCreados);
 }
 public void NaceAgente(boolean createdNew){

//   try{
        //Agentwrk Agent = new Agentwrk(cmb_TipoAgentes.getSelectedItem().toString());
        //Agent.setType(cmb_TipoAgentes.getSelectedItem().toString());
        /*Agent.setIntroverted(Opt_Introvertido.isSelected());
        Agent.setAlone(Opt_Solo.isSelected());*/
	 	Object[] TpAg = new Object[15];
	 	TpAg[AGENT_TYPE] = cmb_TipoAgentes.getSelectedItem().toString();
	 	TpAg[AGENT_INTROVERTED] = Sld_IntExt.getValue();
	 	TpAg[AGENT_WORKALONE] = Sld_AlTem.getValue();
	 	TpAg[AGENT_CREATIVITY] = Sld_Creatividad.getValue();
	 	TpAg[AGENT_EXPERIENCE] = Sld_Experiencia.getValue();
	 	TpAg[AGENT_DESIRE] = 50;
	 	TpAg[AGENT_INTEREST] = 50;
	 	TpAg[AGENT_DISGUST] = 50;
	 	TpAg[AGENT_ANXIETY] = 50;
	 	TpAg[AGENT_STRESS] = 50;
	 	TpAg[AGENT_DRIVER] = Sld_Drive.getValue();
	 	TpAg[AGENT_INFLUENCE] = Sld_Influence.getValue();
	 	TpAg[AGENT_STEADINESS] = Sld_Stainess.getValue();
	 	TpAg[AGENT_COMPLIANCE] = Sld_Compliance.getValue();
	 	if(Opt_Analitico.isSelected())
	 		TpAg[AGENT_PERSONALITY] = "Analytical";
	        else
	          if(Opt_Autoritario.isSelected())
	        	  TpAg[AGENT_PERSONALITY] = "Driver";
	          else
	            if(Opt_Expresivo.isSelected())
	            	TpAg[AGENT_PERSONALITY] = "Expressive";
	            else
	            	TpAg[AGENT_PERSONALITY] = "Amiable";
	 	
        /*Agent.setIntroverted(Sld_IntExt.getValue());
        Agent.setAlone(Sld_AlTem.getValue());
        Agent.setCreativity(Sld_Creatividad.getValue());
        Agent.setExperience(Sld_Experiencia.getValue());
        Agent.setDesire(50);   //Sld_Deseo.getValue());
        Agent.setInterest(50); //Sld_Interes.getValue());
        Agent.setDisgust(50);  //Sld_Disgusto.getValue());
        Agent.setAnxiety(50);  //Sld_Ansiedad.getValue());
        Agent.setStress(50);   //Sld_Stress.getValue());
        Agent.setDrive(Sld_Drive.getValue());
        Agent.setInfluence(Sld_Influence.getValue());
        Agent.setStainess(Sld_Stainess.getValue());
        Agent.setCompliance(Sld_Compliance.getValue());
        if(Opt_Analitico.isSelected())
          Agent.setPersonality("Analytical");
        else
          if(Opt_Autoritario.isSelected())
           Agent.setPersonality("Driver");
          else
            if(Opt_Expresivo.isSelected())
              Agent.setPersonality("Expressive");
            else
              Agent.setPersonality("Amiable");
        Object[] TpAg = new String[1];
        TpAg[0] = cmb_TipoAgentes.getSelectedItem().toString();
        /*Agentwrk Agent = (Agentwrk) Interfaz.Container.createNewAgent(Txt_Name.getText(), "Agentwrk", TpAg); //.start();
        Agent.doActivate();
        PF.createNewAgent(Txt_Name.getText(), "Agentwrk", null).start();*/
        //Agent.doStart(Txt_Name.getText());
        
        try {
        	//AgentContainer cc = Agent.getContainerController();
        	AgentController agc = ac.createNewAgent(Txt_Name.getText(), "Agentwrk", TpAg);
        	agc.start();
        	
        
        	//Agentes2.addElement(agc);
        	if (createdNew)
        		AgentesCreados.addElement(cmb_TipoAgentes.getSelectedItem() + " --> " + Txt_Name.getText());
    } catch (Exception ce) {ce.printStackTrace();}
 }

 public void ModificaAgente(){

  Agentwrk Agent = (Agentwrk) Agentes2.get(Lst_TipoAgentes.getSelectedIndex());
  Txt_Name.setEnabled(true);
  cmb_TipoAgentes.setEnabled(true);
  Lst_TipoAgentes.setEnabled(true);
  But_Agregar.setText("Create Agent");
  Agent.setType(cmb_TipoAgentes.getSelectedItem().toString());
  /*Agent.setIntroverted(Opt_Introvertido.isSelected());
  Agent.setAlone(Opt_Solo.isSelected());*/
  Agent.setIntroverted(Sld_IntExt.getValue());
  Agent.setAlone(Sld_AlTem.getValue());
  Agent.setCreativity(Sld_Creatividad.getValue());
  Agent.setExperience(Sld_Experiencia.getValue());
  Agent.setDesire(Sld_Deseo.getValue());
  Agent.setInterest(Sld_Interes.getValue());
  Agent.setDisgust(Sld_Disgusto.getValue());
  Agent.setAnxiety(Sld_Ansiedad.getValue());
  Agent.setStress(Sld_Stress.getValue());
  Agent.setDrive(Sld_Drive.getValue());
  Agent.setInfluence(Sld_Influence.getValue());
  Agent.setStainess(Sld_Stainess.getValue());
  Agent.setCompliance(Sld_Compliance.getValue());
  if(Opt_Analitico.isSelected())
    Agent.setPersonality("Analytical");
  else
    if(Opt_Autoritario.isSelected())
      Agent.setPersonality("Driver");
    else
      if(Opt_Expresivo.isSelected())
        Agent.setPersonality("Expressive");
      else
        Agent.setPersonality("Amiable");
 Agentes2.setElementAt(Agent, Lst_TipoAgentes.getSelectedIndex());
 AgentesCreados.setElementAt(cmb_TipoAgentes.getSelectedItem() + " --> " + Txt_Name.getText(), Lst_TipoAgentes.getSelectedIndex());
}

 public void Verifica_Personalidad(){  // Metodo para verificar que los parametros CLEAVER corresponden con el tipo de Personalidad

  int CLVPty;  //Variable para saber el tipo de personalidad a partir de los valores CLEAVER:
               // 1.- (Drive) Driver, 2.- (Influence) Expressive, 3.- (Stainess) Amiable, 4.- (Compliance) Analytical

   if (Sld_Drive.getValue() > Sld_Influence.getValue())
     if (Sld_Drive.getValue() > Sld_Stainess.getValue())
       if (Sld_Drive.getValue() > Sld_Compliance.getValue())
          CLVPty = 1;
       else
          CLVPty = 4;
     else
        if (Sld_Stainess.getValue() > Sld_Compliance.getValue())
          CLVPty = 3;
        else
          CLVPty = 4;
   else
      if (Sld_Influence.getValue() > Sld_Stainess.getValue())
         if (Sld_Influence.getValue() > Sld_Compliance.getValue())
           CLVPty = 2;
         else
           CLVPty = 4;
      else
         if (Sld_Stainess.getValue() > Sld_Compliance.getValue())
           CLVPty = 3;
         else
           CLVPty = 4;

    switch(CLVPty) {
      case 1:
           if(!Opt_Autoritario.isSelected())
             if(JOptionPane.showConfirmDialog(null, "According to CLEAVER parameters, the most suitable personality type for this agent is DRIVER.\n Do you want to change it?", "Question", JOptionPane.YES_NO_OPTION) == 0)
               Opt_Autoritario.setSelected(true);
           break;
      case 2:
           if(!Opt_Expresivo.isSelected())
             if(JOptionPane.showConfirmDialog(null, "According to CLEAVER parameters, the most suitable personality type for this agent is EXPRESSIVE.\n Do you want to change it?", "Question", JOptionPane.YES_NO_OPTION) == 0)
               Opt_Expresivo.setSelected(true);
           break;
      case 3:
           if(!Opt_Simpatico.isSelected())
             if(JOptionPane.showConfirmDialog(null, "According to CLEAVER parameters, the most suitable personality type for this agent is AMIABLE.\n Do you want to change it?", "Question", JOptionPane.YES_NO_OPTION) == 0)
               Opt_Simpatico.setSelected(true);
           break;
      case 4:
           if(!Opt_Analitico.isSelected())
             if(JOptionPane.showConfirmDialog(null, "According to CLEAVER parameters, the most suitable personality type for this agent is ANALYTICAL.\n Do you want to change it?", "Question", JOptionPane.YES_NO_OPTION) == 0)
               Opt_Analitico.setSelected(true);
           break;
    }
 }
 
private void LimpiaCaracteristicas(){
     cmb_TipoAgentes.setSelectedItem("PROJECT MANAGER");
     /*Opt_Introvertido.setSelected(true);
     Opt_Solo.setSelected(true);*/
     Sld_IntExt.setValue(0);
     Sld_AlTem.setValue(0);
     Sld_Creatividad.setValue(0);
     Sld_Experiencia.setValue(0);
     Sld_Deseo.setValue(50);
     Sld_Interes.setValue(50);
     Sld_Disgusto.setValue(50);
     Sld_Ansiedad.setValue(50);
     Sld_Stress.setValue(50);
     Sld_Drive.setValue(0);
     Sld_Influence.setValue(0);
     Sld_Stainess.setValue(0);
     Sld_Compliance.setValue(0);
     Opt_Analitico.setSelected(true);
     Txt_Name.setText("");
     Txt_Caracteristicas.setText("");
   }

class PopupListener extends MouseAdapter {
        public void mousePressed(MouseEvent e) {
            MuestraMenu(e);
        }

        public void mouseReleased(MouseEvent e) {
            MuestraMenu(e);
        }

   private void MuestraMenu(MouseEvent e) {
      if (e.isPopupTrigger())
         Pop_OptsAgentes.show(e.getComponent(), e.getX(), e.getY());
     }
  }

  void Sld_Drive_stateChanged(ChangeEvent e) {

    Integer Valor = new Integer(Sld_Drive.getValue());
    Sld_Drive.setToolTipText(Valor.toString());
  }

  void Sld_Influence_stateChanged(ChangeEvent e) {

    Integer Valor = new Integer(Sld_Influence.getValue());
    Sld_Influence.setToolTipText(Valor.toString());
  }

  void Sld_Stainess_stateChanged(ChangeEvent e) {

    Integer Valor = new Integer(Sld_Stainess.getValue());
    Sld_Stainess.setToolTipText(Valor.toString());
  }

  void Sld_Compliance_stateChanged(ChangeEvent e) {

    Integer Valor = new Integer(Sld_Compliance.getValue());
    Sld_Compliance.setToolTipText(Valor.toString());
  }

public static Vector getAgentes2() {
	return Agentes2;
}

public static void setAgentes2(Vector agentes2) {
	Agentes2 = agentes2;
}

public static Vector getGlobalTasks() {
	return GlobalTasks;
}

public static void setGlobalTasks(Vector globalTasks) {
	GlobalTasks = globalTasks;
}



}