/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class that represents the configuration of the relation
among the agent internal parameters and the generated task parameters.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/

import java.util.*;
import java.io.*;

  public class Relations implements Serializable {

    String TskDurLowCreat;
    String TskQtyLowCreat;
    String TskDurMedCreat;
    String TskQtyMedCreat;
    String TskDurHghCreat;
    String TskQtyHghCreat;
    String TskDurLowExprn;
    String TskQtyLowExprn;
    String TskDurMedExprn;
    String TskQtyMedExprn;
    String TskDurHghExprn;
    String TskQtyHghExprn;
    String TskDurLowDesir;
    String TskQtyLowDesir;
    String TskDurMedDesir;
    String TskQtyMedDesir;
    String TskDurHghDesir;
    String TskQtyHghDesir;
    String TskDurLowInter;
    String TskQtyLowInter;
    String TskDurMedInter;
    String TskQtyMedInter;
    String TskDurHghInter;
    String TskQtyHghInter;
    String TskDurLowDisgs;
    String TskQtyLowDisgs;
    String TskDurMedDisgs;
    String TskQtyMedDisgs;
    String TskDurHghDisgs;
    String TskQtyHghDisgs;
    String TskDurLowAnxty;
    String TskQtyLowAnxty;
    String TskDurMedAnxty;
    String TskQtyMedAnxty;
    String TskDurHghAnxty;
    String TskQtyHghAnxty;
    String TskDurLowStrss;
    String TskQtyLowStrss;
    String TskDurMedStrss;
    String TskQtyMedStrss;
    String TskDurHghStrss;
    String TskQtyHghStrss;

    public Relations(){}

    public void setDefault(){

      this.TskDurLowCreat = "Normal";
      this.TskDurMedCreat = "Medium_Advance";
      this.TskDurHghCreat = "High_Advance";
      this.TskQtyLowCreat = "Medium_Decrease";
      this.TskQtyMedCreat = "Normal";
      this.TskQtyHghCreat = "Medium_Increase";
      this.TskDurLowExprn = "Medium_Delay";
      this.TskQtyLowExprn = "Medium_Decrease";
      this.TskDurMedExprn = "Normal";
      this.TskQtyMedExprn = "Normal";
      this.TskDurHghExprn = "Medium_Advance";
      this.TskQtyHghExprn = "High_Increase";
      this.TskDurLowDesir = "Medium_Delay";
      this.TskQtyLowDesir = "Medium_Decrease";
      this.TskDurMedDesir = "Normal";
      this.TskQtyMedDesir = "Normal";
      this.TskDurHghDesir = "High_Advance";
      this.TskQtyHghDesir = "Medium_Increase";
      this.TskDurLowInter = "High_Delay";
      this.TskQtyLowInter = "Medium_Decrease";
      this.TskDurMedInter = "Normal";
      this.TskQtyMedInter = "Normal";
      this.TskDurHghInter = "High_Advance";
      this.TskQtyHghInter = "Medium_Increase";
      this.TskDurLowDisgs = "Normal";
      this.TskQtyLowDisgs = "Normal";
      this.TskDurMedDisgs = "Medium_Delay";
      this.TskQtyMedDisgs = "Medium_Decrease";
      this.TskDurHghDisgs = "High_Delay";
      this.TskQtyHghDisgs = "High_Decrease";
      this.TskDurLowAnxty = "Normal";
      this.TskQtyLowAnxty = "Normal";
      this.TskDurMedAnxty = "Medium_Delay";
      this.TskQtyMedAnxty = "Medium_Decrease";
      this.TskDurHghAnxty = "High_Delay";
      this.TskQtyHghAnxty = "High_Decrease";
      this.TskDurLowStrss = "Normal";
      this.TskQtyLowStrss = "Normal";
      this.TskDurMedStrss = "Medium_Delay";
      this.TskQtyMedStrss = "Medium_Decrease";
      this.TskDurHghStrss = "High_Delay";
      this.TskQtyHghStrss = "High_Decrease";
    }

    public void setTskDurLowCreat(String Str){

       this.TskDurLowCreat = Str;
    }

    public void setTskDurMedCreat(String Str){

       this.TskDurMedCreat = Str;
    }

    public void setTskDurHghCreat(String Str){

       this.TskDurHghCreat = Str;
    }

    public void setTskQtyLowCreat(String Str){

       this.TskQtyLowCreat = Str;
    }

    public void setTskQtyMedCreat(String Str){

       this.TskQtyMedCreat = Str;
    }

    public void setTskQtyHghCreat(String Str){

       this.TskQtyHghCreat = Str;
    }

    public String getTskDurLowCreat(){

       return this.TskDurLowCreat;
    }

    public String getTskDurMedCreat(){

       return this.TskDurMedCreat;
    }

    public String getTskDurHghCreat(){

       return this.TskDurHghCreat;
    }

    public String getTskQtyLowCreat(){

       return this.TskQtyLowCreat;
    }

    public String getTskQtyMedCreat(){

       return this.TskQtyMedCreat;
    }

    public String getTskQtyHghCreat(){

       return this.TskQtyHghCreat;
    }

    public void setTskDurLowExprn(String Str){

       this.TskDurLowExprn = Str;
    }

    public void setTskDurMedExprn(String Str){

       this.TskDurMedExprn = Str;
    }

    public void setTskDurHghExprn(String Str){

       this.TskDurHghExprn = Str;
    }

    public void setTskQtyLowExprn(String Str){

       this.TskQtyLowExprn = Str;
    }

    public void setTskQtyMedExprn(String Str){

       this.TskQtyMedExprn = Str;
    }

    public void setTskQtyHghExprn(String Str){

       this.TskQtyHghExprn = Str;
    }

    public String getTskDurLowExprn(){

       return this.TskDurLowExprn;
    }

    public String getTskDurMedExprn(){

       return this.TskDurMedExprn;
    }

    public String getTskDurHghExprn(){

       return this.TskDurHghExprn;
    }

    public String getTskQtyLowExprn(){

       return this.TskQtyLowExprn;
    }

    public String getTskQtyMedExprn(){

       return this.TskQtyMedExprn;
    }

    public String getTskQtyHghExprn(){

       return this.TskQtyHghExprn;
    }

     public void setTskDurLowDesir(String Str){

       this.TskDurLowDesir = Str;
    }

    public void setTskDurMedDesir(String Str){

       this.TskDurMedDesir = Str;
    }

    public void setTskDurHghDesir(String Str){

       this.TskDurHghDesir = Str;
    }

    public void setTskQtyLowDesir(String Str){

       this.TskQtyLowDesir = Str;
    }

    public void setTskQtyMedDesir(String Str){

       this.TskQtyMedDesir = Str;
    }

    public void setTskQtyHghDesir(String Str){

       this.TskQtyHghDesir = Str;
    }

    public String getTskDurLowDesir(){

       return this.TskDurLowDesir;
    }

    public String getTskDurMedDesir(){

       return this.TskDurMedDesir;
    }

    public String getTskDurHghDesir(){

       return this.TskDurHghDesir;
    }

    public String getTskQtyLowDesir(){

       return this.TskQtyLowDesir;
    }

    public String getTskQtyMedDesir(){

       return this.TskQtyMedDesir;
    }

    public String getTskQtyHghDesir(){

       return this.TskQtyHghDesir;
    }

    public void setTskDurLowInter(String Str){

       this.TskDurLowInter = Str;
    }

    public void setTskDurMedInter(String Str){

       this.TskDurMedInter = Str;
    }

    public void setTskDurHghInter(String Str){

       this.TskDurHghInter = Str;
    }

    public void setTskQtyLowInter(String Str){

       this.TskQtyLowInter = Str;
    }

    public void setTskQtyMedInter(String Str){

       this.TskQtyMedInter = Str;
    }

    public void setTskQtyHghInter(String Str){

       this.TskQtyHghInter = Str;
    }

    public String getTskDurLowInter(){

       return this.TskDurLowInter;
    }

    public String getTskDurMedInter(){

       return this.TskDurMedInter;
    }

    public String getTskDurHghInter(){

       return this.TskDurHghInter;
    }

    public String getTskQtyLowInter(){

       return this.TskQtyLowInter;
    }

    public String getTskQtyMedInter(){

       return this.TskQtyMedInter;
    }

    public String getTskQtyHghInter(){

       return this.TskQtyHghInter;
    }

    public void setTskDurLowDisgs(String Str){

       this.TskDurLowDisgs = Str;
    }

    public void setTskDurMedDisgs(String Str){

       this.TskDurMedDisgs = Str;
    }

    public void setTskDurHghDisgs(String Str){

       this.TskDurHghDisgs = Str;
    }

    public void setTskQtyLowDisgs(String Str){

       this.TskQtyLowDisgs = Str;
    }

    public void setTskQtyMedDisgs(String Str){

       this.TskQtyMedDisgs = Str;
    }

    public void setTskQtyHghDisgs(String Str){

       this.TskQtyHghDisgs = Str;
    }

    public String getTskDurLowDisgs(){

       return this.TskDurLowDisgs;
    }

    public String getTskDurMedDisgs(){

       return this.TskDurMedDisgs;
    }

    public String getTskDurHghDisgs(){

       return this.TskDurHghDisgs;
    }

    public String getTskQtyLowDisgs(){

       return this.TskQtyLowDisgs;
    }

    public String getTskQtyMedDisgs(){

       return this.TskQtyMedDisgs;
    }

    public String getTskQtyHghDisgs(){

       return this.TskQtyHghDisgs;
    }

    public void setTskDurLowAnxty(String Str){

       this.TskDurLowAnxty = Str;
    }

    public void setTskDurMedAnxty(String Str){

       this.TskDurMedAnxty = Str;
    }

    public void setTskDurHghAnxty(String Str){

       this.TskDurHghAnxty = Str;
    }

    public void setTskQtyLowAnxty(String Str){

       this.TskQtyLowAnxty = Str;
    }

    public void setTskQtyMedAnxty(String Str){

       this.TskQtyMedAnxty = Str;
    }

    public void setTskQtyHghAnxty(String Str){

       this.TskQtyHghAnxty = Str;
    }

    public String getTskDurLowAnxty(){

       return this.TskDurLowAnxty;
    }

    public String getTskDurMedAnxty(){

       return this.TskDurMedAnxty;
    }

    public String getTskDurHghAnxty(){

       return this.TskDurHghAnxty;
    }

    public String getTskQtyLowAnxty(){

       return this.TskQtyLowAnxty;
    }

    public String getTskQtyMedAnxty(){

       return this.TskQtyMedAnxty;
    }

    public String getTskQtyHghAnxty(){

       return this.TskQtyHghAnxty;
    }

    public void setTskDurLowStrss(String Str){

       this.TskDurLowStrss = Str;
    }

    public void setTskDurMedStrss(String Str){

       this.TskDurMedStrss = Str;
    }

    public void setTskDurHghStrss(String Str){

       this.TskDurHghStrss = Str;
    }

    public void setTskQtyLowStrss(String Str){

       this.TskQtyLowStrss = Str;
    }

    public void setTskQtyMedStrss(String Str){

       this.TskQtyMedStrss = Str;
    }

    public void setTskQtyHghStrss(String Str){

       this.TskQtyHghStrss = Str;
    }

    public String getTskDurLowStrss(){

       return this.TskDurLowStrss;
    }

    public String getTskDurMedStrss(){

       return this.TskDurMedStrss;
    }

    public String getTskDurHghStrss(){

       return this.TskDurHghStrss;
    }

    public String getTskQtyLowStrss(){

       return this.TskQtyLowStrss;
    }

    public String getTskQtyMedStrss(){

       return this.TskQtyMedStrss;
    }

    public String getTskQtyHghStrss(){

       return this.TskQtyHghStrss;
    }



}