/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class for showing the results of the simulations.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.io.*;
import java.util.*;
import java.text.*;
import java.awt.*;
import java.awt.font.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class Results extends JFrame {


  JPanel contentPane;
  JScrollPane Scl_Results = new JScrollPane();
  public static JTextArea Txt_Results = new JTextArea();
  public static Vector ResTasks = new Vector(1,1);
  public static Vector ResAgent = new Vector(1,1);     //AQUI SE GUARDAN LAS TAREAS HECHAS POR CADA AGENTE (DESDE AGENTWRKBEHAVIOUR)
  public static Vector ResTrust = new Vector(1,1);
  public static Vector AveragesTrust = new Vector(1,1);
  int DurQty;
  Vector Averages = new Vector(1,1);
  Vector CoordenadaX = new Vector(1,1);
  Vector CoordenadaY = new Vector(1,1);
  Vector AgentsTots;
  String Nombre = "";
  Cursor Normal = new Cursor(0);
  Cursor Reloj = new Cursor(3);
  JMenuBar Mnu_Bar = new JMenuBar();
  JMenu Mnu_File = new JMenu();
  JMenuItem Mnu_Open = new JMenuItem();
  JMenuItem Mnu_Close = new JMenuItem();
  JMenuItem Mnu_Save = new JMenuItem();
  JMenuItem Mnu_Exit = new JMenuItem();
  JMenu Mnu_Results = new JMenu();
  JMenuItem Mnu_Tasks = new JMenuItem();
  JMenuItem Mnu_TasksQ = new JMenuItem();
  JMenuItem Mnu_TrustResults = new JMenuItem();
  JMenuItem Mnu_AgentTasks = new JMenu();
  JMenuItem Mnu_AgentQuality = new JMenuItem();
  JMenuItem Mnu_AgentDuration = new JMenuItem();
  JMenuItem Mnu_AgentGoals = new JMenuItem();
  JMenuItem Mnu_AgentTeamColl = new JMenuItem();
  JMenuItem Mnu_AgentIndividualCont = new JMenuItem();
  JMenuItem Mnu_AgentSupervisionLevel = new JMenuItem();

  /**Construct the frame*/
  public Results(Vector Ags) {
   try {
      this.AgentsTots = Ags;
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    if (Txt_Results.getText().equalsIgnoreCase(""))
      Mnu_Save.setEnabled(false);
    else
      Mnu_Save.setEnabled(true);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Principal.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.setResizable(false);
    this.setSize(new Dimension(663, 591));
    this.setTitle("Simulation Results");
    contentPane.setPreferredSize(new Dimension(1, 1));
    Scl_Results.setBounds(new Rectangle(4, 6, 651, 530));
    Txt_Results.setForeground(Color.blue);
    Txt_Results.setEditable(false);
    Txt_Results.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        Txt_Results_mouseClicked(e);
      }
    });
    contentPane.add(Scl_Results, null);
    Scl_Results.getViewport().add(Txt_Results, null);
    Mnu_File.setText("File");
    Mnu_Open.setText("Open results file");
    Mnu_Open.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        try {
             Mnu_Open_actionPerformed(e);
            }
        catch ( IOException e1 ) { System.out.println("ERROR EN RESULTS 97 " + e1); }
        catch ( ClassNotFoundException e2 ) { System.out.println("ERROR EN RESULTS 98 " + e2); }
      }
    });

    Mnu_Save.setText("Save results");
    Mnu_Save.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
       try {
            Mnu_Save_actionPerformed(e);
           }
       catch ( IOException e1 ) { System.out.println("ERROR EN RESULTS 107 " + e1);}
      }
    });

    Mnu_Exit.setText("Exit");
    Mnu_Exit.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        Mnu_Exit_actionPerformed(e);
      }
    });
    Mnu_Results.setText("Show results");
    Mnu_Tasks.setText("Timeliness Project Results");
    Mnu_Tasks.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 1;
        Mnu_Tasks_actionPerformed(e);
      }
    });
    Mnu_TasksQ.setText("Project Quality");
    Mnu_TasksQ.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 2;
        Mnu_Tasks_actionPerformed(e);
      }
    });
    
    Mnu_TrustResults.setText("Trust Evolution");
    Mnu_TrustResults.addActionListener(new ActionListener()  {
        public void actionPerformed(ActionEvent e) {
          Mnu_TrustResults_actionPerformed(e);
        }
      });
    
    Mnu_AgentTasks.setText("Agent Behaviour");
    Mnu_AgentQuality.setText("Quality");
    Mnu_AgentQuality.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 3;
        Mnu_AgentQuality_actionPerformed(e);
      }
    });
    Mnu_AgentDuration.setText("Results Oportunity");
    Mnu_AgentDuration.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 4;
        Mnu_AgentDuration_actionPerformed(e);
      }
    });
    Mnu_AgentGoals.setText("Goals Achievement");
    Mnu_AgentGoals.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 5;
        Mnu_AgentGoals_actionPerformed(e);
      }
    });

    Mnu_AgentTeamColl.setText("Team Collaboration Level");
    Mnu_AgentTeamColl.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 6;
        Mnu_AgentTeamColl_actionPerformed(e);
      }
    });

    Mnu_AgentIndividualCont.setText("Individual Contribution Level");
    Mnu_AgentIndividualCont.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 7;
        Mnu_AgentIndividualCont_actionPerformed(e);
      }
    });

    Mnu_AgentSupervisionLevel.setText("Required Supervision Level");
    Mnu_AgentSupervisionLevel.addActionListener(new ActionListener()  {
      public void actionPerformed(ActionEvent e) {
        DurQty = 8;
        Mnu_AgentSupervisionLevel_actionPerformed(e);
      }
    });

    Mnu_File.add(Mnu_Open);
    Mnu_File.add(Mnu_Save);
    Mnu_File.addSeparator();
    Mnu_File.add(Mnu_Exit);
    Mnu_Results.add(Mnu_AgentTasks);
    Mnu_Results.addSeparator();
    Mnu_Results.add(Mnu_Tasks);
    Mnu_Results.add(Mnu_TasksQ);
    Mnu_Results.addSeparator();
    Mnu_Results.add(Mnu_TrustResults);
    Mnu_AgentTasks.add(Mnu_AgentDuration);
    Mnu_AgentTasks.add(Mnu_AgentQuality);
    Mnu_AgentTasks.add(Mnu_AgentGoals);
    Mnu_AgentTasks.add(Mnu_AgentTeamColl);
    Mnu_AgentTasks.add(Mnu_AgentIndividualCont);
    Mnu_AgentTasks.add(Mnu_AgentSupervisionLevel);
    Mnu_Bar.add(Mnu_File);
    Mnu_Bar.add(Mnu_Results);
    this.setJMenuBar(Mnu_Bar);
  }


 public void paint (Graphics g){

    super.paint (g);

     switch (DurQty)
     { case 1:
         PaintTasksDuration(Averages);
         break;
       case 2:
         PaintTasksQuality(Averages);
         break;
       case 3:
         PaintAgentQuality(Averages, Nombre);
         break;
       case 4:
         PaintAgentDuration(Averages, Nombre);
         break;
       case 5:
         PaintAgentGoals(Averages, Nombre);
         break;
       case 6:
         PaintAgentTeamCollaboration(Averages, Nombre);
         break;
       case 7:
         PaintAgentIndividualContribution(Averages, Nombre);
         break;
       case 8:
         PaintAgentRequiredSupervision(Averages, Nombre);
         break;
     }
}  // FIN PAINT



  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
      this.dispose();
  }

  public void Mnu_Open_actionPerformed(ActionEvent e) throws IOException, ClassNotFoundException{

    JFileChooser chooser = new JFileChooser();
    ExampleFileFilter filter = new ExampleFileFilter();
    String line = null;
    filter.addExtension("rst");
    filter.setDescription("Results files");
    chooser.setFileFilter(filter);
    chooser.setCurrentDirectory(new File("\\"));
    int returnVal = chooser.showOpenDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      setCursor(Reloj);

      /*BufferedReader In = new BufferedReader(new FileReader(chooser.getSelectedFile().getName()));
      Txt_Results.setText(" ");
      String RsltTxt;
      while ((RsltTxt = In.readLine()) != null) {
           Txt_Results.append(RsltTxt + "\n");
      }
      In.close(); */

      String FileName = chooser.getSelectedFile().getName();

      ObjectInputStream InResults = new ObjectInputStream(new FileInputStream(FileName));
      ResTasks = (Vector)InResults.readObject();
      InResults.close();

      ObjectInputStream InRstAgs = new ObjectInputStream(new FileInputStream(FileName.substring(0,FileName.indexOf(".")) + ".agr"));
      ResAgent = (Vector)InRstAgs.readObject();
      InRstAgs.close();
      
      ObjectInputStream InRstTrst = new ObjectInputStream(new FileInputStream(FileName.substring(0,FileName.indexOf(".")) + ".tra"));
      AveragesTrust = (Vector)InRstTrst.readObject();
      InRstTrst.close();

      ResTrust.clear();
      BufferedReader InRstTrstAv =  new BufferedReader(new FileReader(FileName.substring(0,FileName.indexOf(".")) + ".trh"));
      while (( line = InRstTrstAv.readLine()) != null){
    	  ResTrust.addElement(line + "\n");
      }
      InRstTrstAv.close();

      Mnu_Save.setEnabled(false);
      Txt_Results.setText(" ");
      Txt_Results.setText(" ***************** RESTORED DATA *****************");
      setCursor(Normal);
    }
  }

  public void Mnu_Save_actionPerformed(ActionEvent e) throws IOException{

   Principal.contentPane.setCursor(Reloj);

    JFileChooser chooser = new JFileChooser();
    ExampleFileFilter filter = new ExampleFileFilter();
    filter.addExtension("rst");
    filter.setDescription("Results files");
    chooser.setFileFilter(filter);
    chooser.setCurrentDirectory(new File("\\"));
    int returnVal = chooser.showSaveDialog(null);
    if(returnVal == JFileChooser.APPROVE_OPTION)
    {
      /*FileWriter Out2 = new FileWriter(chooser.getSelectedFile().getName());
      Out2.write(Txt_Results.getText());
      Out2.close();*/
      String FileName = chooser.getSelectedFile().getName();
      ObjectOutputStream OutResults = new ObjectOutputStream(new FileOutputStream(FileName));
      ObjectOutputStream OutRstAgs = new ObjectOutputStream(new FileOutputStream(FileName.substring(0,FileName.indexOf(".")) + ".agr"));
      ObjectOutputStream OutRstTrst = new ObjectOutputStream(new FileOutputStream(FileName.substring(0,FileName.indexOf(".")) + ".tra"));
      BufferedWriter OutRstAvg = new BufferedWriter(new FileWriter(FileName.substring(0,FileName.indexOf(".")) + ".trh"));
      OutResults.writeObject(ResTasks);
      OutRstAgs.writeObject(ResAgent);
      OutRstTrst.writeObject(AveragesTrust);
      OutResults.close();
      OutRstAgs.close();
      OutRstTrst.close();
      for (int i=0; i<ResTrust.size(); i++)
    	  OutRstAvg.write((String)ResTrust.get(i));
      OutRstAvg.close();
    }
  Principal.contentPane.setCursor(Normal);
  }


 public void Mnu_Exit_actionPerformed(ActionEvent e){

    this.dispose();
 }

 public void Mnu_Tasks_actionPerformed(ActionEvent e){

      if (Results.ResTasks.size() > 0)
       { Averages.removeAllElements();
         AuxResults AxR, PromAR;
         AxR = (AuxResults) Results.ResTasks.lastElement();
         int TotSim = AxR.NumSimulacion;
         boolean Existe = false;
         for (int s=1; s<=TotSim; s++)
         { for (int tam=0; tam<Results.ResTasks.size(); tam++)
           { AxR = (AuxResults) Results.ResTasks.get(tam);
             if (AxR.NumSimulacion == s)
             { if (Averages.size() == 0)
               { PromAR = new AuxResults(TotSim, AxR.TSName, AxR.QualityTask, AxR.DurationTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
                 Averages.addElement(PromAR);
               }
               else
               { Existe = false;
                 for(int i=0; i<Averages.size(); i++)
                 { PromAR = (AuxResults)Averages.get(i);
                   if (PromAR.TSName.equals(AxR.TSName))
                   { PromAR.SumaDurQty(AxR.DurationTask, AxR.QualityTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
                     Averages.set(i, PromAR);
                     Existe = true;
                   }
                 }
                 if (!Existe)
                 { PromAR = new AuxResults(TotSim, AxR.TSName, AxR.QualityTask, AxR.DurationTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
                   Averages.addElement(PromAR);
                 }
               }
             }
           }
         }
         Graphics Cuad = Txt_Results.getGraphics();
         Cuad.setColor(Color.white);
         Cuad.fillRect(0, 0, 650, 520);
         if (DurQty == 1)
          PaintTasksDuration(Averages);
         else
           if (DurQty == 2)
             PaintTasksQuality(Averages);
       }
 }

 public void Mnu_AgentDuration_actionPerformed(ActionEvent e){

   if (AgentsTots.size() > 0)
   {
     SelectAgent();
     PaintAgentDuration(Averages, Nombre);
   }
 }

 public void Mnu_AgentQuality_actionPerformed(ActionEvent e){

   if (AgentsTots.size() > 0)
     { SelectAgent();
       PaintAgentQuality(Averages, Nombre);
     }
 }

 public void Mnu_AgentGoals_actionPerformed(ActionEvent e){

   if (AgentsTots.size() > 0)
     { SelectAgent();
       PaintAgentGoals(Averages, Nombre);
     }
 }

 public void Mnu_AgentTeamColl_actionPerformed(ActionEvent e){

   if (AgentsTots.size() > 0)
     { SelectAgent();
       PaintAgentTeamCollaboration(Averages, Nombre);
     }
 }

 public void Mnu_AgentIndividualCont_actionPerformed(ActionEvent e){

   if (AgentsTots.size() > 0)
     { SelectAgent();
       PaintAgentIndividualContribution(Averages, Nombre);
     }
 }

 public void Mnu_AgentSupervisionLevel_actionPerformed(ActionEvent e){

    if (AgentsTots.size() > 0)
      { SelectAgent();
        PaintAgentRequiredSupervision(Averages, Nombre);
      }
  }

 public void Mnu_TrustResults_actionPerformed(ActionEvent e){
	 
	 Vector auxTrustAverages = new Vector(1,1);
	 AuxResults tempResults, sumResults;
	 Iterator it;
	 boolean found = false;

	 setCursor(Reloj);
	   if (ResTrust.size()> 0){
		   Txt_Results.setText("");
		   for (int i=0; i<ResTrust.size(); i++)
			   Txt_Results.append((String)ResTrust.get(i));
		   Txt_Results.append("\n\n***************** AVERAGES *********************\n");
		   tempResults = (AuxResults)AveragesTrust.lastElement();
		   int NumSimulations = tempResults.NumSimulacion;
		   for (int i=0; i<AveragesTrust.size(); i++){
			   tempResults = (AuxResults)AveragesTrust.get(i);
			   if (auxTrustAverages.isEmpty())
				   auxTrustAverages.add(tempResults);
			   else{
				   for(int j=0; j<auxTrustAverages.size(); j++){
					   sumResults = (AuxResults)auxTrustAverages.get(j);
					   if (sumResults.TSName.equalsIgnoreCase(tempResults.TSName) && sumResults.Owner.equalsIgnoreCase(tempResults.Owner)){
						   it = tempResults.trustValues.keySet().iterator();
						   String teamMate = it.next().toString();
						   if (sumResults.trustValues.containsKey(teamMate)){
							   sumResults.trustValues.put(teamMate, sumResults.trustValues.get(teamMate) + tempResults.trustValues.get(teamMate));
							   auxTrustAverages.remove(j);
							   auxTrustAverages.insertElementAt(sumResults, j);
							   found = true;
						   }
					   }
				   }
				   if (! found)
					   auxTrustAverages.add(tempResults);
			   }
		   }
		   for (int i=0; i<auxTrustAverages.size(); i++){
			   sumResults = (AuxResults)auxTrustAverages.get(i);
			   it = sumResults.trustValues.keySet().iterator();
			   String teamMate = it.next().toString();
			   double avg = sumResults.trustValues.get(teamMate) / NumSimulations;
			   sumResults.trustValues.put(teamMate, avg);
			   auxTrustAverages.remove(i);
			   auxTrustAverages.insertElementAt(sumResults, i);
			   Txt_Results.append("TRUST LEVEL AVERAGE --> AGENT = " + sumResults.Owner + " TRUST RELATIONSHIP = " + sumResults.trustValues + " IN TASK = " + sumResults.TSName + "\n"); 
		   }
	   }
	   else
		   Txt_Results.setText("NO RESULTS AVAILABLE! BE SURE THAT YOU ALREADY HAVE RUN A SIMULATION INCLUDING THE TRUST MODEL OPTION IN THE SETTINGS MENU");
	   
	   setCursor(Normal);
	 }

 public void SelectAgent(){

   Vector Agnt = new Vector(1,1);
   Vector AgList = new Vector(1,1);
   Agentwrk AgTemp;
   Object[] agentValues;

    Graphics Cuad = Txt_Results.getGraphics();
    Cuad.setColor(Color.white);
    Cuad.fillRect(0, 0, 650, 520);
    Agnt.removeAllElements();
    Averages.removeAllElements();
    repaint();
    agentValues = new Object[AgentsTots.size()];
    for (int i=0; i<AgentsTots.size(); i++)
    { AgTemp = (Agentwrk)AgentsTots.get(i);
      agentValues[i] = AgTemp.getLocalName() + " --> " + AgTemp.getType();
    }
    Object selectedValue = JOptionPane.showInputDialog(null,
    "Select a person:", "Agents Tasks",
    JOptionPane.INFORMATION_MESSAGE, null,
    agentValues, agentValues[0]);
    if ((ResAgent.size() > 0) && (selectedValue!= null))
    { Nombre = selectedValue.toString();
      int indexs = Nombre.lastIndexOf("-->");
      Nombre = Nombre.substring(0,indexs-1);
      for(int j=0; j<ResAgent.size(); j++)
      { AuxResults AxRes = (AuxResults)ResAgent.get(j);
        if (AxRes.Owner.equals(Nombre))
          Agnt.addElement(AxRes);
      }
      AuxResults AxR, PromAR;
      AxR = (AuxResults) Agnt.lastElement();
      int TotSim = AxR.NumSimulacion;
      boolean Existe = false;
      for (int s=1; s<=TotSim; s++)
      { for (int tam=0; tam<Agnt.size(); tam++)
        { AxR = (AuxResults) Agnt.get(tam);
          if (AxR.NumSimulacion == s)
          { if (Averages.size() == 0)
            { PromAR = new AuxResults(TotSim, AxR.TSName, AxR.QualityTask, AxR.DurationTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
              Averages.addElement(PromAR);
            }
            else
            { Existe = false;
              for(int i=0; i<Averages.size(); i++)
              { PromAR = (AuxResults)Averages.get(i);
                if (PromAR.TSName.equals(AxR.TSName))
                { PromAR.SumaDurQty(AxR.DurationTask, AxR.QualityTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
                  Averages.set(i, PromAR);
                  Existe = true;
                }
              }
              if (!Existe)
              { PromAR = new AuxResults(TotSim, AxR.TSName, AxR.QualityTask, AxR.DurationTask, AxR.AgentGoals, AxR.AgentTeamCollaboration, AxR.AgentIndividualContribution, AxR.AgentRequiredSupervision);
                Averages.addElement(PromAR);
              }
            }
          }
        }
      }
      Cuad.setColor(Color.white);
      Cuad.fillRect(0, 0, 650, 520);
    }
}

 public void PaintTasksDuration(Vector Promedios) {

    Graphics Cuad = Txt_Results.getGraphics();
    Graphics Line = Txt_Results.getGraphics();
    Graphics Titulo = Txt_Results.getGraphics();
    Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
    int CX = 25, LYP = 90;
    Integer Et;
    AuxResults PromediosAR;

    if (Promedios.size() > 0)
     { Txt_Results.setText(" ");
       Titulo.setColor(new Color(112,0,0));
       Titulo.setFont(new Font("SansSerif", 1, 15));
       Titulo.drawString("TIMELINESS PROJECT RESULTS", 220, 30);
       Line.setColor(Color.black);
       Line.drawLine(25,LYP,25,490);    // EJE Y
       Line.drawLine(25,490,625,490);  // EJE X
       Cuad.setColor(Color.green);
       Cuad.fillRect(50, 510, 25, 10);
       Letra.drawString("Excelent", 80, 520);
       Cuad.setColor(Color.green.darker());
       Cuad.fillRect(150, 510, 25, 10);
       Letra.drawString("High", 180, 520);
       Cuad.setColor(Color.orange);
       Cuad.fillRect(250, 510, 25, 10);
       Letra.drawString("Acceptable", 280, 520);
       Cuad.setColor(Color.red.darker());
       Cuad.fillRect(350, 510, 25, 10);
       Letra.drawString("Regular", 380, 520);
       Cuad.setColor(Color.red.brighter());
       Cuad.fillRect(450, 510, 25, 10);
       Letra.drawString("Low", 480, 520);
       for (int i=5; i>=0; i--)
        { Et = new Integer(i*5);
          Line.drawLine(18,LYP,36,LYP);
          Letra.drawString(Et.toString(), 2, LYP+5);
          LYP = LYP + 80;
        }
       float PromDur;
       int YDur, pico;
       int NTasks = Promedios.size();
       CoordenadaX.removeAllElements();
       CoordenadaY.removeAllElements();
       NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
       NTasks = StrictMath.round(NTasks);
       for (int i=0; i<Promedios.size(); i++)
        { PromediosAR = (AuxResults)Promedios.get(i);
          Integer NS = new Integer(PromediosAR.NumSimulacion);
          Integer D = new Integer(PromediosAR.DurationTask);
          PromDur = D.floatValue() / NS.floatValue();
          NumberFormat nf = NumberFormat.getInstance();
          nf.setMinimumFractionDigits(1);
          nf.setMaximumFractionDigits(2);
          String DurStr = nf.format(PromDur);
          YDur = StrictMath.round(PromDur);
          pico = StrictMath.round((StrictMath.abs(PromDur) - StrictMath.abs(YDur))*10);
          if (YDur < -8)
            Cuad.setColor(Color.green);
          else
            if (YDur >= -8 && YDur < -3)
              Cuad.setColor(Color.green.darker());
            else
              if (YDur >= -3 && YDur < 3)
                Cuad.setColor(Color.orange);
              else
                if (YDur >= 3 && YDur < 8)
                  Cuad.setColor(Color.red.darker());
                else
                  Cuad.setColor(Color.red.brighter());

          YDur = StrictMath.abs(YDur);
          if (pico < 0)
           { pico = 10 - StrictMath.abs(pico);
             YDur--;
           }
          Cuad.fillRect(CX, 490-(YDur*16)-pico, 20, (YDur*16)+pico);
          Letra = (Graphics2D) Txt_Results.getGraphics();
          Letra.translate(CX+23, (490-(YDur*16)-pico)-5);
          Letra.rotate(0.0 - (Math.PI / 2.0));
          Letra.setColor(Color.blue);
          Letra.drawString(PromediosAR.TSName + " (" + DurStr + "%)", 0, 0 );
          CoordenadaX.addElement(new Integer(CX));
          CoordenadaY.addElement(new Integer((YDur*16)+ pico));
          CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
        }
     }
 }

  public void PaintTasksQuality(Vector Promedios) {

    Graphics Cuad = Txt_Results.getGraphics();
    Graphics Line = Txt_Results.getGraphics();
    Graphics Titulo = Txt_Results.getGraphics();
    Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
    int CX = 25, LYP = 90;
    Integer Et;
    AuxResults PromediosAR;

    if (Promedios.size() > 0)
     { Txt_Results.setText(" ");
       Titulo.setColor(new Color(112,0,0));
       Titulo.setFont(new Font("SansSerif", 1, 15));
       Titulo.drawString("PROJECT QUALITY", 240, 35);
       Line.setColor(Color.black);
       Line.drawLine(25,LYP,25,490);    // EJE Y
       Line.drawLine(25,490,625,490);  // EJE X
       Cuad.setColor(Color.green);
       Cuad.fillRect(50, 510, 25, 10);
       Letra.drawString("Excelent", 80, 520);
       Cuad.setColor(Color.green.darker());
       Cuad.fillRect(150, 510, 25, 10);
       Letra.drawString("High", 180, 520);
       Cuad.setColor(Color.orange);
       Cuad.fillRect(250, 510, 25, 10);
       Letra.drawString("Acceptable", 280, 520);
       Cuad.setColor(Color.red.darker());
       Cuad.fillRect(350, 510, 25, 10);
       Letra.drawString("Regular", 380, 520);
       Cuad.setColor(Color.red.brighter());
       Cuad.fillRect(450, 510, 25, 10);
       Letra.drawString("Low", 480, 520);

       for (int i=10; i>=0; i--)
         { Et = new Integer(i*10);
           Line.drawLine(18,LYP,36,LYP);
           Letra.drawString(Et.toString(), 2, LYP+5);
           LYP = LYP + 40;
         }
       float PromQty;  //PromDur,
       int YDur, pico;
       CoordenadaX.removeAllElements();
       CoordenadaY.removeAllElements();
       int NTasks = Promedios.size();
       NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
       NTasks = StrictMath.round(NTasks);
       for (int i=0; i<Promedios.size(); i++)
        { PromediosAR = (AuxResults)Promedios.get(i);
          Integer NS = new Integer(PromediosAR.NumSimulacion);
          //Integer D = new Integer(PromediosAR.DurationTask);
          Integer Q = new Integer(PromediosAR.QualityTask);
          //PromDur = D.floatValue() / NS.floatValue();
          PromQty = Q.floatValue() / NS.floatValue();
          NumberFormat nf = NumberFormat.getInstance();
          nf.setMinimumFractionDigits(1);
          nf.setMaximumFractionDigits(2);
          //String DurStr = nf.format(PromDur);
          String QtyStr = nf.format(PromQty);
          YDur = StrictMath.round(PromQty);
          pico = StrictMath.round((StrictMath.abs(PromQty) - StrictMath.abs(YDur))*10);
          if (YDur < 12)
            Cuad.setColor(Color.red.brighter());
          else
            if (YDur >= 12 && YDur < 37)
              Cuad.setColor(Color.red.darker());
            else
              if (YDur >= 37 && YDur < 63)
                Cuad.setColor(Color.orange);
              else
                if (YDur >= 63 && YDur < 87)
                  Cuad.setColor(Color.green.darker());
                else
                  Cuad.setColor(Color.green);
          YDur = StrictMath.abs(YDur);
          if (pico < 0)
           { pico = 10 - StrictMath.abs(pico);
             YDur--;
           }
          Cuad.fillRect(CX, 490-(YDur*4)-pico, 20, (YDur*4)+pico);
          Letra = (Graphics2D) Txt_Results.getGraphics();
          Letra.translate(CX+30, (490-(YDur*4)-pico));
          Letra.rotate(0.0 - (Math.PI / 2.0));
          Letra.setColor(Color.blue);
          Letra.drawString(PromediosAR.TSName + " (" + QtyStr + "%)", 0, 0 );
          CoordenadaX.addElement(new Integer(CX));
          CoordenadaY.addElement(new Integer((YDur*4)+pico));
          CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
        }
     }
 }

 public void PaintAgentDuration(Vector Promedios, String AgNm){

  Graphics Cuad = Txt_Results.getGraphics();
  Graphics Line = Txt_Results.getGraphics();
  Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
  Graphics Titulo = Txt_Results.getGraphics();
  int CX = 25, LYP = 90;
  Integer Et;
  AuxResults PromediosAR;

    if (Promedios.size() > 0)
     { Txt_Results.setText(" ");
       Titulo.setColor(new Color(112,0,0));
       Titulo.setFont(new Font("SansSerif", 1, 15));
       Titulo.drawString("TIMELINESS RESULTS OF AGENT: " + AgNm, 220, 30);
       Line.setColor(Color.black);
       Line.drawLine(25,LYP,25,490);    // EJE Y
       Line.drawLine(25,490,625,490);  // EJE X
       Cuad.setColor(Color.green);
       Cuad.fillRect(50, 510, 25, 10);
       Letra.drawString("Excelent", 80, 520);
       Cuad.setColor(Color.green.darker());
       Cuad.fillRect(150, 510, 25, 10);
       Letra.drawString("High", 180, 520);
       Cuad.setColor(Color.orange);
       Cuad.fillRect(250, 510, 25, 10);
       Letra.drawString("Acceptable", 280, 520);
       Cuad.setColor(Color.red.darker());
       Cuad.fillRect(350, 510, 25, 10);
       Letra.drawString("Regular", 380, 520);
       Cuad.setColor(Color.red.brighter());
       Cuad.fillRect(450, 510, 25, 10);
       Letra.drawString("Low", 480, 520);
       for (int i=5; i>=0; i--)
        { Et = new Integer(i*5);
          Line.drawLine(18,LYP,36,LYP);
          Letra.drawString(Et.toString(), 2, LYP+5);
          LYP = LYP + 80;
        }
       float PromDur;
       int YDur, pico;
       int NTasks = Promedios.size();
       CoordenadaX.removeAllElements();
       CoordenadaY.removeAllElements();
       NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
       NTasks = StrictMath.round(NTasks);
       for(int i=0; i<Promedios.size(); i++)
       { PromediosAR = (AuxResults)Promedios.get(i);
         Integer NS = new Integer(PromediosAR.NumSimulacion);
         Integer D = new Integer(PromediosAR.DurationTask);
         PromDur = D.floatValue() / NS.floatValue();
         NumberFormat nf = NumberFormat.getInstance();
         nf.setMinimumFractionDigits(1);
         nf.setMaximumFractionDigits(2);
         String DurStr = nf.format(PromDur);
         YDur = StrictMath.round(PromDur);
         pico = StrictMath.round((StrictMath.abs(PromDur) - StrictMath.abs(YDur))*10);
         if (YDur < -8)
            Cuad.setColor(Color.green);
         else
            if (YDur >= -8 && YDur < -3)
              Cuad.setColor(Color.green.darker());
            else
              if (YDur >= -3 && YDur < 3)
                Cuad.setColor(Color.orange);
              else
                if (YDur >= 3 && YDur < 8)
                  Cuad.setColor(Color.red.darker());
                else
                  Cuad.setColor(Color.red.brighter());
        YDur = StrictMath.abs(YDur);
        if (pico < 0)
         { pico = 10 - StrictMath.abs(pico);
           YDur--;
         }
        Cuad.fillRect(CX, 490-(YDur*16)-pico, 20, (YDur*16)+pico);
        Letra = (Graphics2D) Txt_Results.getGraphics();
        Letra.translate(CX+23, (490-(YDur*16)-pico)-5);
        Letra.rotate(0.0 - (Math.PI / 2.0));
        Letra.setColor(Color.blue);
        Letra.drawString(PromediosAR.TSName + " (" + DurStr + "%)", 0, 0 );
        CoordenadaX.addElement(new Integer(CX));
        CoordenadaY.addElement(new Integer((YDur*16)+ pico));
        CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
      }
    }
 }



 public void PaintAgentQuality(Vector Promedios, String AgNm){

  Graphics Cuad = Txt_Results.getGraphics();
  Graphics Line = Txt_Results.getGraphics();
  Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
  Graphics Titulo = Txt_Results.getGraphics();
  int CX = 25, LYP = 90;
  Integer Et;
  AuxResults PromediosAR;

    if (Promedios.size() > 0)
    {  Txt_Results.setText(" ");
       Titulo.setColor(new Color(112,0,0));
       Titulo.setFont(new Font("SansSerif", 1, 15));
       Titulo.drawString("QUALITY OF AGENT:  " + AgNm, 240, 35);
       Line.setColor(Color.black);
       Line.drawLine(25,LYP,25,490);    // EJE Y
       Line.drawLine(25,490,625,490);  // EJE X
       Cuad.setColor(Color.green);
       Cuad.fillRect(50, 510, 25, 10);
       Letra.drawString("Excelent", 80, 520);
       Cuad.setColor(Color.green.darker());
       Cuad.fillRect(150, 510, 25, 10);
       Letra.drawString("High", 180, 520);
       Cuad.setColor(Color.orange);
       Cuad.fillRect(250, 510, 25, 10);
       Letra.drawString("Acceptable", 280, 520);
       Cuad.setColor(Color.red.darker());
       Cuad.fillRect(350, 510, 25, 10);
       Letra.drawString("Regular", 380, 520);
       Cuad.setColor(Color.red.brighter());
       Cuad.fillRect(450, 510, 25, 10);
       Letra.drawString("Low", 480, 520);
       for (int i=10; i>=0; i--)
         { Et = new Integer(i*10);
           Line.drawLine(18,LYP,36,LYP);              // LINEAS QUE INDICAN
           Letra.drawString(Et.toString(), 2, LYP+5); // LA DIVISION DEL EJE Y
           LYP = LYP + 40;
         }
       float PromQty;
       int YDur, pico;
       int NTasks = Promedios.size();
       CoordenadaX.removeAllElements();
       CoordenadaY.removeAllElements();
       NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
       NTasks = StrictMath.round(NTasks);
       for(int i=0; i<Promedios.size(); i++)
       { PromediosAR = (AuxResults)Promedios.get(i);
         Integer NS = new Integer(PromediosAR.NumSimulacion);
         Integer Q = new Integer(PromediosAR.QualityTask);
         PromQty = 50 + (Q.floatValue() / NS.floatValue());
         if (PromQty > 100)
           PromQty = 100;
         NumberFormat nf = NumberFormat.getInstance();
         nf.setMinimumFractionDigits(1);
         nf.setMaximumFractionDigits(2);
         String QtyStr = nf.format(PromQty);
         YDur = StrictMath.round(PromQty);
         pico = StrictMath.round((StrictMath.abs(PromQty) - StrictMath.abs(YDur))*10);
         if (YDur < 12)
            Cuad.setColor(Color.red.brighter());
          else
            if (YDur >= 12 && YDur < 37)
              Cuad.setColor(Color.red.darker());
            else
              if (YDur >= 37 && YDur < 63)
                Cuad.setColor(Color.orange);
              else
                if (YDur >= 63 && YDur < 87)
                  Cuad.setColor(Color.green.darker());
                else
                  Cuad.setColor(Color.green);
         YDur = StrictMath.abs(YDur);
         if (pico < 0)
         { pico = 10 - StrictMath.abs(pico);
           YDur--;
         }
         Cuad.fillRect(CX, 490-(YDur*4)-pico, 20, (YDur*4)+pico);
         Letra = (Graphics2D) Txt_Results.getGraphics();
         Letra.translate(CX+30, (490-(YDur*4)-pico));
         Letra.rotate(0.0 - (Math.PI / 2.0));
         Letra.setColor(Color.blue);
         Letra.drawString(PromediosAR.TSName + " (" + QtyStr + "%)", 0, 0 );
         CoordenadaY.addElement(new Integer((YDur*4)+pico));
         CoordenadaX.addElement(new Integer(CX));
         CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
      }
    }
 }

 public void PaintAgentGoals(Vector Promedios, String AgNm){

 Graphics Cuad = Txt_Results.getGraphics();
 Graphics Line = Txt_Results.getGraphics();
 Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
 Graphics Titulo = Txt_Results.getGraphics();
 int CX = 25, LYP = 90;
 Integer Et;
 AuxResults PromediosAR;

   if (Promedios.size() > 0)
   {  Txt_Results.setText(" ");
      Titulo.setColor(new Color(112,0,0));
      Titulo.setFont(new Font("SansSerif", 1, 15));
      Titulo.drawString("GOALS ACHIEVEMENT OF AGENT:  " + AgNm, 240, 35);
      Line.setColor(Color.black);
      Line.drawLine(25,LYP,25,490);    // EJE Y
      Line.drawLine(25,490,625,490);  // EJE X
      Cuad.setColor(Color.green);
      Cuad.fillRect(50, 510, 25, 10);
      Letra.drawString("Satisfactory", 80, 520);
      Cuad.setColor(Color.green.darker());
      Cuad.fillRect(150, 510, 25, 10);
      Letra.drawString("Acceptable", 180, 520);
      Cuad.setColor(Color.orange);
      Cuad.fillRect(250, 510, 25, 10);
      Letra.drawString("Minimum", 280, 520);
      Cuad.setColor(Color.red.darker());
      Cuad.fillRect(350, 510, 25, 10);
      Letra.drawString("Low", 380, 520);
      Cuad.setColor(Color.red.brighter());
      Cuad.fillRect(450, 510, 25, 10);
      Letra.drawString("Very Low", 480, 520);
      for (int i=10; i>=0; i--)
        { Et = new Integer(i*10);
          Line.drawLine(18,LYP,36,LYP);              // LINEAS QUE INDICAN
          Letra.drawString(Et.toString(), 2, LYP+5); // LA DIVISION DEL EJE Y
          LYP = LYP + 40;
        }
      float PromGoal;
      int YGoal, pico;
      int NTasks = Promedios.size();   //EL VECTOR PROMEDIOS CONTIENE LAS TAREAS QUE REALIZO EL AGENTE
      CoordenadaX.removeAllElements();
      CoordenadaY.removeAllElements();
      NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
      NTasks = StrictMath.round(NTasks);
      for(int i=0; i<Promedios.size(); i++)
      { PromediosAR = (AuxResults)Promedios.get(i);
        Integer NS = new Integer(PromediosAR.NumSimulacion);
        Integer Gl = new Integer(PromediosAR.AgentGoals);
        PromGoal = 80 + (Gl.floatValue() / NS.floatValue());
        if (PromGoal > 100)
          PromGoal = 100;
        if (PromGoal < 0)
           PromGoal = 0;
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMinimumFractionDigits(1);
        nf.setMaximumFractionDigits(2);
        String QtyStr = nf.format(PromGoal);
        YGoal = StrictMath.round(PromGoal);
        pico = StrictMath.round((StrictMath.abs(PromGoal) - StrictMath.abs(YGoal))*10);
        if (YGoal <= 20)
           Cuad.setColor(Color.red.brighter());
         else
           if (YGoal >= 21 && YGoal <= 40)
             Cuad.setColor(Color.red.darker());
           else
             if (YGoal >= 41 && YGoal <= 60)
               Cuad.setColor(Color.orange);
             else
               if (YGoal >= 61 && YGoal <= 80)
                 Cuad.setColor(Color.green.darker());
               else
                 Cuad.setColor(Color.green);
        YGoal = StrictMath.abs(YGoal);
        if (pico < 0)
        { pico = 10 - StrictMath.abs(pico);
          YGoal--;
        }
        Cuad.fillRect(CX, 490-(YGoal*4)-pico, 20, (YGoal*4)+pico);
        Letra = (Graphics2D) Txt_Results.getGraphics();
        Letra.translate(CX+30, (490-(YGoal*4)-pico));
        Letra.rotate(0.0 - (Math.PI / 2.0));
        Letra.setColor(Color.blue);
        Letra.drawString(PromediosAR.TSName + " (" + QtyStr + "%)", 0, 0 );
        CoordenadaY.addElement(new Integer((YGoal*4)+pico));
        CoordenadaX.addElement(new Integer(CX));
        CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
     }
   }
}

 public void PaintAgentTeamCollaboration(Vector Promedios, String AgNm){

 Graphics Cuad = Txt_Results.getGraphics();
 Graphics Line = Txt_Results.getGraphics();
 Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
 Graphics Titulo = Txt_Results.getGraphics();
 int CX = 25, LYP = 90;
 Integer Et;
 AuxResults PromediosAR;

   if (Promedios.size() > 0)
   {  Txt_Results.setText(" ");
      Titulo.setColor(new Color(112,0,0));
      Titulo.setFont(new Font("SansSerif", 1, 15));
      Titulo.drawString("TEAM COLLABORATION LEVEL OF AGENT:  " + AgNm, 210, 35);
      Line.setColor(Color.black);
      Line.drawLine(25,LYP,25,490);    // EJE Y
      Line.drawLine(25,490,625,490);  // EJE X
      Cuad.setColor(Color.green);
      Cuad.fillRect(50, 510, 25, 10);
      Letra.drawString("Excelent", 80, 520);
      Cuad.setColor(Color.green.darker());
      Cuad.fillRect(150, 510, 25, 10);
      Letra.drawString("High", 180, 520);
      Cuad.setColor(Color.orange);
      Cuad.fillRect(250, 510, 25, 10);
      Letra.drawString("Acceptable", 280, 520);
      Cuad.setColor(Color.red.darker());
      Cuad.fillRect(350, 510, 25, 10);
      Letra.drawString("Regular", 380, 520);
      Cuad.setColor(Color.red.brighter());
      Cuad.fillRect(450, 510, 25, 10);
      Letra.drawString("Low", 480, 520);
      for (int i=10; i>=0; i--)
        { Et = new Integer(i*10);
          Line.drawLine(18,LYP,36,LYP);              // LINEAS QUE INDICAN
          Letra.drawString(Et.toString(), 2, LYP+5); // LA DIVISION DEL EJE Y
          LYP = LYP + 40;
        }
      float PromTeamColl;
      int YTeamColl, pico;
      int NTasks = Promedios.size();   //EL VECTOR PROMEDIOS CONTIENE LAS TAREAS QUE REALIZO EL AGENTE
      CoordenadaX.removeAllElements();
      CoordenadaY.removeAllElements();
      NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
      NTasks = StrictMath.round(NTasks);
      for(int i=0; i<Promedios.size(); i++)
      { PromediosAR = (AuxResults)Promedios.get(i);
        Integer NS = new Integer(PromediosAR.NumSimulacion);
        Integer ATC = new Integer(PromediosAR.AgentTeamCollaboration);
        PromTeamColl = 50 + (ATC.floatValue() / NS.floatValue());
        if (PromTeamColl > 100)
          PromTeamColl = 100;
        if (PromTeamColl < 0)
           PromTeamColl = 0;
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMinimumFractionDigits(1);
        nf.setMaximumFractionDigits(2);
        String TeamCollStr = nf.format(PromTeamColl);
        YTeamColl = StrictMath.round(PromTeamColl);
        pico = StrictMath.round((StrictMath.abs(PromTeamColl) - StrictMath.abs(YTeamColl))*10);
        if (YTeamColl <= 25)
           Cuad.setColor(Color.red.brighter());
         else
           if (YTeamColl >= 26 && YTeamColl <= 33)
             Cuad.setColor(Color.red.darker());
           else
             if (YTeamColl >= 34 && YTeamColl <= 63)
               Cuad.setColor(Color.orange);
             else
               if (YTeamColl >= 64 && YTeamColl <= 79)
                 Cuad.setColor(Color.green.darker());
               else
                 Cuad.setColor(Color.green);
        YTeamColl = StrictMath.abs(YTeamColl);
        if (pico < 0)
        { pico = 10 - StrictMath.abs(pico);
          YTeamColl--;
        }
        Cuad.fillRect(CX, 490-(YTeamColl*4)-pico, 20, (YTeamColl*4)+pico);
        Letra = (Graphics2D) Txt_Results.getGraphics();
        Letra.translate(CX+30, (490-(YTeamColl*4)-pico));
        Letra.rotate(0.0 - (Math.PI / 2.0));
        Letra.setColor(Color.blue);
        Letra.drawString(PromediosAR.TSName + " (" + TeamCollStr + "%)", 0, 0 );
        CoordenadaY.addElement(new Integer((YTeamColl*4)+pico));
        CoordenadaX.addElement(new Integer(CX));
        CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
     }
   }
}

 public void PaintAgentIndividualContribution(Vector Promedios, String AgNm){

  Graphics Cuad = Txt_Results.getGraphics();
  Graphics Line = Txt_Results.getGraphics();
  Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
  Graphics Titulo = Txt_Results.getGraphics();
  int CX = 25, LYP = 90;
  Integer Et;
  AuxResults PromediosAR;

    if (Promedios.size() > 0)
    {  Txt_Results.setText(" ");
       Titulo.setColor(new Color(112,0,0));
       Titulo.setFont(new Font("SansSerif", 1, 15));
       Titulo.drawString("INDIVIDUAL CONTRIBUTION LEVEL OF AGENT:  " + AgNm, 200, 35);
       Line.setColor(Color.black);
       Line.drawLine(25,LYP,25,490);    // EJE Y
       Line.drawLine(25,490,625,490);  // EJE X
       Cuad.setColor(Color.green);
       Cuad.fillRect(50, 510, 25, 10);
       Letra.drawString("Excelent", 80, 520);
       Cuad.setColor(Color.green.darker());
       Cuad.fillRect(150, 510, 25, 10);
       Letra.drawString("High", 180, 520);
       Cuad.setColor(Color.orange);
       Cuad.fillRect(250, 510, 25, 10);
       Letra.drawString("Acceptable", 280, 520);
       Cuad.setColor(Color.red.darker());
       Cuad.fillRect(350, 510, 25, 10);
       Letra.drawString("Regular", 380, 520);
       Cuad.setColor(Color.red.brighter());
       Cuad.fillRect(450, 510, 25, 10);
       Letra.drawString("Low", 480, 520);
       for (int i=10; i>=0; i--)
         { Et = new Integer(i*10);
           Line.drawLine(18,LYP,36,LYP);              // LINEAS QUE INDICAN
           Letra.drawString(Et.toString(), 2, LYP+5); // LA DIVISION DEL EJE Y
           LYP = LYP + 40;
         }
       float PromIndCont;
       int YIndCont, pico;
       int NTasks = Promedios.size();   //EL VECTOR PROMEDIOS CONTIENE LAS TAREAS QUE REALIZO EL AGENTE
       CoordenadaX.removeAllElements();
       CoordenadaY.removeAllElements();
       NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
       NTasks = StrictMath.round(NTasks);
       for(int i=0; i<Promedios.size(); i++)
       { PromediosAR = (AuxResults)Promedios.get(i);
         Integer NS = new Integer(PromediosAR.NumSimulacion);
         Integer AIC = new Integer(PromediosAR.AgentIndividualContribution);
         PromIndCont = 50 + (AIC.floatValue() / NS.floatValue());
         if (PromIndCont > 100)
           PromIndCont = 100;
         if (PromIndCont < 0)
            PromIndCont = 0;
         NumberFormat nf = NumberFormat.getInstance();
         nf.setMinimumFractionDigits(1);
         nf.setMaximumFractionDigits(2);
         String IndivContr = nf.format(PromIndCont);
         YIndCont = StrictMath.round(PromIndCont);
         pico = StrictMath.round((StrictMath.abs(PromIndCont) - StrictMath.abs(YIndCont))*10);
         if (YIndCont <= 25)
            Cuad.setColor(Color.red.brighter());
          else
            if (YIndCont >= 26 && YIndCont <= 33)
              Cuad.setColor(Color.red.darker());
            else
              if (YIndCont >= 34 && YIndCont <= 63)
                Cuad.setColor(Color.orange);
              else
                if (YIndCont >= 64 && YIndCont <= 79)
                  Cuad.setColor(Color.green.darker());
                else
                  Cuad.setColor(Color.green);
         YIndCont = StrictMath.abs(YIndCont);
         if (pico < 0)
         { pico = 10 - StrictMath.abs(pico);
           YIndCont--;
         }
         Cuad.fillRect(CX, 490-(YIndCont*4)-pico, 20, (YIndCont*4)+pico);
         Letra = (Graphics2D) Txt_Results.getGraphics();
         Letra.translate(CX+30, (490-(YIndCont*4)-pico));
         Letra.rotate(0.0 - (Math.PI / 2.0));
         Letra.setColor(Color.blue);
         Letra.drawString(PromediosAR.TSName + " (" + IndivContr + "%)", 0, 0 );
         CoordenadaY.addElement(new Integer((YIndCont*4)+pico));
         CoordenadaX.addElement(new Integer(CX));
         CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
      }
    }
 }

 public void PaintAgentRequiredSupervision(Vector Promedios, String AgNm){

   Graphics Cuad = Txt_Results.getGraphics();
   Graphics Line = Txt_Results.getGraphics();
   Graphics2D Letra = (Graphics2D) Txt_Results.getGraphics();
   Graphics Titulo = Txt_Results.getGraphics();
   int CX = 25, LYP = 90;
   Integer Et;
   AuxResults PromediosAR;

     if (Promedios.size() > 0)
     {  Txt_Results.setText(" ");
        Titulo.setColor(new Color(112,0,0));
        Titulo.setFont(new Font("SansSerif", 1, 15));
        Titulo.drawString("REQUIRED SUPERVISION LEVEL OF AGENT:  " + AgNm, 200, 35);
        Line.setColor(Color.black);
        Line.drawLine(25,LYP,25,490);    // EJE Y
        Line.drawLine(25,490,625,490);  // EJE X
        Cuad.setColor(Color.green.darker());
        Cuad.fillRect(50, 510, 25, 10);
        Letra.drawString("Not Required", 80, 520);
        Cuad.setColor(Color.orange);
        Cuad.fillRect(200, 510, 25, 10);
        Letra.drawString("Eventually", 230, 520);
        Cuad.setColor(Color.red.darker());
        Cuad.fillRect(350, 510, 25, 10);
        Letra.drawString("Periodically", 380, 520);
        Cuad.setColor(Color.red.brighter());
        Cuad.fillRect(500, 510, 25, 10);
        Letra.drawString("Permanently", 530, 520);
        for (int i=10; i>=0; i--)
          { Et = new Integer(i*10);
            Line.drawLine(18,LYP,36,LYP);              // LINEAS QUE INDICAN
            Letra.drawString(Et.toString(), 2, LYP+5); // LA DIVISION DEL EJE Y
            LYP = LYP + 40;
          }
        float PromReqSup;
        int YReqSup, pico;
        int NTasks = Promedios.size();   //EL VECTOR PROMEDIOS CONTIENE LAS TAREAS QUE REALIZO EL AGENTE
        CoordenadaX.removeAllElements();
        CoordenadaY.removeAllElements();
        NTasks = 600 / NTasks;  // 600 ES LO QUE MIDE EL EJE DE LAS X's
        NTasks = StrictMath.round(NTasks);
        for(int i=0; i<Promedios.size(); i++)
        { PromediosAR = (AuxResults)Promedios.get(i);
          Integer NS = new Integer(PromediosAR.NumSimulacion);
          Integer ARS = new Integer(PromediosAR.AgentRequiredSupervision);
          PromReqSup = 55 + (ARS.floatValue() / NS.floatValue());
          if (PromReqSup > 100)
            PromReqSup = 100;
          if (PromReqSup < 0)
             PromReqSup = 0;
          NumberFormat nf = NumberFormat.getInstance();
          nf.setMinimumFractionDigits(1);
          nf.setMaximumFractionDigits(2);
          String ReqSuprv = nf.format(PromReqSup);
          YReqSup = StrictMath.round(PromReqSup);
          pico = StrictMath.round((StrictMath.abs(PromReqSup) - StrictMath.abs(YReqSup))*10);
          if (YReqSup <= 25)
             Cuad.setColor(Color.green.darker());
           else
             if (YReqSup >= 26 && YReqSup <= 57)
               Cuad.setColor(Color.orange);
             else
               if (YReqSup >= 58 && YReqSup <= 88)
                 Cuad.setColor(Color.red.darker());
               else
                   Cuad.setColor(Color.red.brighter());
          YReqSup = StrictMath.abs(YReqSup);
          if (pico < 0)
          { pico = 10 - StrictMath.abs(pico);
            YReqSup--;
          }
          Cuad.fillRect(CX, 490-(YReqSup*4)-pico, 20, (YReqSup*4)+pico);
          Letra = (Graphics2D) Txt_Results.getGraphics();
          Letra.translate(CX+30, (490-(YReqSup*4)-pico));
          Letra.rotate(0.0 - (Math.PI / 2.0));
          Letra.setColor(Color.blue);
          Letra.drawString(PromediosAR.TSName + " (" + ReqSuprv + "%)", 0, 0 );
          CoordenadaY.addElement(new Integer((YReqSup*4)+pico));
          CoordenadaX.addElement(new Integer(CX));
          CX = CX + NTasks;  // DEFINIR LA COORDENADA EN X DE LA SIGUIENTE TAREA
       }
     }
  }

   void Txt_Results_mouseClicked(MouseEvent e) {

        Integer cordX, cordY, cordY2;
        int pos, cuenta;

         if (e.getClickCount() == 2)
          {cordX = new Integer(0);
           cordY = new Integer(0);
           cordY2= new Integer(0);
           cuenta = 0;
           if (Averages.size() > 0)
            { pos = -1;
              for (int j=0; j<CoordenadaX.size(); j++)
               { cordX = (Integer) CoordenadaX.get(j);
                 cordY = (Integer) CoordenadaY.get(j);
                 if ((((e.getX() >= cordX.intValue()) && (e.getX() <= cordX.intValue() + 20)) &&
                   ((e.getY() >= 490 - cordY.intValue()) && (e.getY() <= 490))))
                     pos = j;
               }
              if (pos >= 0)
               { cuenta ++;
                 AuxResults AR = (AuxResults)Averages.get(pos);
                 System.out.println(AR.TSName);
                 boolean packFrame = false;
                 InfoTask frame = new InfoTask(AR.TSName, AgentsTots);
                 if (packFrame)
                   frame.pack();
                 else
                   frame.validate();
                 //Center the window
                 Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                 Dimension frameSize = frame.getSize();
                 if (frameSize.height > screenSize.height)
                   frameSize.height = screenSize.height;
                 if (frameSize.width > screenSize.width)
                   frameSize.width = screenSize.width;
                 frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
                 frame.setResizable(false);
                 frame.setVisible(true);
               }
            }
          }
  }

}