/***********************************************************************
Multi-Agent System to Simulate the Human Behaviour within a Team Work
version 1.0

This is the class that represents the task used for all the agents
involved in the project.

@author: Juan C. Martinez Miranda.
         juan.martinez.miranda@gmail.com
Institution: Universdad Complutense de Madrid
             Facultad de Informtica.
Winter 2010.

************************************************************************/


import java.util.*;
import java.io.*;

  public class Tarea implements Serializable {

    int ID;
    int X, Y;
    String Name;
    int Duration;
    int AdelantoRetraso = 0;
    int FinishPercent = 0;
    String DeadLine;
    float Cost;
    String Priority;
    String AppDomain;
    String Description;
    int Difficult;
    int Type;
    int Quality = 50;
    boolean Realizada;
    Vector Precedencias = new Vector(1, 1);
    Vector Anteriores = new Vector(1, 1);
    Vector AgentsToDevelop = new Vector(1, 1);

    public Tarea(int x, int y){

         this.X = x;
         this.Y = y;
    }

    public void setID(int id){

        this.ID = id;
    }

    public void setName(String N){

       this.Name = N;
    }

    public void setDuration(int D){

       this.Duration = D;
    }

    public void setDeadLine(String DL){

       this.DeadLine = DL;
    }

    public void setCost(float C){

       this.Cost = C;
    }

    public void setPriority(String P){

       this.Priority = P;
    }

    public void setAppDomain(String AppDom) {

        this.AppDomain = AppDom;
    }

    public void setDescription(String Desc){

         this.Description = Desc;
    }

    public void setDifficult(int Dif){

       this.Difficult = Dif;
    }

   public void setType(int Tp){

       this.Type = Tp;
    }

    public void setAgent(String Ag){

      this.AgentsToDevelop.addElement(Ag);

    }

    public void restartParameters(){

       this.AdelantoRetraso = 0;
       this.Quality = 50;
       this.FinishPercent = 0;
    }

    public int getID(){

       return this.ID;
    }

    public String getName(){

       return this.Name;
    }

    public int getDuration(){

       return this.Duration;
    }

    public String getDeadLine(){

       return this.DeadLine;
    }

    public float getCost(){

       return this.Cost;
    }

    public String getPriority(){

       return this.Priority;
    }

    public String getAppDomain(){

       return this.AppDomain;
    }

    public String getDescription(){

       return this.Description;
    }

    public int getDifficult(){

       return this.Difficult;
    }

   public int getType(){

       return this.Type;
    }

   public int getQuality(){

       return this.Quality;
    }

    public int getAdelantoRetraso(){

       return this.AdelantoRetraso;
    }

    public int getFinishPercent(){

       return this.FinishPercent;
    }

    public int getX(){

       return this.X;
    }

    public int getY(){

       return this.Y;
    }

    public int WhatTaskIs(int x, int y){

    int Ancho = this.X + 40;
    int Alto = this.Y + 15;

       if ((x >= this.X) && (x <= Ancho) && (y >= this.Y) && (y <= Alto))
           return this.ID;
       else
           return 0;
  }

  public void ModifyDuration(int daysToAdd, boolean Propio){


   if (!Propio)
     { if (this.AdelantoRetraso == 0)
         this.AdelantoRetraso = daysToAdd;
       else
         if (this.AdelantoRetraso <= daysToAdd)
           this.AdelantoRetraso = daysToAdd;
     }
   else
     { if (this.FinishPercent == 0)
         this.FinishPercent = daysToAdd;
       else
         if (this.FinishPercent <= daysToAdd)
           this.FinishPercent = daysToAdd;
     }

  }

  public void ModifyQuality(int puntsToAdd){

     int QualityTemp;

     QualityTemp = this.Quality + puntsToAdd;
     if (QualityTemp > 100)
       QualityTemp = 100;
     if (QualityTemp < 0)
        QualityTemp = 0;
     this.Quality = QualityTemp;

  }

  public void AsignaPrecedencia(int id){

     Integer iden = new Integer(id);

     this.Precedencias.addElement(iden);

  }

  public Vector MuestraPrecedencias(){

     return this.Precedencias;

  }

  public void RemoveAllPrecedencias(){

      this.Precedencias.clear();
  }

  public void AsignaAnterior(int id){

     Integer iden = new Integer(id);

     this.Anteriores.addElement(iden);

  }

  public Vector MuestraAnteriores(){

     return this.Anteriores;

  }

  public void RemoveAllAnteriores(){

      this.Anteriores.clear();
  }

  public Vector MuestraAgentesAsignados(){

     return this.AgentsToDevelop;

  }

  public void removeAgent(String Ag){

    int i;

      i = this.AgentsToDevelop.indexOf(Ag);
      this.AgentsToDevelop.removeElementAt(i);

   }

  public void removeAllAgents(){

      this.AgentsToDevelop.clear();

   }


}
