;**********************************************************************************
;This is the file with Fuzzy Rules to change the duration and quality of the tasks
;according to the Internal State of the agent.
;
;@author: Juan C. Martinez Miranda.
;         juan.martinez.miranda@gmail.com
;Institution: Universdad Complutense de Madrid
;             Facultad de Informtica.
;Winter 2010.

************************************************************************/

(defglobal ?*FCreativity* = (new nrc.fuzzy.FuzzyVariable "creativity" 0.0 100.0))
(defglobal ?*FExperience* = (new nrc.fuzzy.FuzzyVariable "experience" 0.0 100.0))
(defglobal ?*FDrive* = (new nrc.fuzzy.FuzzyVariable "drive" 0.0 100.0))
(defglobal ?*FInfluence* = (new nrc.fuzzy.FuzzyVariable "influence" 0.0 100.0))
(defglobal ?*FStainess* = (new nrc.fuzzy.FuzzyVariable "stainess" 0.0 100.0))
(defglobal ?*FCompliance* = (new nrc.fuzzy.FuzzyVariable "compliance" 0.0 100.0))
(defglobal ?*FDesire* = (new nrc.fuzzy.FuzzyVariable "desire" 0.0 100.0))
(defglobal ?*FInterest* = (new nrc.fuzzy.FuzzyVariable "interest" 0.0 100.0))
(defglobal ?*FDisgust* = (new nrc.fuzzy.FuzzyVariable "disgust" 0.0 100.0))
(defglobal ?*FAnxiety* = (new nrc.fuzzy.FuzzyVariable "anxiety" 0.0 100.0))
(defglobal ?*FStress* = (new nrc.fuzzy.FuzzyVariable "stress" 0.0 100.0))
(defglobal ?*FTaskType* = (new nrc.fuzzy.FuzzyVariable "tasktype" 0.0 100.0))
(defglobal ?*FTaskDifficult* = (new nrc.fuzzy.FuzzyVariable "taskdifficult" 0.0 100.0))
(defglobal ?*FTrustLevel* = (new nrc.fuzzy.FuzzyVariable "trustlevel" 0.0 50.0))

(defglobal ?*ChangeTaskDays* = (new nrc.fuzzy.FuzzyVariable "ChangeTaskDays" -20.0 20.0 "Days"))
(defglobal ?*ChangeTaskQuality* = (new nrc.fuzzy.FuzzyVariable "ChangeTaskQuality" -50.0 50.0 "Puntos"))
(defglobal ?*ChangeGoalsAchievement* = (new nrc.fuzzy.FuzzyVariable "ChangeGoalsAchievement" -50.0 50.0 "Puntos"))
(defglobal ?*ChangeTeamCollaboration* = (new nrc.fuzzy.FuzzyVariable "ChangeTeamCollaboration" -50.0 50.0 "Puntos"))
(defglobal ?*ChangeIndividualContribution* = (new nrc.fuzzy.FuzzyVariable "ChangeIndividualContribution" -50.0 50.0 "Puntos"))
(defglobal ?*ChangeRequiredSupervision* = (new nrc.fuzzy.FuzzyVariable "ChangeRequiredSupervision" -50.0 50.0 "Puntos"))

(defglobal ?*rulesThatFired* = "")

(defrule init
   (inicio)
  =>
   (import nrc.fuzzy.*)
   (load-package nrc.fuzzy.jess.FuzzyFunctions)
   (?*FCreativity* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FCreativity* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FCreativity* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FExperience* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FExperience* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FExperience* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FDrive* addTerm "low" (new ZFuzzySet 0.0 40.0))
   (?*FDrive* addTerm "medium" (new PIFuzzySet 50.0 30.0))
   (?*FDrive* addTerm "high" (new SFuzzySet 60.0 100.0))
   (?*FInfluence* addTerm "low" (new ZFuzzySet 0.0 40.0))
   (?*FInfluence* addTerm "medium" (new PIFuzzySet 50.0 30.0))
   (?*FInfluence* addTerm "high" (new SFuzzySet 60.0 100.0))
   (?*FStainess* addTerm "low" (new ZFuzzySet 0.0 40.0))
   (?*FStainess* addTerm "medium" (new PIFuzzySet 50.0 30.0))
   (?*FStainess* addTerm "high" (new SFuzzySet 60.0 100.0))
   (?*FCompliance* addTerm "low" (new ZFuzzySet 0.0 40.0))
   (?*FCompliance* addTerm "medium" (new PIFuzzySet 50.0 30.0))
   (?*FCompliance* addTerm "high" (new SFuzzySet 60.0 100.0))
   (?*FDesire* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FDesire* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FDesire* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FInterest* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FInterest* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FInterest* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FDisgust* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FDisgust* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FDisgust* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FAnxiety* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FAnxiety* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FAnxiety* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FStress* addTerm "low" (new ZFuzzySet 0.0 25.0))
   (?*FStress* addTerm "medium" (new PIFuzzySet 50.0 30.0))
   (?*FStress* addTerm "high" (new SFuzzySet 75.0 100.0))
   (?*FTaskType* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FTaskType* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FTaskType* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FTaskDifficult* addTerm "low" (new ZFuzzySet 0.0 35.0))
   (?*FTaskDifficult* addTerm "medium" (new PIFuzzySet 50.0 25.0))
   (?*FTaskDifficult* addTerm "high" (new SFuzzySet 65.0 100.0))
   (?*FTrustLevel* addTerm "low" (new ZFuzzySet 0.0 20.0))
   (?*FTrustLevel* addTerm "medium" (new PIFuzzySet 25.0 15.0))
   (?*FTrustLevel* addTerm "high" (new SFuzzySet 30.0 50.0))
 

   (?*ChangeTaskDays* addTerm "High_Advance" (new ZFuzzySet -20.0 -5.0))
   (?*ChangeTaskDays* addTerm "Medium_Advance" (new PIFuzzySet -5.0 5.0))
   (?*ChangeTaskDays* addTerm "Normal" (new PIFuzzySet 0.0 5.0))
   (?*ChangeTaskDays* addTerm "Medium_Delay" (new PIFuzzySet 5.0 5.0))
   (?*ChangeTaskDays* addTerm "High_Delay" (new SFuzzySet 5.0 20.0))
   (?*ChangeTaskQuality* addTerm "High_Decrease" (new ZFuzzySet -50.0 -25.0))
   (?*ChangeTaskQuality* addTerm "Medium_Decrease" (new PIFuzzySet -15.0 15.0))
   (?*ChangeTaskQuality* addTerm "Normal" (new PIFuzzySet 0.0 15.0))
   (?*ChangeTaskQuality* addTerm "Medium_Increase" (new PIFuzzySet 15.0 15.0))
   (?*ChangeTaskQuality* addTerm "High_Increase" (new SFuzzySet 25.0 50.0))
   (?*ChangeGoalsAchievement* addTerm "High_Decrease" (new ZFuzzySet -50.0 -25.0))
   (?*ChangeGoalsAchievement* addTerm "Medium_Decrease" (new PIFuzzySet -15.0 15.0))
   (?*ChangeGoalsAchievement* addTerm "Normal" (new PIFuzzySet 0.0 15.0))
   (?*ChangeGoalsAchievement* addTerm "Medium_Increase" (new PIFuzzySet 15.0 15.0))
   (?*ChangeGoalsAchievement* addTerm "High_Increase" (new SFuzzySet 25.0 50.0))
   (?*ChangeTeamCollaboration* addTerm "High_Decrease" (new ZFuzzySet -50.0 -25.0))
   (?*ChangeTeamCollaboration* addTerm "Medium_Decrease" (new PIFuzzySet -15.0 15.0))
   (?*ChangeTeamCollaboration* addTerm "Normal" (new PIFuzzySet 0.0 15.0))
   (?*ChangeTeamCollaboration* addTerm "Medium_Increase" (new PIFuzzySet 15.0 15.0))
   (?*ChangeTeamCollaboration* addTerm "High_Increase" (new SFuzzySet 25.0 50.0))
   (?*ChangeIndividualContribution* addTerm "High_Decrease" (new ZFuzzySet -50.0 -25.0))
   (?*ChangeIndividualContribution* addTerm "Medium_Decrease" (new PIFuzzySet -15.0 15.0))
   (?*ChangeIndividualContribution* addTerm "Normal" (new PIFuzzySet 0.0 15.0))
   (?*ChangeIndividualContribution* addTerm "Medium_Increase" (new PIFuzzySet 15.0 15.0))
   (?*ChangeIndividualContribution* addTerm "High_Increase" (new SFuzzySet 25.0 50.0))
   (?*ChangeRequiredSupervision* addTerm "High_Decrease" (new ZFuzzySet -50.0 -25.0))
   (?*ChangeRequiredSupervision* addTerm "Medium_Decrease" (new PIFuzzySet -15.0 15.0))
   (?*ChangeRequiredSupervision* addTerm "Normal" (new PIFuzzySet 0.0 15.0))
   (?*ChangeRequiredSupervision* addTerm "Medium_Increase" (new PIFuzzySet 15.0 15.0))
   (?*ChangeRequiredSupervision* addTerm "High_Increase" (new SFuzzySet 25.0 50.0))

   (store CREATIVITYFUZZYVARIABLE ?*FCreativity*)
   (store EXPERIENCEFUZZYVARIABLE ?*FExperience*)
   (store DRIVEFUZZYVARIABLE ?*FDrive*)
   (store INFLUENCEFUZZYVARIABLE ?*FInfluence*)
   (store STAINESSFUZZYVARIABLE ?*FStainess*)
   (store COMPLIANCEFUZZYVARIABLE ?*FCompliance*)
   (store DESIREFUZZYVARIABLE ?*FDesire*)
   (store INTERESTFUZZYVARIABLE ?*FInterest*)
   (store DISGUSTFUZZYVARIABLE ?*FDisgust*)
   (store ANXIETYFUZZYVARIABLE ?*FAnxiety*)
   (store STRESSFUZZYVARIABLE ?*FStress*)
   (store TASKTYPEFUZZYVARIABLE ?*FTaskType*)
   (store TASKDIFFICULTFUZZYVARIABLE ?*FTaskDifficult*)
   (store TRUSTLEVELFUZZYVARIABLE ?*FTrustLevel*)
)

(defrule low_creativity_high_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_low_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_driver_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW DRIVER AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_driver_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW DRIVER AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_driver_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (drive ?dr&:(fuzzy-match ?dr "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW DRIVER AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_high_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_low_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_influence_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW EXPRESSIVE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_influence_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW EXPRESSIVE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_influence_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (influence ?inf&:(fuzzy-match ?inf "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW EXPRESSIVE AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_high_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_low_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_stainess_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW AMIABLE AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_stainess_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW AMIABLE AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_stainess_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (stainess ?stss&:(fuzzy-match ?stss "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW AMIABLE AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_high_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH HIGH ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_high_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH HIGH ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_high_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH HIGH ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_medium_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_medium_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_medium_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH MEDIUM ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)


(defrule low_creativity_low_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule low_creativity_low_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "low"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW CREATIVITY WITH LOW ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule medium_creativity_low_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "medium"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM CREATIVITY WITH LOW ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_compliance_high_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "high"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW ANALYTICAL AND MAKING HIGH SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_compliance_medium_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "medium"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW ANALYTICAL AND MAKING MEDIUM SPECIALISED TASK; ")
  )
)

(defrule high_creativity_low_compliance_low_specialised_task
  (and (creativity ?c&:(fuzzy-match ?c "high"))
       (tasktype ?tstp&:(fuzzy-match ?tstp "low"))
       (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH CREATIVITY WITH LOW ANALYTICAL AND MAKING LOW SPECIALISED TASK; ")
  )
)

(defrule low_experience_high_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "low"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW EXPERIENCE WITH HIGH DIFFICULT TASK; ")
  )
)

(defrule low_experience_medium_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "low"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW EXPERIENCE WITH MEDIUM DIFFICULT TASK; ")
  )
)

(defrule low_experience_low_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "low"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW EXPERIENCE WITH LOW DIFFICULT TASK; ")
  )
)

(defrule medium_experience_high_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "medium"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM EXPERIENCE WITH HIGH DIFFICULT TASK; ")
  )
)

(defrule medium_experience_medium_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "medium"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM EXPERIENCE WITH MEDIUM DIFFICULT TASK; ")
  )
)

(defrule medium_experience_low_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "medium"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM EXPERIENCE WITH LOW DIFFICULT TASK; ")
  )
)

(defrule high_experience_high_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "high"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "high"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH EXPERIENCE WITH HIGH DIFFICULT TASK; ")
  )
)

(defrule high_experience_medium_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "high"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "medium"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH EXPERIENCE WITH MEDIUM DIFFICULT TASK; ")
  )
)

(defrule high_experience_low_difficult_task
  (and (experience ?e&:(fuzzy-match ?e "high"))
       (taskdifficult ?tsdiff&:(fuzzy-match ?tsdiff "low"))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH EXPERIENCE WITH LOW DIFFICULT TASK; ")
  )
)

(defrule desire_low
  (desire ?d&:(fuzzy-match ?d "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW DESIRE; ")
  )
)

(defrule desire_medium
  (desire ?d&:(fuzzy-match ?d "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM DESIRE; ")
  )
)

(defrule desire_high
  (desire ?d&:(fuzzy-match ?d "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH DESIRE; ")
  )
)

(defrule interest_low
  (interest ?i&:(fuzzy-match ?i "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW INTEREST; ")
  )
)

(defrule interest_medium
  (interest ?i&:(fuzzy-match ?i "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM INTEREST; ")
  )
)

(defrule interest_high
  (interest ?i&:(fuzzy-match ?i "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH INTEREST; ")
  )
)

(defrule disgust_low
  (disgust ?di&:(fuzzy-match ?di "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW DISGUST; ")
  )
)

(defrule disgust_medium
  (disgust ?di&:(fuzzy-match ?di "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM DISGUST; ")
  )
)

(defrule disgust_high
  (disgust ?di&:(fuzzy-match ?di "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH DISGUST; ")
  )
)

(defrule anxiety_low
  (anxiety ?a&:(fuzzy-match ?a "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW ANXIETY; ")
  )
)
(defrule anxiety_medium
  (anxiety ?a&:(fuzzy-match ?a "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM ANXIETY; ")
  )
)

(defrule anxiety_high
  (anxiety ?a&:(fuzzy-match ?a "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH ANXIETY; ")
  )
)

(defrule stress_low
  (stress ?s&:(fuzzy-match ?s "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW STRESS; ")
  )
)

(defrule stress_medium
  (stress ?s&:(fuzzy-match ?s "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM STRESS; ")
  )
)

(defrule stress_high
  (stress ?s&:(fuzzy-match ?s "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH STRESS; ")
  )
)

(defrule drive_low
  (drive ?dr&:(fuzzy-match ?dr "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW DRIVER; ")
  )
)

(defrule drive_medium
  (drive ?dr&:(fuzzy-match ?dr "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM DRIVER; ")
  )
)

(defrule drive_high
  (drive ?dr&:(fuzzy-match ?dr "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH DRIVER; ")
  )
)

(defrule influence_low
  (influence ?inf&:(fuzzy-match ?inf "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW EXPRESSIVE; ")
  )
)

(defrule influence_medium
  (influence ?inf&:(fuzzy-match ?inf "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM EXPRESSIVE; ")
  )
)

(defrule influence_high
  (influence ?inf&:(fuzzy-match ?inf "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH EXPRESSIVE; ")
  )
)

(defrule stainess_low
  (stainess ?stss&:(fuzzy-match ?stss "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Decrease"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW AMIABLE; ")
  )
)

(defrule stainess_medium
  (stainess ?stss&:(fuzzy-match ?stss "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Normal"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM AMIABLE; ")
  )
)

(defrule stainess_high
  (stainess ?stss&:(fuzzy-match ?stss "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "High_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH AMIABLE; ")
  )
)

(defrule compliance_low
  (compliance ?cmpl&:(fuzzy-match ?cmpl "low"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Decrease"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Medium_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Decrease"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW ANALYTICAL; ")
  )
)

(defrule compliance_medium
  (compliance ?cmpl&:(fuzzy-match ?cmpl "medium"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Normal"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Normal"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "Medium_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM ANALYTICAL; ")
  )
)

(defrule compliance_high
  (compliance ?cmpl&:(fuzzy-match ?cmpl "high"))
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Increase"))
          (change_goals_achievement (new FuzzyValue ?*ChangeGoalsAchievement* "High_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
          (change_individual_contribution (new FuzzyValue ?*ChangeIndividualContribution* "Medium_Increase"))
          (change_required_supervision (new FuzzyValue ?*ChangeRequiredSupervision* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH ANALYTICAL; ")
  )
)

(defrule trust_level_low
  (and (trustlevel ?trstlvl&:(fuzzy-match ?trstlvl "low"))
       (includetrust ?incldtrst&:(= ?incldtrst 1))
  ) 
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "High_Delay"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "High_Decrease"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Decrease"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " LOW TRUST LEVEL; ")
  )
)

(defrule trust_level_medium
  (and (trustlevel ?trstlvl&:(fuzzy-match ?trstlvl "medium"))
       (includetrust ?incldtrst&:(= ?incldtrst 1))
  )   
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Normal"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Normal"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "Medium_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " MEDIUM TRUST LEVEL; ")
  )
)

(defrule trust_level_high
  (and (trustlevel ?trstlvl&:(fuzzy-match ?trstlvl "high"))
       (includetrust ?incldtrst&:(= ?incldtrst 1))
  )
 =>
  (assert (change_task_days (new FuzzyValue ?*ChangeTaskDays* "Medium_Advance"))
          (change_task_quality (new FuzzyValue ?*ChangeTaskQuality* "Medium_Increase"))
          (change_team_collaboration (new FuzzyValue ?*ChangeTeamCollaboration* "High_Increase"))
  )
  (bind ?*rulesThatFired* (str-cat ?*rulesThatFired*
        " HIGH TRUST LEVEL; ")
  )
)



(defrule defuzzify "low salience to allow all rules to fire and do global contribution"
  (declare (salience -100))
  (change_task_days ?chd)
  (change_task_quality ?chq)
  (change_goals_achievement ?chga)
  (change_team_collaboration ?chtc)
  (change_individual_contribution ?chic)
  (change_required_supervision ?chrs)

 =>
  (bind ?final-days (?chd momentDefuzzify))
  (bind ?final-quality (?chq momentDefuzzify))
  (bind ?final-goals (?chga momentDefuzzify))
  (bind ?final-collaboration (?chtc momentDefuzzify))
  (bind ?final-contribution (?chic momentDefuzzify))
  (bind ?final-supervision (?chrs momentDefuzzify))
  (store DIASPARALATAREA ?final-days)
  (store CALIDADTOTAL ?final-quality)
  (store METASALCANZADAS ?final-goals)
  (store COLABORACIONEQUIPO ?final-collaboration)
  (store CONTRIBUCIONINDIVIDUAL ?final-contribution)
  (store SUPERVISIONREQUERIDA ?final-supervision)
  (store RULESTHATFIRED ?*rulesThatFired*)
)
